*******************************;
* Program to combine datasets *;
*******************************;

   %macro mergeit(mydsn);

      %let err_msg = NONE;

      **************************;
      * check for coga or irpg *;
      **************************;

         %let study=%cogairpg(&mydsn.);
         %if &study.=dk %then %do;
            %let err_msg=%str(ERROR: Cannot tell if &dsn. is COGA or IRPG.);
            %goto errexit;
         %end;

      ***************;
      * select list *;
      ***************;

         %if &study.=coga %then %do;
            %let list=dep3r man3r dys3r
                      add3r cd3r odd3r 
                      alc3r can3r drg3r
                      ovx3r sep3r pan3r soc3r ocd3r
                      anx3r bul3r som3r psy3r
                      depd4 mand4 dysd4
                      addd4 cdd4 oddd4 
                      alcd4 cand4 drgd4 tobd4
                      gadd4 sepd4 pand4 socd4 ocdd4
                      anxd4 buld4 somd4
                      depic 
                      addic cdic oddic
                      alcic canic drgic
                      gadic sepic panic socic ocdic
                      alcfn;
         %end;
         %else %if &study.=irpg %then %do;
            %let list=dep3r 
                      add3r cd3r odd3r 
                      alc3r can3r drg3r
                      depd4 
                      addd4 cdd4 oddd4 
                      alcd4 cand4 drgd4 tobd4
                      depic 
                      addic cdic oddic
                      alcic canic drgic
                      alcfn;
         %end;

      ******************;
      * merge datasets *;
      ******************;

         %let nlist=%utlwrds(&list.);

         %do i=1 %to &nlist.;

            %let word=%scan(&list.,&i.);

            proc sort data=&word. nodupkey;
            by ind_id;
            run;

         %end;

         data &mydsn.;
         merge &list.;
         by ind_id;
         run;

      ******************;
      * emergency exit *;
      ******************;

         %errexit:
            %if &err_msg ne NONE %then %do;
               %put &err_msg;
            %end;

   %mend mergeit;
