***** calc.sas ***** (3/27/95);
    *** reference to al25a_1-al25a_9 removed (NSR in consultation with DR;
* C-SSAGA DSM-III-R: Psychoactive Substance (Alcohol) Use Disorder *;

** Alcohol Dependence **;

*** Alc Criterion A ***;

**** Alc screener 1 ****;
if al4c ge 7 | (1 le al4d le 4) then #alscr1=1;
else if al2=1 | (0 le al4c le 6) | al4d=0 then #alscr1=0;

#al3ra1=1;  **** symptom group 1 ****;
if al21b=5 | al22b=5 then #al3ra1=5;
else if al21a=9 | al21b=9 | al22a=9 | al22b=9 then #al3ra1=.;

#al3ra2=1;  **** symptom group 2 ****;
if al20c=5 | al20b=5 then #al3ra2=5;
else if al20a=9 | al20b=9 | al20c=9 then #al3ra2=.;

#al3ra3=1;  **** symptom group 3 ****;
if al28=5 then #al3ra3=5;
else if al28=9 then #al3ra3=.;

#al3ra4=1;  **** symptom group 4 ****;
if al14d=5 | al15b=5 | al16=5 | al26b=5 | al27b=5 then #al3ra4=5;
else if al14c=9 | al14d=9 | al15a=9 | al15b=9 | al16=9 | al26a=9 |
 al26b=9 | al27a=9 | al27b=9 then #al3ra4=.;

#al3ra5=1;  **** symptom group 5 ****;
if al18=5 then #al3ra5=5;
else if al18=9 then #al3ra5=.;

#al3ra6=1;  **** symptom group 6 ****;
if al10g=5 | al13e=5 | al14b=5 then #al3ra6=5;
else if al10g=9 | al10f=9 | (al10f=. & (al10a=9 | al10c=9 |
 al10d=9 | al10e=9)) | al13e=9 | al13d=9 | (al13d=. & ( al13a=9 | al13b=9
 | al13c=9)) | al14a=9 | al14b=9 then #al3ra6=.;

#al3ra7=1;  **** symptom group 7 ****;
if al19a=5 | al19b=5 then #al3ra7=5;
else if al19a=9 | al19b=9 then #al3ra7=.;

#al3ra8=1;  **** symptom group 8 ****;
if al25b=5 then #al3ra8=5;
else if al25b=9 | (al25b=. & ((al24a_1=9)+(al24a_2=9)+(al24a_3=9)+(al24a_4=9)
 +(al24a_5=9)+(al24a_6=9)+(al24a_7=9)+(al24a_8=9)+(al24a_9=9)+(al24a_10=9)) ge 2)
  then #al3ra8=.;

#al3ra9=1; **** symptom group 9 ****;
if al24b_1=5 | al24b_2=5 | al24b_3=5 | al24b_4=5 | al24b_5=5 | al24b_6=5 |
 al24b_7=5 | al24b_8=5 | al24b_9=5 | al24b_10=5 then #al3ra9=5;
else if al24b_1=9 | al24b_2=9 | al24b_3=9 | al24b_4=9 | al24b_5=9 | al24b_6=9
 | al24b_7=9 | al24b_8=9 | al24b_9=9 | al24b_10=9
 | al24a_1=9 | al24a_2=9 | al24a_3=9 | al24a_4=9 | al24a_5=9 | al24a_6=9
 | al24a_7=9 | al24a_8=9 | al24a_9=9 | al24a_10=9 then #al3ra9=.;

array ryala #al3ra1-#al3ra9;
if #alscr1=. then do over ryala;
 ryala=.;
end;

#al3rasx=0; #al3ramx=0;  **** symptom group counts ****;
do over ryala;
 if ryala=5 then #al3rasx+1;
 else if ryala=. then #al3ramx+1;
end;

#al3ra=1;  *** Criterion A ***;
if #al3rasx ge 3 then #al3ra=5;
else if #al3rasx+#al3ramx ge 3 then #al3ra=.;

*** Alc Criterion B ***;

#al3rb=1;
if al30b=5 then #al3rb=5;
else if al30b=9 | #al3ramx ge 1 then #al3rb=.;

** Alcohol Dependence Diagnosis **;

#al3rde=1;
if #al3ra=5 & #al3rb=5 then #al3rde=5;
else if #al3ra=. | (#al3ra ne 1 & #al3rb=.) then #al3rde=.;

** Alcohol Abuse **;

*** Alc Criterion A ***;

#al3raa1=#al3ra6;  **** symptom group 1 ****;

#al3raa2=1;  **** symptom group 2 ****;
if al14d=5 | al26b=5 | al27b=5 then #al3raa2=5;
else if al14c=9 | al14d=9 | al26a=9 | al26b=9 | al27a=9 | al27b=9 then
  #al3raa2=.;

if #alscr1=. then do;
 #al3raa1=.; #al3raa2=.;
end;

#al3raa=1;  *** Criterion A ***;
if #al3raa1=5 | #al3raa2=5 then #al3raa=5;
else if #al3raa1=. | #al3raa2=. then #al3raa=.;

*** Alc Criterion B ***;

#al3rba=1;
if al30b=5 then #al3rba=5;
else if al30b=9 | (#al3raa1=. | #al3raa2=.) then #al3rba=.;

*** Alc Criterion C ***;

#al3rca=1;
if #al3rde=1 then #al3rca=5;
else if #al3rde=. then #al3rca=.;

** Alcohol Abuse Diagnosis **;

#al3rab=1;
if #al3raa=5 & #al3rba=5 & #al3rca=5 then #al3rab=5;
else if #al3raa=. | (#al3raa ne 1 & #al3rca=.) | (#al3raa ne 1 & #al3rca ne 1
 & #al3rba=.) then #al3rab=.;

label #al3ra='Alcohol Dependence - Criterion A'
      #al3rb='Alcohol Dependence - Criterion B'
      #al3rde='Alcohol Dependence Diagnosis'
      #al3raa='Alcohol Abuse - Criterion A'
      #al3rba='Alcohol Abuse - Criterion B'
      #al3rca='Alcohol Abuse - Criterion C'
      #al3rab='Alcohol Abuse - Diagnosis'
;
