***** cadh.sas ***** (3/27/95) ;

* C-SSAGA DSM-III-R: Attention Deficit-Hyperactivity Disorder *;

** ADHD Criterion A **;

array ryada at1_1 at2_1 at3_1 at4_1 at5_1 at6_1 at8_1 at9_1 at10_1 at11_1
 at12_1 at13_1 at14_1;
array ryadb #at3ra1-#at3ra6 #at3ra8-#at3ra14;

do over ryada;  *** symptom groups 1-6,8-14 ***;
 ryadb=1;
 if ryada=5 then ryadb=5;
 else if ryada=9 then ryadb=.;
end;

#at3ra7=1;  *** symptom group 7 ***;
if at7a_1=5 | at7b_1=5 then #at3ra7=5;
else if at7a_1=9 | at7b_1=9 then #at3ra7=.;

*** ADHD screener 1 ***;
if #at3ra1=5 | #at3ra2=5 | #at3ra3=5 | #at3ra4=5 | #at3ra5=5 | #at3ra6=5 |
 #at3ra7=5 | #at3ra8=5 then #atscr1=1;
else if #at3ra1=1 & #at3ra2=1 & #at3ra3=1 & #at3ra4=1 & #at3ra5=1 &
 #at3ra6=1 & #at3ra7=1 & #at3ra8=1 then #atscr1=0;

if #atscr1=. then do;
 #at3ra9=.; #at3ra10=.; #at3ra11=.; #at3ra12=.; #at3ra13=.; #at3ra14=.;
end;

#at3rasx=0; #at3ramx=0;  *** symptom group counts ***;
array ryadc #at3ra1-#at3ra14;
do over ryadc;
 if ryadc=5 then #at3rasx+1;
 else if ryadc=. then #at3ramx+1;
end;

**Diagnosis without duration or clustering
    - just symptom count**;
#at3ract=1;  *** 8+ symptom groups ***;
if #at3rasx ge 8 then #at3ract=5;
else if #at3rasx+#at3ramx ge 8 then #at3ract=.;

#atscr2=0;  *** ADHD screener 2 ***;
if #at3rasx ge 4 then #atscr2=1;
else if #at3rasx+#at3ramx ge 4 then #atscr2=.;

#at3ra=1;  ** Criterion A **;
if #at3ract=5 & at15d=5 & at15e=5 then #at3ra=5;
else if #at3ract=. | (at15d=. & #atscr2=1 & #at3ract ne 1 & at15e ne 1) | (at15e=.
 & #atscr2=1 & #at3ract ne 1 & at15d ne 1) then #at3ra=.;

** ADHD Criterion B **;

#at3rb=1;  ** Criterion B **;
if 1 le at15a le 6 then #at3rb=5;
else if at15a=-9 | (at15a=. & #atscr2=1) then #at3rb=.;

** ADHD Criterion C not assessed **;

* ADHD Diagnosis *;

#at3r=1;
if #at3ra=5 & #at3rb=5 then #at3r=5;
else if #at3ra=. | (#at3rb=. & #at3ra ne 1) then #at3r=.;

label #at3ract='ADHD - Diag w/ 8+symptoms'
      #at3ra='ADHD - Criterion A'
      #at3rb='ADHD - Criterion B'
      #at3r='ADHD Diagnosis'
;
keep  #at3ract #at3ra #at3rb #at3r;
;
***** calc.sas ***** (3/27/95);

* C-SSAGA DSM-III-R: Psychoactive Substance (Alcohol) Use Disorder *;

** Alcohol Dependence **;

*** Alc Criterion A ***;

**** Alc screener 1 ****;
if al4c ge 7 | (1 le al4d le 4) then #alscr1=1;
else if al2=1 | (0 le al4c le 6) | al4d=0 then #alscr1=0;

#al3ra1=1;  **** symptom group 1 ****;
if al21b=5 | al22b=5 then #al3ra1=5;
else if al21a=9 | al21b=9 | al22a=9 | al22b=9 then #al3ra1=.;

#al3ra2=1;  **** symptom group 2 ****;
if al20c=5 | al20b=5 then #al3ra2=5;
else if al20a=9 | al20b=9 | al20c=9 then #al3ra2=.;

#al3ra3=1;  **** symptom group 3 ****;
if al28=5 then #al3ra3=5;
else if al28=9 then #al3ra3=.;

#al3ra4=1;  **** symptom group 4 ****;
if al14d=5 | al15b=5 | al16=5 | al26b=5 | al27b=5 then #al3ra4=5;
else if al14c=9 | al14d=9 | al15a=9 | al15b=9 | al16=9 | al26a=9 |
 al26b=9 | al27a=9 | al27b=9 then #al3ra4=.;

#al3ra5=1;  **** symptom group 5 ****;
if al18=5 then #al3ra5=5;
else if al18=9 then #al3ra5=.;

#al3ra6=1;  **** symptom group 6 ****;
if al10g=5 | al13e=5 | al14b=5 then #al3ra6=5;
else if al10g=9 | al10f=9 | (al10f=. & (al10a=9 | al10c=9 |
 al10d=9 | al10e=9)) | al13e=9 | al13d=9 | (al13d=. & ( al13a=9 | al13b=9
 | al13c=9)) | al14a=9 | al14b=9 then #al3ra6=.;

#al3ra7=1;  **** symptom group 7 ****;
if al19a=5 | al19b=5 then #al3ra7=5;
else if al19a=9 | al19b=9 then #al3ra7=.;

#al3ra8=1;  **** symptom group 8 ****;
if al25b=5 then #al3ra8=5;
else if al25b=9 | (al25b=. & ((al24a_1=9)+(al24a_2=9)+(al24a_3=9)+(al24a_4=9)
 +(al24a_5=9)+(al24a_6=9)+(al24a_7=9)+(al24a_8=9)+(al24a_9=9)+(al24a_10=9)) ge 2)
 | al25a_1=9 | (al25a_1 ne 1 & (al25a_2=9 | al25a_3=9 | al25a_4=9 |
 al25a_5=9 | al25a_6=9 | al25a_7=9 | al25a_8=9 | al25a_9=9)) then #al3ra8=.;

#al3ra9=1; **** symptom group 9 ****;
if al24b_1=5 | al24b_2=5 | al24b_3=5 | al24b_4=5 | al24b_5=5 | al24b_6=5 |
 al24b_7=5 | al24b_8=5 | al24b_9=5 | al24b_10=5 then #al3ra9=5;
else if al24b_1=9 | al24b_2=9 | al24b_3=9 | al24b_4=9 | al24b_5=9 | al24b_6=9
 | al24b_7=9 | al24b_8=9 | al24b_9=9 | al24b_10=9
 | al24a_1=9 | al24a_2=9 | al24a_3=9 | al24a_4=9 | al24a_5=9 | al24a_6=9
 | al24a_7=9 | al24a_8=9 | al24a_9=9 | al24a_10=9 then #al3ra9=.;

array ryala #al3ra1-#al3ra9;
if #alscr1=. then do over ryala;
 ryala=.;
end;

#al3rasx=0; #al3ramx=0;  **** symptom group counts ****;
do over ryala;
 if ryala=5 then #al3rasx+1;
 else if ryala=. then #al3ramx+1;
end;

#al3ra=1;  *** Criterion A ***;
if #al3rasx ge 3 then #al3ra=5;
else if #al3rasx+#al3ramx ge 3 then #al3ra=.;

*** Alc Criterion B ***;

#al3rb=1;
if al30b=5 then #al3rb=5;
else if al30b=9 | #al3ramx ge 1 then #al3rb=.;

** Alcohol Dependence Diagnosis **;

#al3rde=1;
if #al3ra=5 & #al3rb=5 then #al3rde=5;
else if #al3ra=. | (#al3ra ne 1 & #al3rb=.) then #al3rde=.;

** Alcohol Abuse **;

*** Alc Criterion A ***;

#al3raa1=#al3ra6;  **** symptom group 1 ****;

#al3raa2=1;  **** symptom group 2 ****;
if al14d=5 | al26b=5 | al27b=5 then #al3raa2=5;
else if al14c=9 | al14d=9 | al26a=9 | al26b=9 | al27a=9 | al27b=9 then
  #al3raa2=.;

if #alscr1=. then do;
 #al3raa1=.; #al3raa2=.;
end;

#al3raa=1;  *** Criterion A ***;
if #al3raa1=5 | #al3raa2=5 then #al3raa=5;
else if #al3raa1=. | #al3raa2=. then #al3raa=.;

*** Alc Criterion B ***;

#al3rba=1;
if al30b=5 then #al3rba=5;
else if al30b=9 | (#al3raa1=. | #al3raa2=.) then #al3rba=.;

*** Alc Criterion C ***;

#al3rca=1;
if #al3rde=1 then #al3rca=5;
else if #al3rde=. then #al3rca=.;

** Alcohol Abuse Diagnosis **;

#al3rab=1;
if #al3raa=5 & #al3rba=5 & #al3rca=5 then #al3rab=5;
else if #al3raa=. | (#al3raa ne 1 & #al3rca=.) | (#al3raa ne 1 & #al3rca ne 1
 & #al3rba=.) then #al3rab=.;

label #al3ra='Alcohol Dependence - Criterion A'
      #al3rb='Alcohol Dependence - Criterion B'
      #al3rde='Alcohol Dependence Diagnosis'
      #al3raa='Alcohol Abuse - Criterion A'
      #al3rba='Alcohol Abuse - Criterion B'
      #al3rca='Alcohol Abuse - Criterion C'
      #al3rab='Alcohol Abuse - Diagnosis'
keep  #al3ra #al3rb #al3rde #al3raa #al3rba
      #al3rca #al3rab;
;
***** canr.sas ***** (3/27/95);

* C-SSAGA DSM-III-R: Anorexia Nervosa Eating Disorder *;

** AN Criterion A **;

#an3ra=1;
if an3c_3=5 then #an3ra=5;
else if an1=9 | an3c_3=9 then #an3ra=.;

** AN Criterion B **;

#an3rb=1;
if an4=5 | an5=5 then #an3rb=5;
else if an4=3 | an5=3 then #an3rb=3;
else if an1=9 | an4=9 | an5=9 then #an3rb=.;

** AN Criterion C **;

#an3rc=an2;
if an1=9 | an2=9 then #an3rc=.;

** AN Criterion D **;

#an3rd=.N;
if dm1=2 & dm3 ge 9 then do;
 #an3rd=1;
 if an9=5 then #an3rd=5;
 else if an1=9 | an8=9 | an9=9 then #an3rd=.;
end;

* Anorexia Nervosa Diagnosis *;

#an3r=1;
if dm1=1 | dm3 le 8 then do;
 if #an3ra=5 & #an3rb=5 & #an3rc=5 then #an3r=5;
 else if #an3ra=5 & #an3rb ge 3 & #an3rc ge 3 then #an3r=3;
 else if #an3ra=. |(( #an3rb=. | #an3rc=.)& #an3ra ne 1) then #an3r=.;
end;
else if dm1=2 & dm3 ge 9 then do;
 if #an3ra=5 & #an3rb=5 & #an3rc=5 & #an3rd=5 then #an3r=5;
 else if #an3ra=5 & #an3rb ge 3 & #an3rc ge 3 & #an3rd=5 then #an3r=3;
 else if #an3ra=. |(( #an3rb=. | #an3rc=. | #an3rd=.)& #an3ra ne 1) then #an3r=.;
end;

label #an3ra='Anorexia - Criterion A'
      #an3rb='Anorexia - Criterion B'
      #an3rc='Anorexia - Criterion C'
      #an3rd='Anorexia - Criterion D'
      #an3r='Anorexia - Diagnosis'
;
keep  #an3ra #an3rb #an3rc #an3r #an3r;
***** cbul.sas ***** (3/27/95);

* C-SSAGA DSM-III-R: Bulimia Nervosa Eating Disorder *;

** Bul Criterion A **;

#bu3ra=1;
if bu2a=5 | bu2b=5 then #bu3ra=5;
else if bu2a=3 then #bu3ra=3;
else if bu1a=9 | bu2b=9 then #bu3ra=.;

** Bul Criterion B **;

#bu3rb=bu7;
if #bu3ra=1 then #bu3rb=1;
else if #bu3ra=. | bu7=9 then #bu3rb=.;

** Bul Criterion C **;

#bu3rc=1;
if bu5=5 | bu6=5 then #bu3rc=5;
else if bu5=3 | bu6=3 then #bu3rc=3;
else if #bu3ra=. | bu5=9 | bu6=9 then #bu3rc=.;

** Bul Criterion D **;

#bu3rd=1;
if bu3=5 then #bu3rd=5;
else if #bu3ra=. | bu3=9 then #bu3rd=.;

** Bul Criterion E **;

#bu3re=1;
if bu4a=5 | bu4b=5 then #bu3re=5;
else if bu4a=3 | bu4b=3 then #bu3re=3;
else if #bu3ra=. | bu4a=9 | bu4b=9 then #bu3re=.;

* Bulimia Nervosa Diagnosis *;

#bu3r=1;
if #bu3ra=5 & #bu3rb=5 & #bu3rc=5 & #bu3rd=5 & #bu3re=5 then #bu3r=5;
else if #bu3ra ge 3 & #bu3rb ge 3 & #bu3rc ge 3 & #bu3rd=5 & #bu3re ge 3
 then #bu3r=3;
else if #bu3ra=. | ((#bu3rb=. | #bu3rc=. | #bu3rd=. | #bu3re=.) & #bu3ra ne 1) then #bu3r=.;

label #bu3ra='Bulimia - Criterion A'
      #bu3rb='Bulimia - Criterion B'
      #bu3rc='Bulimia - Criterion C'
      #bu3rd='Bulimia - Criterion D'
      #bu3re='Bulimia - Criterion E'
      #bu3r='Bulimia Diagnosis'
;
keep  #bu3ra #bu3rb #bu3rc #bu3rd #bu3re #bu3r;
***3/27/95 (rev)***;

***** cdrg.sas ***** (3/27/95);

* C-SSAGA DSM-III-R: Psychoactive Substance (Street Drugs) Use Disorder *;

** Street Drugs Dependence **;

*** SD Criterion A ***;

**** SD screener 0 ****;
if sd1_1=5 | sd1_2=5 | sd1_3=5 | sd1_4=5 | sd1_5=5 | sd1_6=5 | sd2=5 | sd3=5
 | sd4=5 then #sdscr0=1;
else if sd1_1=1 & sd1_2=1 & sd1_3=1 & sd1_4=1 & sd1_5=1 & sd1_6=1 | sd2=1 |
 sd3=1 | sd4=1 then #sdscr0=0;

array sd6a_(6) sd6a_1-sd6a_6;
array sd6b_(6) sd6b_1-sd6b_6;
array sdscr(6) #sdscr1-#sdscr6;

array sda1_9(6,9) #sd3ra11-#sd3ra19 #sd3ra21-#sd3ra29 #sd3ra31-#sd3ra39
                   #sd3ra41-#sd3ra49 #sd3ra51-#sd3ra59 #sd3ra61-#sd3ra69;
array sds(6) #sd3rsx1-#sd3rsx6;
array sdm(6) #sd3rmx1-#sd3rmx6;
array sda(6) #sd3ra1-#sd3ra6;
array sdb(6) #sd3rb1-#sd3rb6;
array sdde(6) #sd3rde1-#sd3rde6;

array sdaa1(6) #sd3aa11 #sd3aa21 #sd3aa31 #sd3aa41 #sd3aa51 #sd3aa61;
array sdaa2(6) #sd3aa12 #sd3aa22 #sd3aa32 #sd3aa42 #sd3aa52 #sd3aa62;
array sdaa(6) #sd3raa1-#sd3raa6;
array sdba(6) #sd3rba1-#sd3rba6;
array sdca(6) #sd3rca1-#sd3rca6;
array sdab(6) #sd3rab1-#sd3rab6;

array sd12a_(6) sd12a_1-sd12a_6;
array sd12b_(6) sd12b_1-sd12b_6;
array sd13a_(6) sd13a_1-sd13a_6;
array sd13b_(6) sd13b_1-sd13b_6;
array sd9a_(6) sd9a_1-sd9a_6;
array sd9b_(6) sd9b_1-sd9b_6;
array sd9c_(6) sd9c_1-sd9c_6;
array sd11_(6) sd11_1-sd11_6;
array sd14a_(6) sd14a_1-sd14a_6;
array sd14b_(6) sd14b_1-sd14b_6;
array sd15_(6) sd15_1-sd15_6;
array sd16a_(6) sd16a_1-sd16a_6;
array sd16b_(6) sd16b_1-sd16b_6;
array sd17a_(6) sd17a_1-sd17a_6;
array sd17b_(6) sd17b_1-sd17b_6;
array sd10_(6) sd10_1-sd10_6;
array sd18a_(6) sd18a_1-sd18a_6;
array sd18b_(6) sd18b_1-sd18b_6;
array sd18c_(6) sd18c_1-sd18c_6;
array sd18d_(6) sd18d_1-sd18d_6;
array sd18e_(6) sd18e_1-sd18e_6;
array sd20a_(6) sd20a_1-sd20a_6;
array sd20b_(6) sd20b_1-sd20b_6;
array sd20c_(6) sd20c_1-sd20c_6;
array sd20d_(6) sd20d_1-sd20d_6;
array sd20e_(6) sd20e_1-sd20e_6;
array sd20f_(6) sd20f_1-sd20f_6;
array sd21_(6) sd21_1-sd21_6;
array sd8a_(6) sd8a_1-sd8a_6;
array sd8b_(6) sd8b_1-sd8b_6;
array sd22_(16,6) sd22a_1-sd22a_6 sd22b_1-sd22b_6 sd22c_1-sd22c_6
 sd22d_1-sd22d_6 sd22e_1-sd22e_6 sd22f_1-sd22f_6 sd22g_1-sd22g_6
 sd22h_1-sd22h_6 sd22i_1-sd22i_6 sd22j_1-sd22j_6 sd22k_1-sd22k_6
 sd22l_1-sd22l_6 sd22m_1-sd22m_6 sd22n_1-sd22n_6 sd22o_1-sd22o_6
 sd22p_1-sd22p_6;
array sd23_(6) sd23_1-sd23_6;
array sd24_(6) sd24_1-sd24_6;

do i=1 to 6;

 **** SD screener 1-6 ****;
 if sd6a_(i) ge 7 | (1 le sd6b_(i) le 4) then sdscr(i)=1;
 else if #sdscr0=0 | (0 le sd6a_(i) le 6) | sd6b_(i)=0 then sdscr(i)=0;

 sda1_9(i,1)=1;  **** symptom group 1 ****;
 if sd12b_(i)=5 | sd13b_(i)=5 then sda1_9(i,1)=5;
 else if sd12a_(i)=9 | sd12b_(i)=9 | sd13a_(i)=9 | sd13b_(i)=9 then
  sda1_9(i,1)=.;

 sda1_9(i,2)=1;  **** symptom group 2 ****;
 if sd9c_(i)=5 | sd9b_(i)=5 then sda1_9(i,2)=5;
 else if sd9a_(i)=9 | sd9b_(i)=9 | sd9c_(i)=9 then sda1_9(i,2)=.;

 sda1_9(i,3)=1;  **** symptom group 3 ****;
 if sd11_(i)=5 then sda1_9(i,3)=5;
 else if sd11_(i)=9 then sda1_9(i,3)=.;

 sda1_9(i,4)=1;  **** symptom group 4 ****;
 if sd14b_(i)=5 | sd15_(i)=5 | sd16b_(i)=5 | sd17b_(i)=5 then sda1_9(i,4)=5;
 else if sd14a_(i)=9 | sd14b_(i)=9 | sd15_(i)=9 | sd16a_(i)=9 | sd16b_(i)=9 |
  sd17a_(i)=9 | sd17b_(i)=9 then sda1_9(i,4)=.;

 sda1_9(i,5)=1;  **** symptom group 5 ****;
 if sd10_(i)=5 then sda1_9(i,5)=5;
 else if sd10_(i)=9 then sda1_9(i,5)=.;

 sda1_9(i,6)=1;  **** symptom group 6 ****;
 if sd18e_(i)=5 | sd20f_(i)=5 | sd21_(i)=5 then sda1_9(i,6)=5;
 else if sd18e_(i)=9 | sd18d_(i)=9 | (sd18d_(i)=. & (sd18a_(i)=9 | sd18b_(i)=9
  | sd18c_(i)=9)) | sd20f_(i)=9 | sd20e_(i)=9 | (sd20e_(i)=. & (sd20a_(i)=9 |
  sd20b_(i)=9 | sd20c_(i)=9 | sd20d_(i)=9)) | sd21_(i)=9 then sda1_9(i,6)=.;

 sda1_9(i,7)=1;  **** symptom group 7 ****;
 if sd8a_(i)=5 | sd8b_(i)=5 then sda1_9(i,7)=5;
 else if sd8a_(i)=9 | sd8b_(i)=9 then sda1_9(i,7)=.;

 sd24_9s=0;
 do j=1 to 16;
  if sd22_(j,i)=9 then sd24_9s+1;
 end;

 sda1_9(i,8)=1;  **** symptom group 8 ****;
 if sd24_(i)=5 then sda1_9(i,8)=5;
 else if sd24_(i)=9 | (sd24_(i)=. & sd24_9s ge 2) then sda1_9(i,8)=.;

 sda1_9(i,9)=1;  **** symptom group 9 ****;
 if sd23_(i)=5 then sda1_9(i,9)=5;
 else if sd23_(i)=9 | sd22_(1,i)=9 | sd22_(2,i)=9 | sd22_(3,i)=9 | sd22_(4,i)=9
  | sd22_(5,i)=9 | sd22_(6,i)=9 | sd22_(7,i)=9 | sd22_(8,i)=9 | sd22_(9,i)=9
  | sd22_(10,i)=9 | sd22_(11,i)=9 | sd22_(12,i)=9 | sd22_(13,i)=9 | sd22_(14,i)=9
  | sd22_(15,i)=9 | sd22_(16,i)=9 then sda1_9(i,9)=.;

 if #sdscr0=. | sdscr(i)=. then do j=1 to 9;
  sda1_9(i,j)=.;
 end;

 sds(i)=0; sdm(i)=0;  **** symptom group counts ****;
 do j=1 to 9;
  if sda1_9(i,j)=5 then sds(i)+1;
  else if sda1_9(i,j)=. then sdm(i)+1;
 end;

 sda(i)=1;  *** Criterion A ***;
 if sds(i) ge 3 then sda(i)=5;
 else if sds(i)+sdm(i) ge 3 then sda(i)=.;

 *** SD Criterion B ***;

 sdb(i)=1;
 if sd26b=5 then sdb(i)=5;
 else if sd26b=9 | sdm(i) ge 1 then sdb(i)=.;

 ** Street Drugs Dependence Diagnosis **;

 sdde(i)=1;
 if sda(i)=5 & sdb(i)=5 then sdde(i)=5;
 else if sda(i)=. | (sda(i) ne 1 & sdb(i)=.) then sdde(i)=.;

 ** Street Drugs Abuse **;

 *** SD Criterion A ***;

 sdaa1(i)=sda1_9(i,6);  **** symptom group 1 ****;

 sdaa2(i)=1;  **** symptom group 2 ****;
 if sd16b_(i)=5 | sd17b_(i)=5 then sdaa2(i)=5;
 else if sd16a_(i)=9 | sd16b_(i)=9 | sd17a_(i)=9 | sd17b_(i)=9 then sdaa2(i)=.;

 sdaa(i)=1;  *** Criterion A ***;
 if sdaa1(i)=5 | sdaa2(i)=5 then sdaa(i)=5;
 else if sdaa1(i)=. | sdaa2(i)=. then sdaa(i)=.;

 if #sdscr0=. | sdscr(i)=. then do;
  sdaa1(i)=.; sdaa2(i)=.;
 end;

 *** SD Criterion B ***;

 sdba(i)=1;
 if sd26b=5 then sdba(i)=5;
 else if sd26b=9 | (sdaa1(i)=. | sdaa2(i)=.) then sdba(i)=.;

 *** SD Criterion C ***;

 sdca(i)=1;
 if sdde(i)=1 then sdca(i)=5;
 else if sdde(i)=. then sdca(i)=.;

 ** Street Drugs Abuse Diagnosis **;

 sdab(i)=1;
 if sdaa(i)=5 & sdba(i)=5 & sdca(i)=5 then sdab(i)=5;
 else if sdaa(i)=. | (sdaa(i) ne 1 & sdca(i)=.) | (sdaa(i) ne 1 & sdca(i) ne 1
  & sdba(i)=.) then sdab(i)=.;
end;

label #sd3ra1='Street Drugs Dependence Criterion A'
      #sd3ra2='Street Drugs Dependence Criterion A'
      #sd3ra3='Street Drugs Dependence Criterion A'
      #sd3ra4='Street Drugs Dependence Criterion A'
      #sd3ra5='Street Drugs Dependence Criterion A'
      #sd3ra6='Street Drugs Dependence Criterion A'
      #sd3rb1='Street Drugs Dependence Criterion B'
      #sd3rb2='Street Drugs Dependence Criterion B'
      #sd3rb3='Street Drugs Dependence Criterion B'
      #sd3rb4='Street Drugs Dependence Criterion B'
      #sd3rb5='Street Drugs Dependence Criterion B'
      #sd3rb6='Street Drugs Dependence Criterion B'
      #sd3rde1='Street Drugs Dependence Diagnosis'
      #sd3rde2='Street Drugs Dependence Diagnosis'
      #sd3rde3='Street Drugs Dependence Diagnosis'
      #sd3rde4='Street Drugs Dependence Diagnosis'
      #sd3rde5='Street Drugs Dependence Diagnosis'
      #sd3rde6='Street Drugs Dependence Diagnosis'
      #sd3raa1='Street Drugs Abuse Criterion A'
      #sd3raa2='Street Drugs Abuse Criterion A'
      #sd3raa3='Street Drugs Abuse Criterion A'
      #sd3raa4='Street Drugs Abuse Criterion A'
      #sd3raa5='Street Drugs Abuse Criterion A'
      #sd3raa6='Street Drugs Abuse Criterion A'
      #sd3rba1='Street Drugs Abuse Criterion B'
      #sd3rba2='Street Drugs Abuse Criterion B'
      #sd3rba3='Street Drugs Abuse Criterion B'
      #sd3rba4='Street Drugs Abuse Criterion B'
      #sd3rba5='Street Drugs Abuse Criterion B'
      #sd3rba6='Street Drugs Abuse Criterion B'
      #sd3rca1='Street Drugs Abuse Criterion C'
      #sd3rca2='Street Drugs Abuse Criterion C'
      #sd3rca3='Street Drugs Abuse Criterion C'
      #sd3rca4='Street Drugs Abuse Criterion C'
      #sd3rca5='Street Drugs Abuse Criterion C'
      #sd3rca6='Street Drugs Abuse Criterion C'
      #sd3rab1='Street Drugs Abuse Diagnosis'
      #sd3rab2='Street Drugs Abuse Diagnosis'
      #sd3rab3='Street Drugs Abuse Diagnosis'
      #sd3rab4='Street Drugs Abuse Diagnosis'
      #sd3rab5='Street Drugs Abuse Diagnosis'
      #sd3rab6='Street Drugs Abuse Diagnosis'
  ;
keep #sd3ra1-#sd3ra6 #sd3rb1-#sd3rb6 #sd3rde1-#sd3rde6
     #sd3raa1-#sd3raa6 #sd3rba1-#sd3rba6 #sd3rca1-#sd3rca6
     #sd3rab1-#sd3rab6;
***** cmj.sas ***** (3/27/95);

* C-SSAGA DSM-III-R: Psychoactive Substance (Marijuana) Use Disorder *;

** Marijuana Dependence **;

*** Mj Criterion A ***;

**** Mj screener 1 ****;
if mj1e ge 7 | (1 le mj1f le 4) then #mjscr1=1;
else if mj1a=1 | (0 le mj1e le 6) | mj1f=0 then #mjscr1=0;

#mj3ra1=1;  **** symptom group 1 ****;
if mj6b=5 | mj7b=5 then #mj3ra1=5;
else if mj6a=9 | mj6b=9 | mj7a=9 | mj7b=9 then #mj3ra1=.;

#mj3ra2=1;  **** symptom group 2 ****;
if mj8c=5 | mj8b=5 then #mj3ra2=5;
else if mj8a=9 | mj8b=9 | mj8c=9 then #mj3ra2=.;

#mj3ra3=1;  **** symptom group 3 ****;
if mj20=5 then #mj3ra3=5;
else if mj20=9 then #mj3ra3=.;

#mj3ra4=1;  **** symptom group 4 ****;
if mj14b=5 | mj15=5 | mj16b=5 | mj17b=5 then #mj3ra4=5;
else if mj14a=9 | mj14b=9 | mj15=9 | mj16a=9 | mj16b=9 | mj17a=9 | mj17b=9
 then #mj3ra4=.;

#mj3ra5=1;  **** symptom group 5 ****;
if mj9a=5 | mj9b=5 then #mj3ra5=5;
else if mj9a=9 | mj9b=9 then #mj3ra5=.;

#mj3ra6=1;  **** symptom group 6 ****;
if mj10e=5 | mj12f=5 | mj13b=5 then #mj3ra6=5;
else if mj10e=9 | mj10d=9 | (mj10d=. & (mj10a=9 | mj10b=9 | mj10c=9)) |
 mj12f=9 | mj12e=9 | (mj12e=. & (mj12a=9 | mj12b=9 | mj12c=9 | mj12d=9)) |
 mj13a=9 | mj13b=9 then #mj3ra6=.;

#mj3ra7=1;  **** symptom group 7 ****;
if mj4a=5 | mj4b=5 then #mj3ra7=5;
else if mj4a=9 | mj4b=9 then #mj3ra7=.;

#mj3ra8=1;  **** symptom group 8 ****;
if mj19b=5 then #mj3ra8=5;
else if mj19b=9 | (mj19b=. & ((mj18a_1=9)+(mj18a_2=9)+(mj18a_3=9)+(mj18a_4=9)
 +(mj18a_5=9)+(mj18a_6=9)+(mj18a_7=9) ge 2) | ((mj19a_1=9)+(mj19a_2=9)+(mj19a_3=9)
 + (mj19a_4=9)+(mj19a_5=9)+(mj19a_6=9)+(mj19a_7=9) ge 2)) then #mj3ra8=.;

#mj3ra9=1;  **** symptom group 9 ****;
if mj18b_1=5 | mj18b_2=5 | mj18b_3=5 | mj18b_4=5 | mj18b_5=5 | mj18b_6=5 |
 mj18b_7=5 then #mj3ra9=5;
else if mj18b_1=9 | mj18b_2=9 | mj18b_3=9 | mj18b_4=9 | mj18b_5=9 | mj18b_6=9
 | mj18b_7=9 | mj18a_1=9 | mj18a_2=9 | mj18a_3=9 | mj18a_4=9 | mj18a_5=9 |
 mj18a_6=9 | mj18a_7=9 then #mj3ra9=.;

array rymja #mj3ra1-#mj3ra9;
if #mjscr1=. then do over rymja;
 rymja=.;
end;

#mj3rasx=0; #mj3ramx=0;  **** symptom group counts ****;
do over rymja;
 if rymja=5 then #mj3rasx+1;
 else if rymja=. then #mj3ramx+1;
end;

#mj3ra=1;  *** Criterion A ***;
if #mj3rasx ge 3 then #mj3ra=5;
else if #mj3rasx+#mj3ramx ge 3 then #mj3ra=.;

*** Mj Criterion B ***;

#mj3rb=1;
if mj22b=5 then #mj3rb=5;
else if mj22b=9 | #mj3ramx ge 1 then #mj3rb=.;

** Marijuana Dependence Diagnosis **;

#mj3rde=1;
if #mj3ra=5 & #mj3rb=5 then #mj3rde=5;
else if #mj3ra=. | (#mj3ra ne 1 & #mj3rb=.) then #mj3rde=.;

** Marijuana Abuse **;

*** Mj Criterion A ***;

#mj3raa1=#mj3ra6;  **** symptom group 1 ****;

#mj3raa2=1;  **** symptom group 2 ****;
if mj16b=5 | mj17b=5 then #mj3raa2=5;
else if mj16a=9 | mj16b=9 | mj17a=9 | mj17b=9 then #mj3raa2=.;

if #mjscr1=. then do;
 #mj3raa1=.; #mj3raa2=.;
end;

#mj3raa=1;  *** Criterion A ***;
if #mj3raa1=5 | #mj3raa2=5 then #mj3raa=5;
else if #mj3raa1=. | #mj3raa2=. then #mj3raa=.;

*** Mj Criterion B ***;

#mj3rba=1;
if mj22b=5 then #mj3rba=5;
else if mj22b=9 | (#mj3raa1=. | #mj3raa2=.) then #mj3rba=.;

*** Mj Criterion C ***;

#mj3rca=1;
if #mj3rde=1 then #mj3rca=5;
else if #mj3rde=. then #mj3rca=.;

** Marijuana Abuse Diagnosis **;

#mj3rab=1;
if #mj3raa=5 & #mj3rba=5 & #mj3rca=5 then #mj3rab=5;
else if #mj3raa=. | (#mj3raa ne 1 & #mj3rca=.) | (#mj3raa ne 1 & #mj3rca ne 1
 & #mj3rba=.) then #mj3rab=.;

label #mj3ra='Marijuana Dependence - Criterion A'
      #mj3rb='Marijuana Dependence - Criterion B'
      #mj3rde='Marijuana Dependence - Diagnosis'
      #mj3raa='Marijuana Abuse - Criterion A'
      #mj3rba='Marijuana Abuse - Criterion B'
      #mj3rca='Marijuana Abuse - Criterion C'
      #mj3rab='Marijuana Abuse - Diagnosis'
;
keep #mj3ra #mj3rb #mj3rde #mj3raa
      #mj3rba #mj3rca #mj3rab;
***** cobc.sas ***** (3/27/95);

* C-SSAGA DSM-III-R: Obsessive Compulsive Disorder *;

** Obsessions **;

*** Ob Criterion A ***;

#ob3ra1=1;  **** symptom group 1 ****;
if ob1=5 | ob2b=5 | ob3=5 | ob4=5 | ob5=5 then #ob3ra1=5;
else if ob1=3 | ob2b=3 | ob3=3 | ob4=3 | ob5=3 then #ob3ra1=3;
else if ob1=9 | ob2a=9 | ob2b=9 | ob3=9 | ob4=9 | ob5=9  then #ob3ra1=.;

#ob3ra2=1;  **** symptom group 2 ****;
if ob6=5 then #ob3ra2=5;
else if ob6=3 then #ob3ra2=3;
if ob6=9 | #ob3ra1=. then #ob3ra2=.;  * if vs else if intentional;

#ob3ra3=1;  **** symptom group 3 ****;
if ob7=5 then #ob3ra3=5;
else if ob7=3 then #ob3ra2=3;
if ob7=9 | #ob3ra1=. then #ob3ra3=.;  * if vs else if intentional;

**** symptom group 4 not assessed ****;

#ob3ra=1;  *** Criterion A ***;
if #ob3ra1=5 & #ob3ra2=5 & #ob3ra3=5 then #ob3ra=5;
else if #ob3ra1 ge 3 & #ob3ra2 ge 3 & #ob3ra3 ge 3 then #ob3ra=3;
else if #ob3ra1=. | #ob3ra2=. | #ob3ra3=. then #ob3ra=.;

*** Ob Criterion B ***;

#ob3rb=1;
if ob8a=5 | ob8b=2 then #ob3rb=5;
else if #ob3ra1=. | ob8a=9 | ob8b=9 then #ob3rb=.;

** Obsessions Diagnosis **;

#ob3r=1;
if #ob3ra=5 & #ob3rb=5 then #ob3r=5;
else if #ob3ra=3 & #ob3rb=5 then #ob3r=3;
else if (#ob3ra=. & #ob3rb ne 1) | (#ob3rb=. & #ob3ra ne 1) then #ob3r=.;

** Compulsions **;

*** Cp Criterion A ***;

#cp3ra1=1;  **** symptom group 1 ****;
if cp1=5 | cp2b=5 | cp3b=5 then #cp3ra1=5;
else if cp1=3 | cp2b=3 | cp3b=3 then #cp3ra1=3;
else if cp1=9 | cp2a=9 | cp2b=9 | cp3a=9 | cp3b=9 then #cp3ra1=.;

#cp3ra2=1;  **** symptom group 2 ****;
if cp4=5 then #cp3ra2=5;
else if cp4=3 then #cp3ra2=3;
if cp3a=9 | cp3b=9 | #cp3ra1=. then #cp3ra2=.;  * if vs else if intentional;

#cp3ra3=1;  **** symptom group 3 ****;
if cp5a=5 | cp5b=5 then #cp3ra3=5;
else if cp5a=3 | cp5b=3 then #cp3ra3=3;
else if cp5a=9 | cp5b=9 then #cp3ra3=.;
if #cp3ra1=. then #cp3ra3=.;  * if vs else if intentional;

#cp3ra=1;  *** Criterion A ***;
if #cp3ra1=5 & #cp3ra2=5 & #cp3ra3=5 then #cp3ra=5;
else if #cp3ra1 ge 3 & #cp3ra2 ge 3 & #cp3ra3 ge 3 then #cp3ra=3;
else if #cp3ra1=. | #cp3ra2=. | #cp3ra3=. then #cp3ra=.;

*** Cp Criterion B ***;

#cp3rb=1;
if cp6a=5 | cp6b=2 then #cp3rb=5;
else if #cp3ra1=. | cp6a=9 | cp6b=9 then #cp3rb=.;

** Compulsions Diagnosis **;

#cp3r=1;
if #cp3ra=5 & #cp3rb=5 then #cp3r=5;
else if #cp3ra=3 & #cp3rb=5 then #cp3r=3;
else if (#cp3ra=. & #cp3rb ne 1) | (#cp3rb=. & #cp3ra ne 1) then #cp3r=.;

* Obsessive Compulsive Diagnosis *;

#oc3r=1;
if #ob3r=5 | #cp3r=5 then #oc3r=5;
else if #ob3r=3 | #cp3r=3 then #oc3r=3;
else if #ob3r=. | #cp3r=. then #oc3r=.;

label #ob3ra='Obsession - Criterion A'
      #ob3rb='Obsession - Criterion B'
      #ob3r='Obsession Diagnosis'
      #cp3ra='Compulsion - Criterion A'
      #cp3rb='Compulsion - Criterion B'
      #cp3r='Compulsion - Diagnosis'
      #oc3r='Obsessive Compulsive Diagnosis'
;
keep  #ob3ra #ob3rb #ob3r #cp3ra
      #cp3rb #cp3r
      #oc3r
;
***** con.sas (3/27/95) *****;

* C-SSAGA DSM-III-R: Conduct Disorder *;

** CD Criterion A **;

#cd3ra1=1;  *** symptom group 1 ***;
cd3rd=cd3d; cd3rg=cd3g;
if cd3d=9 then cd3rd=.;
if cd3g=9 then cd3rg=.;
ttl=sum(cd3c,cd3rd,cd3f,cd3rg);
if cd3c ge 2 | (2 le cd3d le 5) | cd3f ge 2 | (2 le cd3g le 5) | ttl ge 2 then #cd3ra1=5;
else if cd3a=9 | cd3b=9 | cd3d=9 | cd3e=9 | cd3g=9 then #cd3ra1=.;

#cd3ra2=1;  *** symptom group 2 ***;
if ((cd4b=1 | cd4c=1) & cd4d=1) | cd4b ge 2 | (2 le cd4c le 5) then #cd3ra2=5;
else if cd4a=9 | cd4c=9 | ((cd4b=1 | cd4c=1) & cd4d=9) then #cd3ra2=.;

#cd3ra3=1;  *** symptom group 3 ***;
if (2 le cd5c le 4) then #cd3ra3=5;
else if cd5a=9 | cd5b=9 | cd5c=9 then #cd3ra3=.;

#cd3ra4=1;  *** symptom group 4 ***;
if cd6d ge 3 | (3 le cd6e le 5) then #cd3ra4=5;
else if cd6d ge 1 | (1 le cd6e le 5) then #cd3ra4=3;
else if cd6a=9 | cd6c=9 | cd6e=9 then #cd3ra4=.;

#cd3ra5=1;  *** symptom group 5 ***;
if cd7b ge 3 | (3 le cd7c le 5) | cd8b ge 3 | cd8c=3 then #cd3ra5=5;
else if cd7a=9 | cd7c=9 | cd8a=9 | cd8c=9 then #cd3ra5=.;

#cd3ra6=1;  *** symptom group 6 ***;
if cd9b ge 3 | (3 le cd9c le 5) then #cd3ra6=5;
else if cd9b ge 1 | (1 le cd9c le 5) then #cd3ra6=3;
else if cd9a=9 | cd9c=9 then #cd3ra6=.;

#cd3ra7=1;  *** symptom group 7 ***;
if cd10c ge 3 | (3 le cd10d le 5) then #cd3ra7=5;
else if cd10c ge 1 | (1 le cd10d le 5) then #cd3ra7=3;
else if cd10a=9 | cd10b=9 | cd10d=9 then #cd3ra7=.;

#cd3ra8=1;  *** symptom group 8 ***;
if cd11d ge 2 | (2 le cd11e le 5) then #cd3ra8=5;
else if cd11d ge 1 | (1 le cd11e le 5) then #cd3ra8=3;
else if cd11a=9 | cd11c=9 | cd11e=9 then #cd3ra8=.;

#cd3ra9=1;  *** symptom group 9 ***;
if cd12=5 then #cd3ra9=5;
else if cd12=9 then #cd3ra9=.;

#cd3ra10=1;  *** symptom group 10 ***;
if cd14b ge 2 | (2 le cd14c le 5) then #cd3ra10=5;
else if cd13a=9 | cd14a=9 | cd14c=9 then #cd3ra10=.;

#cd3ra11=1;  *** symptom group 11 ***;
if cd13b ge 3 | (3 le cd13c le 5) then #cd3ra11=5;
else if cd13a=9 | cd13c=9 then #cd3ra11=.;

#cd3ra12=1;  *** symptom group 12 ***;
if cd15b ge 3 | (3 le cd15c le 5) then #cd3ra12=5;
else if cd15b ge 1 | (1 le cd15c le 5) then #cd3ra12=3;
else if cd15a=9 | cd15c=9 then #cd3ra12=.;

#cd3ra13=1;  *** symptom group 13 ***;
if cd16d ge 2 | (2 le cd16e le 5) then #cd3ra13=5;
else if cd16d ge 1 | (1 le cd16e le 5) then #cd3ra13=3;
else if cd16a=9 | cd16c=9 | cd16e=9 then #cd3ra13=.;

#cd3r5sx=0; #cd3r3sx=0; #cd3ramx=0;  *** symptom group counts ***;
array rycda #cd3ra1-#cd3ra13;
do over rycda;
 if rycda=5 then #cd3r5sx+1;
 else if rycda=. then #cd3ramx+1;
 if rycda ge 3 then #cd3r3sx+1;
end;

**Diagnosis with no duration or clusterion
     - just symptom count**;
#cd3ract=1;  *** 3+ symptom groups ***;
if #cd3r5sx ge 3 then #cd3ract=5;
else if #cd3r3sx ge 3 then #cd3ract=3;
else if #cd3r5sx+#cd3ramx ge 3 then #cd3ract=.;

#cd3ra=1;  ** Criterion A **;
if #cd3ract=5 & cd18a=5 & cd18b=5 then #cd3ra=5;
else if #cd3ract=3 & cd18a=5 & cd18b=5 then #cd3ra=3;
else if #cd3ract=. | (cd18a=. & #cd3r5sx ge 2 & #cd3ract ne 1 & cd18b ne 1) |
 (cd18b=. & #cd3ract ne 1 & cd18a ne 1) then #cd3ra=.;

** CD Criterion B not assessed **;

* CD Diagnosis *;

#cd3r=#cd3ra;  * no Criterion B *;

label #cd3ract='ChildConDis - Diag w/3+symptom'
      #cd3ra='ChildConDis Criterion A'
      #cd3r='Child Conduct Disorder'
;
keep  #cd3ract #cd3ra
      #cd3r
;
***** copp.sas *****;

* C-SSAGA DSM-III-R: Oppositional Defiant Disorder *;

** ODD Criterion A **;

array ryopa op1 op2a op3a op4 op6-op9;
array ryopb #op3ra1-#op3ra4 #op3ra6-#op3ra9;

do over ryopa;  *** symptom groups 1-4,6-9;
 ryopb=1;
 if ryopa=5 then ryopb=5;
 else if ryopa=9 then ryopb=.;
end;

#op3ra5=1;  *** symptom group 5 ***;
if op5=2 then #op3ra5=5;
else if op5=9 then #op3ra5=.;

*** ODD screener ***;
if #op3ra1=5 | #op3ra2=5 | #op3ra3=5 | #op3ra4=5 | #op3ra5=5 then #opscr1=1;
else if #op3ra1=1 & #op3ra2=1 & #op3ra3=1 & #op3ra4=1 & #op3ra5=1 then
 #opscr1=0;

if #opscr1=. then do;
 #op3ra6=.; #op3ra7=.; #op3ra8=.; #op3ra9=.;
end;

#op3rasx=0; #op3ramx=0;  *** symptom group counts ***;
array ryopc #op3ra1-#op3ra9;
do over ryopc;
 if ryopc=5 then #op3rasx+1;
 else if ryopc=. then #op3ramx+1;
end;

**Diagnosis without duration or clustering
    - just based on symptom count*;
#op3ract=1;  *** 5+ symptom groups ***;
if #op3rasx ge 5 then #op3ract=5;
else if #op3rasx+#op3ramx ge 5 then #op3ract=.;

#op3ra=1;  ** Criterion A **;
if #op3ract=5 & op10d=5 & op10e=5 then #op3ra=5;
else if #op3ract=. | (op10d=. & #op3ract ne 1 & op10e ne 1) | (op10e=. &
  #op3ract ne 1 & op10d ne 1) then #op3ra=.;

** ODD Criterion B not to be included (WR) **;

* ODD Diagnosis *;

#op3r=#op3ra;  * no Criterion B *;

label #op3ract='ODD -Diag w/5+Symptoms'
      #op3ra='ODD - Criterion A'
      #op3r='ODD - Diagnosis'
;
keep #op3ract #op3ra #op3r;
***** covr.sas ***** (3/27/95 rev);

* C-SSAGA DSM-III-R: Overanxious Disorder *;

** Ov Criterion A **;

array ryova ov2-ov8;
array ryovb #ov3ra1-#ov3ra7;

do over ryova;  *** symptom groups 1-7 ***;
 ryovb=ryova;
 if ryova=9 then ryovb=.;
end;

*** Ov screener 1 ***;
if #ov3ra1 ge 3 | #ov3ra2 ge 3 then #ovscr1=1;
else if #ov3ra1=1 & #ov3ra2=1 then #ovscr1=0;

if #ovscr1=. then do;
 #ov3ra3=.; #ov3ra4=.; #ov3ra5=.; #ov3ra6=.; #ov3ra7=.;
end;

#ov3rsx5=0; #ov3rsx3=0; #ov3ramx=0;  *** symptom group counts ***;
do over ryovb;
 if ryovb=5 then #ov3rsx5+1;
 else if ryovb=. then #ov3ramx+1;
 if ryovb ge 3 then #ov3rsx3+1;     * if vs else if intentional;
end;

***Diagnosis without duration or clustering
      - just based on symptom count***;
#ov3rct5=1; #ov3rct3=1;  ** 4+ symptom groups **;
if #ov3rsx5 ge 4 then #ov3rct5=5;
else if #ov3rsx5+#ov3ramx ge 4 then #ov3rct5=.;
if #ov3rsx3 ge 4 then #ov3rct3=5;
else if #ov3rsx3+#ov3ramx ge 4 then #ov3rct3=.;

#ov3ra5=1; #ov3ra3=1;  ** Criterion A **;
if #ov3rct5=5 & ov10a=5 & ov10b=5 then #ov3ra5=5;
else if #ov3rct5=. | (ov10a=. & #ov3rct5 ne 1 & ov10b ne 1) | (ov10b=. &
 #ov3rct5 ne 1 & ov10a ne 1) then #ov3ra5=.;
if #ov3rct3=5 & ov10a=5 & ov10b=5 then #ov3ra3=5;
else if #ov3rct3=. | (ov10a=. & #ov3rct3 ne 1 & ov10b ne 1) | (ov10b=. &
 #ov3rct3 ne 1 & ov10a ne 1) then #ov3ra3=.;

** Ov Criterion B, C, D not assessed **;

* Overaxious Diagnosis *;

#ov3r=1;
if #ov3ra5=5 then #ov3r=5;
else if #ov3ra3=5 then #ov3r=3;
else if ov2=1 & ov3=1 then #ov3r=1;
else if #ov3ra5=. | #ov3ra3=. then #ov3r=.;

label #ov3rct5='OvrAnx 4+symptoms, no alc/drg use'
      #ov3rct3='OvrAnx 4+symptoms, alc/drg use'
      #ov3ra5='OvrAnx Criterion A - No alc/drg use'
      #ov3ra3='OvrAnx Criterion A - Alc/drg use'
      #ov3r='Overanxious Diagnosis'
;
keep  #ov3rct5
      #ov3rct3
      #ov3ra5
      #ov3ra3
      #ov3r
;
***** cpsy.sas ***** (3/27/95);

* C-SSAGA Psychotic Symptoms *;

** Psychotic Sx Criterion A **;

array rypsa ps4 ps5 ps6;
array rypsb #ps3ra3-#ps3ra5;

do over rypsa;  *** symptom groups 3-5 ***;
 rypsb=1;
 if rypsa=5 then rypsb=5;
 else if rypsa=3 then rypsb=3;
 else if rypsa=9 then rypsb=.;
end;

#ps3ra1=1;  *** symptom group 1 ***;
if ps1a=5 & ps1c=1 then #ps3ra1=5;
else if ps1a ge 3 & ps1c=1 then #ps3ra1=3;
else if ps1a=9 | ps1c=9 then #ps3ra1=.;

#ps3ra2=1;  *** symptom group 2 ***;
if ps2a=5 | ps3=5 then #ps3ra2=5;
else if ps2a=3 | ps3=3 then #ps3ra2=3;
else if ps2a=9 | ps3=9 then #ps3ra2=.;

#ps3ra6=1;  *** symptom group 6 ***;
if ps7=5 | ps8=5 | ps9=5 | ps10=5 | ps11=5 | ps12=5 then #ps3ra6=5;
else if ps7=3 | ps8=3 | ps9=3 | ps10=3 | ps11=3 | ps12=3 then #ps3ra6=3;
else if ps7=9 | ps8=9 | ps9=9 | ps10=9 | ps11=9 | ps12=9 then #ps3ra6=.;

#ps3rsx5=0; #ps3rsx3=0; #ps3ramx=0;  *** symptom group counts ***;
array rypsc #ps3ra1-#ps3ra6;
do over rypsc;
 if rypsc=5 then #ps3rsx5+1;
 else if rypsc=. then #ps3ramx+1;
 if rypsc ge 3 then #ps3rsx3+1;  * if vs else if intentional;
end;

#ps3ra=1;  *** Criterion A ***;
if #ps3rsx5 ge 1 then #ps3ra=5;
else if #ps3rsx3 ge 1 then #ps3ra=3;
else if #ps3ramx ge 1 then #ps3ra=.;

** Other Psychotic Criteria not assessed **;

* Psychotic Sx Diagnosis *;

#ps3r=#ps3ra; * no other criteria;

label #ps3ra='Psychotic Symptoms - Criterion A'
      #ps3r='Psychotic Sx Diagnosis'
;
keep  #ps3ra #ps3r
;
***** csep.sas ***** (3/27/95 rev);

* C-SSAGA DSM-III-R: Separation Anxiety Disorder *;

** Sep Criterion A **;

array rysaa sa1-sa3 sa6 sa9 sa10;
array rysab #sa3ra1-#sa3ra3 #sa3ra5-#sa3ra7;

do over rysaa;  *** symptom groups 1-3,5-7 ***;
 rysab=rysaa;
 if rysaa=9 then rysab=.;
end;

#sa3ra4=1;  *** symptom group 4 ***;
if sa4=5 | sa5=5 then #sa3ra4=5;
else if sa4=3 | sa5=3 then #sa3ra4=3;
else if sa4=9 | sa5=9 then #sa3ra4=.;

#sa3ra8=1;  *** symptom group 8 ***;
if sa11a=5 | sa11b=5 then #sa3ra8=5;
else if sa11a=3 | sa11b=3 then #sa3ra8=3;
else if sa11a=9 | sa11b=9 then #sa3ra8=.;

#sa3ra9=1;  *** symptom group 9 ***;
if sa7=5 | sa8a=5 | sa8b=5 then #sa3ra9=5;
else if sa7=3 | sa8a=3 | sa8b=3 then #sa3ra9=3;
else if sa7=9 | sa8a=9 | sa8b=9 then #sa3ra9=.;

*** Sep screener 1 ***;
if sa1 ge 3 | sa2 ge 3 | sa3 ge 3 | sa4 ge 3 | sa5 ge 3 then #sascr1=1;
else if sa1=1 & sa2=1 & sa3=1 & sa4=1 & sa5=1 then #sascr1=0;

if #sascr1=. then do;
 #sa3ra5=.; #sa3ra6=.; #sa3ra7=.; #sa3ra8=.; #sa3ra9=.;
end;

#sa3rsx5=0; #sa3rsx3=0; #sa3ramx=0;  *** symptom group counts ***;
array rysac #sa3ra1-#sa3ra9;
do over rysac;
 if rysac=5 then #sa3rsx5+1;
 else if rysac=. then #sa3ramx+1;
 if rysac ge 3 then #sa3rsx3+1;
end;

  **Diagnosis without duration and clustering
       - just symptom count > 3**;
#sa3ra5=1; #sa3ra3=1;  ** Criterion A **;
if #sa3rsx5 ge 3 then #sa3ra5=5;
else if #sa3rsx5+#sa3ramx ge 3 then #sa3ra5=.;
if #sa3rsx3 ge 3 then #sa3ra3=5;
else if #sa3rsx3+#sa3ramx ge 3 then #sa3ra3=.;

** Criterion B **;

#sa3rb=1;
if sa13=5 then #sa3rb=5;
else if sa13=9 | #sa3ramx ge 1 then #sa3rb=.;

** Criterion C **;

#sa3rc=1;
if (1 le sa12a le 17)|(1 le dm3 lt 18) then #sa3rc=5;
else if dm3=-9 | (dm3 ge 18 & sa12a=-9) then #sa3rc=.;

** Criterion D not assessed **;

* Separation Anxiety Diagnosis *;

#sa3r=1;
if #sa3ra5=5 & #sa3rb=5 & #sa3rc=5 then #sa3r=5;
else if #sa3ra3=5 & #sa3rb=5 & #sa3rc=5 then #sa3r=3;
else if #sascr1=0 then #sa3r=1;
else if #sa3ra3=. | ((#sa3rb=. | #sa3rc=.) & #sa3ra3 ne 1) then #sa3r=.;

label #sa3ra5='SepAnx Crit.A & Diag w/3+Symp-no alc/drg'
      #sa3ra3='SepAnx Crit.A & Diag w/3+Symp-alc/drg'
      #sa3rb='SepAnx Criterion B'
      #sa3rc='SepAnx Criterion C'
      #sa3r='Separation Anxiety Diagnosis'
;
keep  #sa3ra5
      #sa3ra3
      #sa3rb
      #sa3rc
      #sa3r
;
***** csom.sas ***** (3/27/95);

* C-SSAGA DSM-III-R: Somatization Disorder *;

** Som Criterion A **;

#sm3ra=1;
if sm1=5 | sm2=5 then #sm3ra=5;
else if sm1=9 | sm2=9 then #sm3ra=.;
else if sm1=3 | sm2=3 then #sm3ra=3;

** Som Criterion B **;

array rysma sm3 sm4a sm4b sm4c sm4d sm4e;
array rysmb sm5 sm6a sm6b sm6c sm6d;
array rysmc sm7 sm8a sm8b sm8c;
array rysmd sm9 sm10 sm11a sm11b sm11c sm11d sm11e sm11f sm11g sm11h sm11i sm11j;
array rysme sm12b sm12c sm12d;

#sm3rsx5=0; #sm3rsx3=0; #sm3rbmx=0;  *** symptom group counts ***;
do over rysma;
 if sm3=9 then #sm3rbmx+1;
 else if rysma=5 then #sm3rsx5+1;
 else if rysma=9 then #sm3rbmx+1;
 if sm3 ne 9 & (rysma=3 | rysma=5) then #sm3rsx3+1;  * if vs else if intentional;
end;

do over rysmb;
 if sm5=9 then #sm3rbmx+1;
 else if rysmb=5 then #sm3rsx5+1;
 else if rysmb=9 then #sm3rbmx+1;
 if sm5 ne 9 & (rysmb=3 | rysmb=5) then #sm3rsx3+1;  * if vs else if intentional;
end;

do over rysmc;
 if sm7=9 then #sm3rbmx+1;
 else if rysmc=5 then #sm3rsx5+1;
 else if rysmc=9 then #sm3rbmx+1;
 if sm7 ne 9 & (rysmc=3 | rysmc=5) then #sm3rsx3+1;  * if vs else if intentional;
end;

do over rysmd;
 if sm9=9 & sm10=9 then #sm3rbmx+1;
 else if rysmd=5 then #sm3rsx5+1;
 else if rysmd=9 then #sm3rbmx+1;
 if (sm9 ne 9 | sm10 ne 9) & (rysmd=3 | rysmd=5) then #sm3rsx3+1;
end;

if dm1=2 & dm3 ge 9 then do over rysme;
 if sm12a=9 | sm12b=9 then #sm3rbmx+1;
 else if rysme=5 then #sm3rsx5+1;
 else if rysme=9 then #sm3rbmx+1;
 if sm12a ne 9 & sm12b ne 9 & (rysme=3 | rysme=5) then #sm3rsx3+1;
end;

#sm3rb5=1; #sm3rb3=1;  ** Criterion B **;
if #sm3rsx5 ge 13 then #sm3rb5=5;
else if #sm3rsx5+#sm3rbmx ge 13 then #sm3rb5=.;
if #sm3rsx3 ge 13 then #sm3rb3=5;
else if #sm3rsx3+#sm3rbmx ge 13 then #sm3rb3=.;

* Somatization Diagnosis *;

#sm3r=1;
if #sm3ra=5 & #sm3rb5=5 then #sm3r=5;
else if #sm3ra=. | #sm3rb5=. then #sm3r=.;
else if #sm3ra=5 & #sm3rb3=5 then #sm3r=3;
else if #sm3rb3=. then #sm3r=.;

label #sm3ra='Somatization - Criterion A'
      #sm3rb5='Somat. - Criterion B - no alc/drg use'
      #sm3rb3='Somat. - Criterion B - alc/drg use'
      #sm3r='Somatization Diagnosis'
;
keep  #sm3ra
      #sm3rb5
      #sm3rb3
      #sm3r
;
***3/27/95 (rev)***;

***** cdep.sas *****;

* C-SSAGA DSM-III-R: Major Depressive Episode *;

** MD screeners **;

*** MD screener 1 (current scr) ***;
if (md2a=5 | md2b=5 | md2c=5 | md2d=5 | md2e=5) & md3a=5 then #mdscr1=1;
else if (md2a=1 & md2b=1 & md2c=1 & md2d=1 & md2e=1) | md3a=1 then #mdscr1=0;

*** MD screener 2 (other time scr) ***;
if (md6a=5 | md6b=5 | md6c=5 | md6d=5 | md6e=5) & md7a=5 then #mdscr2=1;
else if (md6a=1 & md6b=1 & md6c=1 & md6d=1 & md6e=1) | md7a=1 then #mdscr2=0;


*** MD screener 4 (current clean scr) ***;
if md4a=1 & (md4b=1 | (md4b=5 & (md4c=1 | md4c=2))) & md4e=1 then #mdscr4=1;
else if md4a=5 | (md4b=5 & (3 ge md4c ge 998)) | md4e=5 then #mdscr4=0;

*** MD screener 5 (other time 1 clean scr) ***;
if md10a=1 & (md10b=1 | (md10b=5 & (md10c=1 | md10c=2))) & md10e=1 then
 #mdscr5=1;
else if md10a=5 | (md10b=5 & (3 ge md10c ge 998)) | md10e=5 then #mdscr5=0;

*** MD screener 6 (other time 2 clean scr) ***;
if #mdscr5 ne 1 & md12a=5 & md12d=1 then #mdscr6=1;
else if md12a=1 | md12d=5 then #mdscr6=0;

** Major Depressive Episodes **;

*** MD Criterion A (current) ***;

  **** symptom group 1 ****;
if md3b=5 then #mdc3ra1=5;
else if (md2a=1 & md2b=1 & md2e=1) | md3b=1 | md3a=1 then #mdc3ra1=1;

  **** symptom group 2 ****;
if md3c=5 then #mdc3ra2=5;
else if (md2c=1 & md2d=1) | md3c=1 | md3a=1 then #mdc3ra2=1;

#mdc3ra3=1;  **** symptom group 3 ****;
if mda_19b=5 | mda_20b=5 | mda_19a=5 | mda_20a=5 then #mdc3ra3=5;
else if mda_19a=9 | mda_19b=9 | mda_20a=9 | mda_20b=9 then #mdc3ra3=.;

#mdc3ra4=1;  **** symptom group 4 ****;
if mda_21a=5 | mda_21b=5 | mda_21c=5 | mda_21d=5 then #mdc3ra4=5;
else if mda_21a=9 | mda_21b=9 | mda_21c=9 | mda_21d=9 then #mdc3ra4=.;

#mdc3ra5=1;  **** symptom group 5 ****;
if mda_22=5 | mda_23=5 then #mdc3ra5=5;
else if mda_22=9 | mda_23=9 then #mdc3ra5=.;

#mdc3ra6=1;  **** symptom group 6 ****;
if mda_24=5 then #mdc3ra6=5;
else if mda_24=9 then #mdc3ra6=.;

#mdc3ra7=1;  **** symptom group 7 ****;
if mda_25=5 | mda_26=5 then #mdc3ra7=5;
else if mda_25=9 | mda_26=9 then #mdc3ra7=.;

#mdc3ra8=1;  **** symptom group 8 ****;
if mda_27a=5 | mda_27b=5 | mda_28a=5 | mda_28b=5 then #mdc3ra8=5;
else if mda_27a=9 | mda_27b=9 | mda_28a=9 | mda_28b=9 then #mdc3ra8=.;

#mdc3ra9=1;  **** symptom group 9 ****;
if mda_29a=5 | mda_29b=5 | mda_29c=5 | mda_29d=5 then #mdc3ra9=5;
else if mda_29a=9 | mda_29b=9 | mda_29c=9 | mda_29d=9 then #mdc3ra9=.;


*** MD Criterion A (other time) ***;

  **** symptom group 1 ****;
if md7b=5 | md12b=5 then #mdp3ra1=5;
else if (md6a=1 & md6b=1 & md6c=1) | md7b=1 | md12b=1 then #mdp3ra1=1;

  **** symptom group 2 ****;
if md7c=5 | md12c=5 then #mdp3ra2=5;
else if (md6d=1 & md6e=1) | md7c=1 | md12c=1 then #mdp3ra2=1;

#mdp3ra3=1;  **** symptom group 3 ****;
if mdb_19a=5 | mdb_19b=5 | mdb_20a=5 | mdb_20b=5 then #mdp3ra3=5;
else if mdb_19a=9 | mdb_19b=9 | mdb_20a=9 | mdb_20b=9 then #mdp3ra3=.;

#mdp3ra4=1;  **** symptom group 4 ****;
if mdb_21a=5 | mdb_21b=5 | mdb_21c=5 | mdb_21d=5 then #mdp3ra4=5;
else if mdb_21a=9 | mdb_21b=9 | mdb_21c=9 | mdb_21d=9 then #mdp3ra4=.;

#mdp3ra5=1;  **** symptom group 5 ****;
if mdb_22=5 | mdb_23=5 then #mdp3ra5=5;
else if mdb_22=9 | mdb_23=9 then #mdp3ra5=.;

#mdp3ra6=1;  **** symptom group 6 ****;
if mdb_24=5 then #mdp3ra6=5;
else if mdb_24=9 then #mdp3ra6=.;

#mdp3ra7=1;  **** symptom group 7 ****;
if mdb_25=5 | mdb_26=5 then #mdp3ra7=5;
else if mdb_25=9 | mdb_26=9 then #mdp3ra7=.;

#mdp3ra8=1;  **** symptom group 8 ****;
if mdb_27a=5 | mdb_27b=5 | mdb_28a=5 | mdb_28b=5 then #mdp3ra8=5;
else if mdb_27a=9 | mdb_27b=9 | mdb_28a=9 | mdb_28b=9 then #mdp3ra8=.;

#mdp3ra9=1;  **** symptom group 9 ****;
if mdb_29a=5 | mdb_29b=5 | mdb_29c=5 | mdb_29d=5 then #mdp3ra9=5;
else if mdb_29a=9 | mdb_29b=9 | mdb_29c=9 | mdb_29d=9 then #mdp3ra9=.;

cur_past=0;
array rymda #mdc3ra1-#mdc3ra9;
array rymdb #mdp3ra1-#mdp3ra9;
if (#mdscr1=1 & #mdscr2 ne 1) | (#mdscr4=1 & #mdscr5 ne 1 & #mdscr6 ne 1) then
do over rymda;
 if _I_ le 2 then rymdb=rymda;
 cur_past=1;
 if _I_ gt 2 & rymda=5 then rymdb=rymda;
 if _I_ gt 2 then rymda=.;
 if #mdscr1=. then rymda=.;
end;

#mdc3rsx=0; #mdc3rmx=0;  **** symptom group counts (current) ****;
do over rymda;
 if rymda=5 then #mdc3rsx+1;
 else if rymda=. then #mdc3rmx+1;
end;

#mdc3rac=1;  **** 5+ symptom groups *****;
if #mdc3rsx ge 5 then #mdc3rac=5;
else if #mdc3rsx+#mdc3rmx ge 5 then #mdc3rac=.;

#mdc3ra=1;  *** Criterion A ***;
if #mdc3rac=5 & (#mdc3ra1=5 | #mdc3ra2=5) & mda_30b=5 then #mdc3ra=5;
else if (#mdc3rac=. & (#mdc3ra1 ne 1 | #mdc3ra2 ne 1)) | (#mdc3rac ne . &
 ((#mdc3ra1=. & #mdc3ra2 ne 5) | (#mdc3ra1 ne 5 & #mdc3ra2=.))) |
 (#mdc3rac ne 1 & (#mdc3ra1 ne 1 | #mdc3ra1 ne 1) & mda_30b=9) then #mdc3ra=.;

*** MD Criterion B ***;

#mdc3rb1=1;  **** B group 1 (alc & drug)****;
if mda_31c=5 | #mdscr4=0 then #mdc3rb1=5;
else if mda_31c=9 & #mdscr4 = . then #mdc3rb1=.;

#mdc3rb2=1;  **** B group 2 (bereavement)****;
if mda_31a=5 then #mdc3rb2=5;
else if mda_31a=9 then #mdc3rb2=.;

#mdc3rb3=1;  **** B group 3 (illness/injury)****;
if mda_31b=5 then #mdc3rb3=5;
else if mda_31b=9 then #mdc3rb3=.;

#mdc3rb=1;  *** Criterion B ***;
if #mdc3rb1=1 & #mdc3rb2=1 & #mdc3rb3=1 then #mdc3rb=5;
else if #mdc3rb1=. | #mdc3rb2=. | #mdc3rb3=. then #mdc3rb=.;

** Current Depressive Episode Diagnosis **;

#mdc3r=1;
if #mdc3ra=5 & #mdc3rb=5 then #mdc3r=5;
else if #mdc3ra=5 & #mdc3rb1=5 then #mdc3r=4; *alc&drg*;
else if #mdc3ra=5 & #mdc3rb2=5 then #mdc3r=3; *bereavement*;
else if #mdc3ra=5 & #mdc3rb3=5 then #mdc3r=2; *illness/injury*;
else if #mdc3ra=. | (#mdc3rb=. & #mdc3ra ne 1) then #mdc3r=.;

#mdp3rsx=0; #mdp3rmx=0;  **** symptom group counts (other time) ****;
do over rymdb;
 if rymdb=5 then #mdp3rsx+1;
 else if rymdb=. then #mdp3rmx+1;
end;

#mdp3rac=1;  **** 5+ symptom groups *****;
if #mdp3rsx ge 5 then #mdp3rac=5;
else if #mdp3rsx+#mdp3rmx ge 5 then #mdp3rac=.;

#mdp3ra=1;  *** Criterion A ***;
if #mdp3rac=5 & (#mdp3ra1=5 | #mdp3ra2=5) & mdb_30b=5 then #mdp3ra=5;
else if (#mdp3rac=. & (#mdp3ra1 ne 1 | #mdp3ra2 ne 1)) | (#mdp3rac ne . &
 ((#mdp3ra1=. & #mdp3ra2 ne 5) | (#mdp3ra1 ne 5 & #mdp3ra2=.))) |
 (#mdp3rac ne 1 & (#mdp3ra1 ne 1 | #mdp3ra1 ne 1) & mdb_30b=9) then #mdp3ra=.;

*** MD Criterion B ***;

#mdp3rb1=1;  **** B group 1 (alc&drug)****;
if mdb_31c=5 | #mdscr5=0 | #mdscr6=0 then #mdp3rb1=5;
else if cur_past=1 & (#mdscr4=0 | mda_31c=5) then #mdp3rb1=5;
else if mdb_31c=9 & #mdscr5=. & #mdscr6=. then #mdp3rb1=.;
else if cur_past=1 & #mdscr4=. & mda_31c=9 then #mdp3rb1=.;

#mdp3rb2=1;  **** B group 2 (bereavement)****;
if mdb_31a=5 then #mdp3rb2=5;
else if cur_past=1 & mda_31a=5 then #mdp3rb2=5;
else if mdb_31a=9 then #mdp3rb2=.;

#mdp3rb3=1;  **** B group 3 (illness/injury)****;
if mdb_31b=5 then #mdp3rb3=5;
else if cur_past=1 & mda_31b=5 then #mdp3rb3=5;
else if mdb_31b=9 then #mdp3rb3=.;

#mdp3rb=1;  *** Criterion B ***;
if #mdp3rb1=1 & #mdp3rb2=1 & #mdp3rb3=1 then #mdp3rb=5;
else if #mdp3rb1=. | #mdp3rb2=. | #mdp3rb3=. then #mdp3rb=.;

** Other Time Depressive Episode Diagnosis **;

#mdp3r=1;
if #mdp3ra=5 & #mdp3rb=5 then #mdp3r=5;
else if #mdp3ra=5 & #mdp3rb1=5 then #mdp3r=4; *alc&drug*;
else if #mdp3ra=5 & #mdp3rb2=5 then #mdp3r=3; *bereavement*;
else if #mdp3ra=5 & #mdp3rb3=5 then #mdp3r=2; *injury/illness*;
else if #mdp3ra=. | (#mdp3rb=.& #mdp3ra ne 1) then #mdp3r=.;

label #mdc3ra='Cur. Depression, Crit. A'
      #mdc3rb1='Cur. Depression,Crit. B-Alc&Drug use'
      #mdc3rb2='Cur. Depres. Crit.B-bereavement'
      #mdc3rb3='Cur. Depres. Crit.B-illness/injury'
      #mdc3rb='Cur.Depres. Crit.B-No other factors'
      #mdc3r='Cur. Depres. Diagnosis'
      #mdp3ra='Past Depression, Crit. A'
      #mdp3rb1='Past Depression,Crit. B-Alc&Drug use'
      #mdp3rb2='Past Depres. Crit.B-bereavement'
      #mdp3rb3='Past Depres. Crit.B-illness/injury'
      #mdp3rb='Past Depres. Crit.B-No other factors'
      #mdp3r='Past Depres. Diagnosis'
;
keep  #mdc3ra
      #mdc3rb1
      #mdc3rb2
      #mdc3rb3
      #mdc3rb
      #mdc3r
      #mdp3ra
      #mdp3rb1
      #mdp3rb2
      #mdp3rb3
      #mdp3rb
      #mdp3r
;

** Additional Dirty episodes of Depression**;

*** MD Criterion A **;

***symptom 1 & 2 ***;
#mdd3ra1=1; #mdd3ra2=1;  **** symptom group 1 & 2 ****;
if md35a=5 then #mdd3ra1=5 ;
else if md35a=9 then #mdd3ra1=.;
if md35a=5 then #mdd3ra2=5 ;
else if md35a=9 then #mdd3ra2=.;

#mdd3ra3=1;  **** symptom group 3 ****;
if md35c_1=5 | md35c_2=5 then #mdd3ra3=5;
else if md35c_1=9 | md35c_2=9 then #mdd3ra3=.;

#mdd3ra4=1;  **** symptom group 4 ****;
if md35c_3=5 then #mdd3ra4=5;
else if md35c_3=9 then #mdd3ra4=.;

#mdd3ra5=1;  **** symptom group 5 ****;
if md35c_4=5 | md35c_5=5 then #mdd3ra5=5;
else if md35c_4=9 | md35c_5=9 then #mdd3ra5=.;

#mdd3ra6=1;  **** symptom group 6 ****;
if md35c_6=5 then #mdd3ra6=5;
else if md35c_6=9 then #mdd3ra6=.;

#mdd3ra7=1;  **** symptom group 7 ****;
if md35c_7=5 then #mdd3ra7=5;
else if md35c_7=9 then #mdd3ra7=.;

#mdd3ra8=1;  **** symptom group 8 ****;
if md35c_8=5 | md35c_9=5 then #mdd3ra8=5;
else if md35c_8=9 | md35c_9=9 then #mdd3ra8=.;

#mdd3ra9=1;  **** symptom group 9 ****;
if md35c_10=5 then #mdd3ra9=5;
else if md35c_10=9 then #mdd3ra9=.;

array rymdd #mdd3ra1-#mdd3ra9;

#mdd3rsx=0; #mdd3rmx=0;  **** symptom group counts ****;
do over rymdd;
 if rymdd=5 then #mdd3rsx+1;
 else if rymdd=. then #mdd3rmx+1;
end;

#mdd3rac=1;  **** 5+ symptom groups *****;
if #mdd3rsx ge 5 then #mdd3rac=5;
else if #mdd3rsx+#mdd3rmx ge 5 then #mdd3rac=.;

#mdd3ra=1;  *** Criterion A ***;
if #mdd3rac=5 & (#mdd3ra1=5 | #mdd3ra2=5) & md35d=5 then #mdd3ra=5;
else if (#mdd3rac=. & (#mdd3ra1 ne 1 | #mdd3ra2 ne 1))
 | md35d=9 then #mdd3ra=.;

*** Criterion B not assessed - It is dirty ***;

**** MD - Dirty diagnoses **** ;

#mdd3r=#mdd3ra;


** Other clean episodes of Depression**;

*** MD Criterion A **;

***symptom 1 & 2 ***;
#mdo3ra1=1; #mdl3ra2=1;  **** symptom group 1 & 2 ****;
if md36a=5 then #mdo3ra1=5 ;
else if md36a=9 then #mdo3ra1=.;
if md36a=5 then #mdo3ra2=5;
else if md36a=9 then #mdo3ra2=.;

#mdo3ra3=1;  **** symptom group 3 ****;
if md36c_1=5 | md36c_2=5 then #mdo3ra3=5;
else if md36c_1=9 | md36c_2=9 then #mdo3ra3=.;

#mdo3ra4=1;  **** symptom group 4 ****;
if md36c_3=5 then #mdo3ra4=5;
else if md36c_3=9 then #mdo3ra4=.;

#mdo3ra5=1;  **** symptom group 5 ****;
if md36c_4=5 | md36c_5=5 then #mdo3ra5=5;
else if md36c_4=9 | md36c_5=9 then #mdo3ra5=.;

#mdo3ra6=1;  **** symptom group 6 ****;
if md36c_6=5 then #mdo3ra6=5;
else if md36c_6=9 then #mdo3ra6=.;

#mdo3ra7=1;  **** symptom group 7 ****;
if md36c_7=5 then #mdo3ra7=5;
else if md36c_7=9 then #mdo3ra7=.;

#mdo3ra8=1;  **** symptom group 8 ****;
if md36c_8=5 | md36c_9=5 then #mdo3ra8=5;
else if md36c_8=9 | md36c_9=9 then #mdo3ra8=.;

#mdo3ra9=1;  **** symptom group 9 ****;
if md36c_10=5 then #mdo3ra9=5;
else if md36c_10=9 then #mdo3ra9=.;

array rymdo #mdo3ra1-#mdo3ra9;

#mdo3rsx=0; #mdo3rmx=0;  **** symptom group counts ****;
do over rymdo;
 if rymdo=5 then #mdo3rsx+1;
 else if rymdo=. then #mdo3rmx+1;
end;

#mdo3rac=1;  **** 5+ symptom groups *****;
if #mdo3rsx ge 5 then #mdo3rac=5;
else if #mdo3rsx+#mdo3rmx ge 5 then #mdo3rac=.;

#mdo3ra=1;  *** Criterion A ***;
if #mdo3rac=5 & (#mdo3ra1=5 | #mdo3ra2=5) & md36d=5 then #mdo3ra=5;
else if (#mdo3rac=. & (#mdo3ra1 ne 1 | #mdo3ra2 ne 1 ))
 | md36d=9 then #mdo3ra=.;

*** Criterion B not assessed - It is clean ***;

****Other MD - diagnoses **** ;

#mdo3r=#mdo3ra;

label #mdd3ra='Additional Dirty MD - Criterion A'
      #mdo3ra='Other clean MD - Criterion A'
      #mdd3r='MD Diagnosis - Dirty'
      #mdo3r='Other MD clean Diagnosis'
;
keep  #mdd3ra
      #mdo3ra
      #mdd3r
      #mdo3r
;
