libname mf72 '/more/coga/mf/mf72';
data mf72.dx_csaga;set mf72.cssaga;
   length default=3;
   length ind_id 8;
   keep ind_id;
*** al25a_1-al25a_9 removed  NSR ***;
***** cadh.sas ***** (3/27/95) ;
* C-SSAGA DSM-III-R: Attention Deficit-Hyperactivity Disorder *;

** ADHD Criterion A **;

array ryada at1_1 at2_1 at3_1 at4_1 at5_1 at6_1 at8_1 at9_1 at10_1 at11_1
 at12_1 at13_1 at14_1;
array ryadb cat3ra1-cat3ra6 cat3ra8-cat3ra14;

do over ryada;  *** symptom groups 1-6,8-14 ***;
 ryadb=1;
 if ryada=5 then ryadb=5;
 else if ryada=9 then ryadb=.;
end;

cat3ra7=1;  *** symptom group 7 ***;
if at7a_1=5 | at7b_1=5 then cat3ra7=5;
else if at7a_1=9 | at7b_1=9 then cat3ra7=.;

*** ADHD screener 1 ***;
if cat3ra1=5 | cat3ra2=5 | cat3ra3=5 | cat3ra4=5 | cat3ra5=5 | cat3ra6=5 |
 cat3ra7=5 | cat3ra8=5 then catscr1=1;
else if cat3ra1=1 & cat3ra2=1 & cat3ra3=1 & cat3ra4=1 & cat3ra5=1 &
 cat3ra6=1 & cat3ra7=1 & cat3ra8=1 then catscr1=0;

if catscr1=. then do;
 cat3ra9=.; cat3ra10=.; cat3ra11=.; cat3ra12=.; cat3ra13=.; cat3ra14=.;
end;

cat3rasx=0; cat3ramx=0;  *** symptom group counts ***;
array ryadc cat3ra1-cat3ra14;
do over ryadc;
 if ryadc=5 then cat3rasx+1;
 else if ryadc=. then cat3ramx+1;
end;

**Diagnosis without duration or clustering
    - just symptom count**;
cat3ract=1;  *** 8+ symptom groups ***;
if cat3rasx ge 8 then cat3ract=5;
else if cat3rasx+cat3ramx ge 8 then cat3ract=.;

catscr2=0;  *** ADHD screener 2 ***;
if cat3rasx ge 4 then catscr2=1;
else if cat3rasx+cat3ramx ge 4 then catscr2=.;

cat3ra=1;  ** Criterion A **;
if cat3ract=5 & at15d=5 & at15e=5 then cat3ra=5;
else if cat3ract=. | (at15d=. & catscr2=1 & cat3ract ne 1 & at15e ne 1) | (at15e=.
 & catscr2=1 & cat3ract ne 1 & at15d ne 1) then cat3ra=.;

** ADHD Criterion B **;

cat3rb=1;  ** Criterion B **;
if 1 le at15a le 6 then cat3rb=5;
else if at15a=-9 | (at15a=. & catscr2=1) then cat3rb=.;

** ADHD Criterion C not assessed **;

* ADHD Diagnosis *;

cat3r=1;
if cat3ra=5 & cat3rb=5 then cat3r=5;
else if cat3ra=. | (cat3rb=. & cat3ra ne 1) then cat3r=.;

label cat3ract='ADHD - Diag w/ 8+symptoms'
      cat3ra='ADHD - Criterion A'
      cat3rb='ADHD - Criterion B'
      cat3r='ADHD Diagnosis'
;
keep  cat3ract cat3ra cat3rb cat3r;
;
***** calc.sas ***** (3/27/95);

* C-SSAGA DSM-III-R: Psychoactive Substance (Alcohol) Use Disorder *;

** Alcohol Dependence **;

*** Alc Criterion A ***;

**** Alc screener 1 ****;
if al4c ge 7 | (1 le al4d le 4) then calscr1=1;
else if al2=1 | (0 le al4c le 6) | al4d=0 then calscr1=0;

cal3ra1=1;  **** symptom group 1 ****;
if al21b=5 | al22b=5 then cal3ra1=5;
else if al21a=9 | al21b=9 | al22a=9 | al22b=9 then cal3ra1=.;

cal3ra2=1;  **** symptom group 2 ****;
if al20c=5 | al20b=5 then cal3ra2=5;
else if al20a=9 | al20b=9 | al20c=9 then cal3ra2=.;

cal3ra3=1;  **** symptom group 3 ****;
if al28=5 then cal3ra3=5;
else if al28=9 then cal3ra3=.;

cal3ra4=1;  **** symptom group 4 ****;
if al14d=5 | al15b=5 | al16=5 | al26b=5 | al27b=5 then cal3ra4=5;
else if al14c=9 | al14d=9 | al15a=9 | al15b=9 | al16=9 | al26a=9 |
 al26b=9 | al27a=9 | al27b=9 then cal3ra4=.;

cal3ra5=1;  **** symptom group 5 ****;
if al18=5 then cal3ra5=5;
else if al18=9 then cal3ra5=.;

cal3ra6=1;  **** symptom group 6 ****;
if al10g=5 | al13e=5 | al14b=5 then cal3ra6=5;
else if al10g=9 | al10f=9 | (al10f=. & (al10a=9 | al10c=9 |
 al10d=9 | al10e=9)) | al13e=9 | al13d=9 | (al13d=. & ( al13a=9 | al13b=9
 | al13c=9)) | al14a=9 | al14b=9 then cal3ra6=.;

cal3ra7=1;  **** symptom group 7 ****;
if al19a=5 | al19b=5 then cal3ra7=5;
else if al19a=9 | al19b=9 then cal3ra7=.;

cal3ra8=1;  **** symptom group 8 ****;
if al25b=5 then cal3ra8=5;
else if al25b=9 | (al25b=. & ((al24a_1=9)+(al24a_2=9)+(al24a_3=9)+(al24a_4=9)
 +(al24a_5=9)+(al24a_6=9)+(al24a_7=9)+(al24a_8=9)+(al24a_9=9)+(al24a_10=9)) ge 2)
 then cal3ra8=.;

cal3ra9=1; **** symptom group 9 ****;
if al24b_1=5 | al24b_2=5 | al24b_3=5 | al24b_4=5 | al24b_5=5 | al24b_6=5 |
 al24b_7=5 | al24b_8=5 | al24b_9=5 | al24b_10=5 then cal3ra9=5;
else if al24b_1=9 | al24b_2=9 | al24b_3=9 | al24b_4=9 | al24b_5=9 | al24b_6=9
 | al24b_7=9 | al24b_8=9 | al24b_9=9 | al24b_10=9
 | al24a_1=9 | al24a_2=9 | al24a_3=9 | al24a_4=9 | al24a_5=9 | al24a_6=9
 | al24a_7=9 | al24a_8=9 | al24a_9=9 | al24a_10=9 then cal3ra9=.;

array ryala cal3ra1-cal3ra9;
if calscr1=. then do over ryala;
 ryala=.;
end;

cal3rasx=0; cal3ramx=0;  **** symptom group counts ****;
do over ryala;
 if ryala=5 then cal3rasx+1;
 else if ryala=. then cal3ramx+1;
end;

cal3ra=1;  *** Criterion A ***;
if cal3rasx ge 3 then cal3ra=5;
else if cal3rasx+cal3ramx ge 3 then cal3ra=.;

*** Alc Criterion B ***;

cal3rb=1;
if al30b=5 then cal3rb=5;
else if al30b=9 | cal3ramx ge 1 then cal3rb=.;

** Alcohol Dependence Diagnosis **;

cal3rde=1;
if cal3ra=5 & cal3rb=5 then cal3rde=5;
else if cal3ra=. | (cal3ra ne 1 & cal3rb=.) then cal3rde=.;

** Alcohol Abuse **;

*** Alc Criterion A ***;

cal3raa1=cal3ra6;  **** symptom group 1 ****;

cal3raa2=1;  **** symptom group 2 ****;
if al14d=5 | al26b=5 | al27b=5 then cal3raa2=5;
else if al14c=9 | al14d=9 | al26a=9 | al26b=9 | al27a=9 | al27b=9 then
  cal3raa2=.;

if calscr1=. then do;
 cal3raa1=.; cal3raa2=.;
end;

cal3raa=1;  *** Criterion A ***;
if cal3raa1=5 | cal3raa2=5 then cal3raa=5;
else if cal3raa1=. | cal3raa2=. then cal3raa=.;

*** Alc Criterion B ***;

cal3rba=1;
if al30b=5 then cal3rba=5;
else if al30b=9 | (cal3raa1=. | cal3raa2=.) then cal3rba=.;

*** Alc Criterion C ***;

cal3rca=1;
if cal3rde=1 then cal3rca=5;
else if cal3rde=. then cal3rca=.;

** Alcohol Abuse Diagnosis **;

cal3rab=1;
if cal3raa=5 & cal3rba=5 & cal3rca=5 then cal3rab=5;
else if cal3raa=. | (cal3raa ne 1 & cal3rca=.) | (cal3raa ne 1 & cal3rca ne 1
 & cal3rba=.) then cal3rab=.;

label cal3ra='Alcohol Dependence - Criterion A'
      cal3rb='Alcohol Dependence - Criterion B'
      cal3rde='Alcohol Dependence Diagnosis'
      cal3raa='Alcohol Abuse - Criterion A'
      cal3rba='Alcohol Abuse - Criterion B'
      cal3rca='Alcohol Abuse - Criterion C'
      cal3rab='Alcohol Abuse - Diagnosis';
keep  cal3ra cal3rb cal3rde cal3raa cal3rba
      cal3rca cal3rab;
;
***** canr.sas ***** (3/27/95);

* C-SSAGA DSM-III-R: Anorexia Nervosa Eating Disorder *;

** AN Criterion A **;

can3ra=1;
if an3c_3=5 then can3ra=5;
else if an1=9 | an3c_3=9 then can3ra=.;

** AN Criterion B **;

can3rb=1;
if an4=5 | an5=5 then can3rb=5;
else if an4=3 | an5=3 then can3rb=3;
else if an1=9 | an4=9 | an5=9 then can3rb=.;

** AN Criterion C **;

can3rc=an2;
if an1=9 | an2=9 then can3rc=.;

** AN Criterion D **;

can3rd=.N;
if dm1=2 & dm3 ge 9 then do;
 can3rd=1;
 if an9=5 then can3rd=5;
 else if an1=9 | an8=9 | an9=9 then can3rd=.;
end;

* Anorexia Nervosa Diagnosis *;

can3r=1;
if dm1=1 | dm3 le 8 then do;
 if can3ra=5 & can3rb=5 & can3rc=5 then can3r=5;
 else if can3ra=5 & can3rb ge 3 & can3rc ge 3 then can3r=3;
 else if can3ra=. |(( can3rb=. | can3rc=.)& can3ra ne 1) then can3r=.;
end;
else if dm1=2 & dm3 ge 9 then do;
 if can3ra=5 & can3rb=5 & can3rc=5 & can3rd=5 then can3r=5;
 else if can3ra=5 & can3rb ge 3 & can3rc ge 3 & can3rd=5 then can3r=3;
 else if can3ra=. |(( can3rb=. | can3rc=. | can3rd=.)& can3ra ne 1) then can3r=.;
end;

label can3ra='Anorexia - Criterion A'
      can3rb='Anorexia - Criterion B'
      can3rc='Anorexia - Criterion C'
      can3rd='Anorexia - Criterion D'
      can3r='Anorexia - Diagnosis'
;
keep  can3ra can3rb can3rc can3r can3r;
***** cbul.sas ***** (3/27/95);

* C-SSAGA DSM-III-R: Bulimia Nervosa Eating Disorder *;

** Bul Criterion A **;

cbu3ra=1;
if bu2a=5 | bu2b=5 then cbu3ra=5;
else if bu2a=3 then cbu3ra=3;
else if bu1a=9 | bu2b=9 then cbu3ra=.;

** Bul Criterion B **;

cbu3rb=bu7;
if cbu3ra=1 then cbu3rb=1;
else if cbu3ra=. | bu7=9 then cbu3rb=.;

** Bul Criterion C **;

cbu3rc=1;
if bu5=5 | bu6=5 then cbu3rc=5;
else if bu5=3 | bu6=3 then cbu3rc=3;
else if cbu3ra=. | bu5=9 | bu6=9 then cbu3rc=.;

** Bul Criterion D **;

cbu3rd=1;
if bu3=5 then cbu3rd=5;
else if cbu3ra=. | bu3=9 then cbu3rd=.;

** Bul Criterion E **;

cbu3re=1;
if bu4a=5 | bu4b=5 then cbu3re=5;
else if bu4a=3 | bu4b=3 then cbu3re=3;
else if cbu3ra=. | bu4a=9 | bu4b=9 then cbu3re=.;

* Bulimia Nervosa Diagnosis *;

cbu3r=1;
if cbu3ra=5 & cbu3rb=5 & cbu3rc=5 & cbu3rd=5 & cbu3re=5 then cbu3r=5;
else if cbu3ra ge 3 & cbu3rb ge 3 & cbu3rc ge 3 & cbu3rd=5 & cbu3re ge 3
 then cbu3r=3;
else if cbu3ra=. | ((cbu3rb=. | cbu3rc=. | cbu3rd=. | cbu3re=.) & cbu3ra ne 1) then cbu3r=.;

label cbu3ra='Bulimia - Criterion A'
      cbu3rb='Bulimia - Criterion B'
      cbu3rc='Bulimia - Criterion C'
      cbu3rd='Bulimia - Criterion D'
      cbu3re='Bulimia - Criterion E'
      cbu3r='Bulimia Diagnosis'
;
keep  cbu3ra cbu3rb cbu3rc cbu3rd cbu3re cbu3r;
***3/27/95 (rev)***;

***** cdrg.sas ***** (3/27/95);

* C-SSAGA DSM-III-R: Psychoactive Substance (Street Drugs) Use Disorder *;

** Street Drugs Dependence **;

*** SD Criterion A ***;

**** SD screener 0 ****;
if sd1_1=5 | sd1_2=5 | sd1_3=5 | sd1_4=5 | sd1_5=5 | sd1_6=5 | sd2=5 | sd3=5
 | sd4=5 then csdscr0=1;
else if sd1_1=1 & sd1_2=1 & sd1_3=1 & sd1_4=1 & sd1_5=1 & sd1_6=1 | sd2=1 |
 sd3=1 | sd4=1 then csdscr0=0;

array sd6a_(6) sd6a_1-sd6a_6;
array sd6b_(6) sd6b_1-sd6b_6;
array sdscr(6) csdscr1-csdscr6;

array sda1_9(6,9) csd3ra11-csd3ra19 csd3ra21-csd3ra29 csd3ra31-csd3ra39
                   csd3ra41-csd3ra49 csd3ra51-csd3ra59 csd3ra61-csd3ra69;
array sds(6) csd3rsx1-csd3rsx6;
array sdm(6) csd3rmx1-csd3rmx6;
array sda(6) csd3ra1-csd3ra6;
array sdb(6) csd3rb1-csd3rb6;
array sdde(6) csd3rde1-csd3rde6;

array sdaa1(6) csd3aa11 csd3aa21 csd3aa31 csd3aa41 csd3aa51 csd3aa61;
array sdaa2(6) csd3aa12 csd3aa22 csd3aa32 csd3aa42 csd3aa52 csd3aa62;
array sdaa(6) csd3raa1-csd3raa6;
array sdba(6) csd3rba1-csd3rba6;
array sdca(6) csd3rca1-csd3rca6;
array sdab(6) csd3rab1-csd3rab6;

array sd12a_(6) sd12a_1-sd12a_6;
array sd12b_(6) sd12b_1-sd12b_6;
array sd13a_(6) sd13a_1-sd13a_6;
array sd13b_(6) sd13b_1-sd13b_6;
array sd9a_(6) sd9a_1-sd9a_6;
array sd9b_(6) sd9b_1-sd9b_6;
array sd9c_(6) sd9c_1-sd9c_6;
array sd11_(6) sd11_1-sd11_6;
array sd14a_(6) sd14a_1-sd14a_6;
array sd14b_(6) sd14b_1-sd14b_6;
array sd15_(6) sd15_1-sd15_6;
array sd16a_(6) sd16a_1-sd16a_6;
array sd16b_(6) sd16b_1-sd16b_6;
array sd17a_(6) sd17a_1-sd17a_6;
array sd17b_(6) sd17b_1-sd17b_6;
array sd10_(6) sd10_1-sd10_6;
array sd18a_(6) sd18a_1-sd18a_6;
array sd18b_(6) sd18b_1-sd18b_6;
array sd18c_(6) sd18c_1-sd18c_6;
array sd18d_(6) sd18d_1-sd18d_6;
array sd18e_(6) sd18e_1-sd18e_6;
array sd20a_(6) sd20a_1-sd20a_6;
array sd20b_(6) sd20b_1-sd20b_6;
array sd20c_(6) sd20c_1-sd20c_6;
array sd20d_(6) sd20d_1-sd20d_6;
array sd20e_(6) sd20e_1-sd20e_6;
array sd20f_(6) sd20f_1-sd20f_6;
array sd21_(6) sd21_1-sd21_6;
array sd8a_(6) sd8a_1-sd8a_6;
array sd8b_(6) sd8b_1-sd8b_6;
array sd22_(16,6) sd22a_1-sd22a_6 sd22b_1-sd22b_6 sd22c_1-sd22c_6
 sd22d_1-sd22d_6 sd22e_1-sd22e_6 sd22f_1-sd22f_6 sd22g_1-sd22g_6
 sd22h_1-sd22h_6 sd22i_1-sd22i_6 sd22j_1-sd22j_6 sd22k_1-sd22k_6
 sd22l_1-sd22l_6 sd22m_1-sd22m_6 sd22n_1-sd22n_6 sd22o_1-sd22o_6
 sd22p_1-sd22p_6;
array sd23_(6) sd23_1-sd23_6;
array sd24_(6) sd24_1-sd24_6;

do i=1 to 6;

 **** SD screener 1-6 ****;
 if sd6a_(i) ge 7 | (1 le sd6b_(i) le 4) then sdscr(i)=1;
 else if csdscr0=0 | (0 le sd6a_(i) le 6) | sd6b_(i)=0 then sdscr(i)=0;

 sda1_9(i,1)=1;  **** symptom group 1 ****;
 if sd12b_(i)=5 | sd13b_(i)=5 then sda1_9(i,1)=5;
 else if sd12a_(i)=9 | sd12b_(i)=9 | sd13a_(i)=9 | sd13b_(i)=9 then
  sda1_9(i,1)=.;

 sda1_9(i,2)=1;  **** symptom group 2 ****;
 if sd9c_(i)=5 | sd9b_(i)=5 then sda1_9(i,2)=5;
 else if sd9a_(i)=9 | sd9b_(i)=9 | sd9c_(i)=9 then sda1_9(i,2)=.;

 sda1_9(i,3)=1;  **** symptom group 3 ****;
 if sd11_(i)=5 then sda1_9(i,3)=5;
 else if sd11_(i)=9 then sda1_9(i,3)=.;

 sda1_9(i,4)=1;  **** symptom group 4 ****;
 if sd14b_(i)=5 | sd15_(i)=5 | sd16b_(i)=5 | sd17b_(i)=5 then sda1_9(i,4)=5;
 else if sd14a_(i)=9 | sd14b_(i)=9 | sd15_(i)=9 | sd16a_(i)=9 | sd16b_(i)=9 |
  sd17a_(i)=9 | sd17b_(i)=9 then sda1_9(i,4)=.;

 sda1_9(i,5)=1;  **** symptom group 5 ****;
 if sd10_(i)=5 then sda1_9(i,5)=5;
 else if sd10_(i)=9 then sda1_9(i,5)=.;

 sda1_9(i,6)=1;  **** symptom group 6 ****;
 if sd18e_(i)=5 | sd20f_(i)=5 | sd21_(i)=5 then sda1_9(i,6)=5;
 else if sd18e_(i)=9 | sd18d_(i)=9 | (sd18d_(i)=. & (sd18a_(i)=9 | sd18b_(i)=9
  | sd18c_(i)=9)) | sd20f_(i)=9 | sd20e_(i)=9 | (sd20e_(i)=. & (sd20a_(i)=9 |
  sd20b_(i)=9 | sd20c_(i)=9 | sd20d_(i)=9)) | sd21_(i)=9 then sda1_9(i,6)=.;

 sda1_9(i,7)=1;  **** symptom group 7 ****;
 if sd8a_(i)=5 | sd8b_(i)=5 then sda1_9(i,7)=5;
 else if sd8a_(i)=9 | sd8b_(i)=9 then sda1_9(i,7)=.;

 sd24_9s=0;
 do j=1 to 16;
  if sd22_(j,i)=9 then sd24_9s+1;
 end;

 sda1_9(i,8)=1;  **** symptom group 8 ****;
 if sd24_(i)=5 then sda1_9(i,8)=5;
 else if sd24_(i)=9 | (sd24_(i)=. & sd24_9s ge 2) then sda1_9(i,8)=.;

 sda1_9(i,9)=1;  **** symptom group 9 ****;
 if sd23_(i)=5 then sda1_9(i,9)=5;
 else if sd23_(i)=9 | sd22_(1,i)=9 | sd22_(2,i)=9 | sd22_(3,i)=9 | sd22_(4,i)=9
  | sd22_(5,i)=9 | sd22_(6,i)=9 | sd22_(7,i)=9 | sd22_(8,i)=9 | sd22_(9,i)=9
  | sd22_(10,i)=9 | sd22_(11,i)=9 | sd22_(12,i)=9 | sd22_(13,i)=9 | sd22_(14,i)=9
  | sd22_(15,i)=9 | sd22_(16,i)=9 then sda1_9(i,9)=.;

 if csdscr0=. | sdscr(i)=. then do j=1 to 9;
  sda1_9(i,j)=.;
 end;

 sds(i)=0; sdm(i)=0;  **** symptom group counts ****;
 do j=1 to 9;
  if sda1_9(i,j)=5 then sds(i)+1;
  else if sda1_9(i,j)=. then sdm(i)+1;
 end;

 sda(i)=1;  *** Criterion A ***;
 if sds(i) ge 3 then sda(i)=5;
 else if sds(i)+sdm(i) ge 3 then sda(i)=.;

 *** SD Criterion B ***;

 sdb(i)=1;
 if sd26b=5 then sdb(i)=5;
 else if sd26b=9 | sdm(i) ge 1 then sdb(i)=.;

 ** Street Drugs Dependence Diagnosis **;

 sdde(i)=1;
 if sda(i)=5 & sdb(i)=5 then sdde(i)=5;
 else if sda(i)=. | (sda(i) ne 1 & sdb(i)=.) then sdde(i)=.;

 ** Street Drugs Abuse **;

 *** SD Criterion A ***;

 sdaa1(i)=sda1_9(i,6);  **** symptom group 1 ****;

 sdaa2(i)=1;  **** symptom group 2 ****;
 if sd16b_(i)=5 | sd17b_(i)=5 then sdaa2(i)=5;
 else if sd16a_(i)=9 | sd16b_(i)=9 | sd17a_(i)=9 | sd17b_(i)=9 then sdaa2(i)=.;

 sdaa(i)=1;  *** Criterion A ***;
 if sdaa1(i)=5 | sdaa2(i)=5 then sdaa(i)=5;
 else if sdaa1(i)=. | sdaa2(i)=. then sdaa(i)=.;

 if csdscr0=. | sdscr(i)=. then do;
  sdaa1(i)=.; sdaa2(i)=.;
 end;

 *** SD Criterion B ***;

 sdba(i)=1;
 if sd26b=5 then sdba(i)=5;
 else if sd26b=9 | (sdaa1(i)=. | sdaa2(i)=.) then sdba(i)=.;

 *** SD Criterion C ***;

 sdca(i)=1;
 if sdde(i)=1 then sdca(i)=5;
 else if sdde(i)=. then sdca(i)=.;

 ** Street Drugs Abuse Diagnosis **;

 sdab(i)=1;
 if sdaa(i)=5 & sdba(i)=5 & sdca(i)=5 then sdab(i)=5;
 else if sdaa(i)=. | (sdaa(i) ne 1 & sdca(i)=.) | (sdaa(i) ne 1 & sdca(i) ne 1
  & sdba(i)=.) then sdab(i)=.;
end;

label csd3ra1='Street Drugs Dependence Criterion A'
      csd3ra2='Street Drugs Dependence Criterion A'
      csd3ra3='Street Drugs Dependence Criterion A'
      csd3ra4='Street Drugs Dependence Criterion A'
      csd3ra5='Street Drugs Dependence Criterion A'
      csd3ra6='Street Drugs Dependence Criterion A'
      csd3rb1='Street Drugs Dependence Criterion B'
      csd3rb2='Street Drugs Dependence Criterion B'
      csd3rb3='Street Drugs Dependence Criterion B'
      csd3rb4='Street Drugs Dependence Criterion B'
      csd3rb5='Street Drugs Dependence Criterion B'
      csd3rb6='Street Drugs Dependence Criterion B'
      csd3rde1='Street Drugs Dependence Diagnosis'
      csd3rde2='Street Drugs Dependence Diagnosis'
      csd3rde3='Street Drugs Dependence Diagnosis'
      csd3rde4='Street Drugs Dependence Diagnosis'
      csd3rde5='Street Drugs Dependence Diagnosis'
      csd3rde6='Street Drugs Dependence Diagnosis'
      csd3raa1='Street Drugs Abuse Criterion A'
      csd3raa2='Street Drugs Abuse Criterion A'
      csd3raa3='Street Drugs Abuse Criterion A'
      csd3raa4='Street Drugs Abuse Criterion A'
      csd3raa5='Street Drugs Abuse Criterion A'
      csd3raa6='Street Drugs Abuse Criterion A'
      csd3rba1='Street Drugs Abuse Criterion B'
      csd3rba2='Street Drugs Abuse Criterion B'
      csd3rba3='Street Drugs Abuse Criterion B'
      csd3rba4='Street Drugs Abuse Criterion B'
      csd3rba5='Street Drugs Abuse Criterion B'
      csd3rba6='Street Drugs Abuse Criterion B'
      csd3rca1='Street Drugs Abuse Criterion C'
      csd3rca2='Street Drugs Abuse Criterion C'
      csd3rca3='Street Drugs Abuse Criterion C'
      csd3rca4='Street Drugs Abuse Criterion C'
      csd3rca5='Street Drugs Abuse Criterion C'
      csd3rca6='Street Drugs Abuse Criterion C'
      csd3rab1='Street Drugs Abuse Diagnosis'
      csd3rab2='Street Drugs Abuse Diagnosis'
      csd3rab3='Street Drugs Abuse Diagnosis'
      csd3rab4='Street Drugs Abuse Diagnosis'
      csd3rab5='Street Drugs Abuse Diagnosis'
      csd3rab6='Street Drugs Abuse Diagnosis'
  ;
keep csd3ra1-csd3ra6 csd3rb1-csd3rb6 csd3rde1-csd3rde6
     csd3raa1-csd3raa6 csd3rba1-csd3rba6 csd3rca1-csd3rca6
     csd3rab1-csd3rab6;
***** cmj.sas ***** (3/27/95);

* C-SSAGA DSM-III-R: Psychoactive Substance (Marijuana) Use Disorder *;

** Marijuana Dependence **;

*** Mj Criterion A ***;

**** Mj screener 1 ****;
if mj1e ge 7 | (1 le mj1f le 4) then cmjscr1=1;
else if mj1a=1 | (0 le mj1e le 6) | mj1f=0 then cmjscr1=0;

cmj3ra1=1;  **** symptom group 1 ****;
if mj6b=5 | mj7b=5 then cmj3ra1=5;
else if mj6a=9 | mj6b=9 | mj7a=9 | mj7b=9 then cmj3ra1=.;

cmj3ra2=1;  **** symptom group 2 ****;
if mj8c=5 | mj8b=5 then cmj3ra2=5;
else if mj8a=9 | mj8b=9 | mj8c=9 then cmj3ra2=.;

cmj3ra3=1;  **** symptom group 3 ****;
if mj20=5 then cmj3ra3=5;
else if mj20=9 then cmj3ra3=.;

cmj3ra4=1;  **** symptom group 4 ****;
if mj14b=5 | mj15=5 | mj16b=5 | mj17b=5 then cmj3ra4=5;
else if mj14a=9 | mj14b=9 | mj15=9 | mj16a=9 | mj16b=9 | mj17a=9 | mj17b=9
 then cmj3ra4=.;

cmj3ra5=1;  **** symptom group 5 ****;
if mj9a=5 | mj9b=5 then cmj3ra5=5;
else if mj9a=9 | mj9b=9 then cmj3ra5=.;

cmj3ra6=1;  **** symptom group 6 ****;
if mj10e=5 | mj12f=5 | mj13b=5 then cmj3ra6=5;
else if mj10e=9 | mj10d=9 | (mj10d=. & (mj10a=9 | mj10b=9 | mj10c=9)) |
 mj12f=9 | mj12e=9 | (mj12e=. & (mj12a=9 | mj12b=9 | mj12c=9 | mj12d=9)) |
 mj13a=9 | mj13b=9 then cmj3ra6=.;

cmj3ra7=1;  **** symptom group 7 ****;
if mj4a=5 | mj4b=5 then cmj3ra7=5;
else if mj4a=9 | mj4b=9 then cmj3ra7=.;

cmj3ra8=1;  **** symptom group 8 ****;
if mj19b=5 then cmj3ra8=5;
else if mj19b=9 | (mj19b=. & ((mj18a_1=9)+(mj18a_2=9)+(mj18a_3=9)+(mj18a_4=9)
 +(mj18a_5=9)+(mj18a_6=9)+(mj18a_7=9) ge 2) | ((mj19a_1=9)+(mj19a_2=9)+(mj19a_3=9)
 + (mj19a_4=9)+(mj19a_5=9)+(mj19a_6=9)+(mj19a_7=9) ge 2)) then cmj3ra8=.;

cmj3ra9=1;  **** symptom group 9 ****;
if mj18b_1=5 | mj18b_2=5 | mj18b_3=5 | mj18b_4=5 | mj18b_5=5 | mj18b_6=5 |
 mj18b_7=5 then cmj3ra9=5;
else if mj18b_1=9 | mj18b_2=9 | mj18b_3=9 | mj18b_4=9 | mj18b_5=9 | mj18b_6=9
 | mj18b_7=9 | mj18a_1=9 | mj18a_2=9 | mj18a_3=9 | mj18a_4=9 | mj18a_5=9 |
 mj18a_6=9 | mj18a_7=9 then cmj3ra9=.;

array rymja cmj3ra1-cmj3ra9;
if cmjscr1=. then do over rymja;
 rymja=.;
end;

cmj3rasx=0; cmj3ramx=0;  **** symptom group counts ****;
do over rymja;
 if rymja=5 then cmj3rasx+1;
 else if rymja=. then cmj3ramx+1;
end;

cmj3ra=1;  *** Criterion A ***;
if cmj3rasx ge 3 then cmj3ra=5;
else if cmj3rasx+cmj3ramx ge 3 then cmj3ra=.;

*** Mj Criterion B ***;

cmj3rb=1;
if mj22b=5 then cmj3rb=5;
else if mj22b=9 | cmj3ramx ge 1 then cmj3rb=.;

** Marijuana Dependence Diagnosis **;

cmj3rde=1;
if cmj3ra=5 & cmj3rb=5 then cmj3rde=5;
else if cmj3ra=. | (cmj3ra ne 1 & cmj3rb=.) then cmj3rde=.;

** Marijuana Abuse **;

*** Mj Criterion A ***;

cmj3raa1=cmj3ra6;  **** symptom group 1 ****;

cmj3raa2=1;  **** symptom group 2 ****;
if mj16b=5 | mj17b=5 then cmj3raa2=5;
else if mj16a=9 | mj16b=9 | mj17a=9 | mj17b=9 then cmj3raa2=.;

if cmjscr1=. then do;
 cmj3raa1=.; cmj3raa2=.;
end;

cmj3raa=1;  *** Criterion A ***;
if cmj3raa1=5 | cmj3raa2=5 then cmj3raa=5;
else if cmj3raa1=. | cmj3raa2=. then cmj3raa=.;

*** Mj Criterion B ***;

cmj3rba=1;
if mj22b=5 then cmj3rba=5;
else if mj22b=9 | (cmj3raa1=. | cmj3raa2=.) then cmj3rba=.;

*** Mj Criterion C ***;

cmj3rca=1;
if cmj3rde=1 then cmj3rca=5;
else if cmj3rde=. then cmj3rca=.;

** Marijuana Abuse Diagnosis **;

cmj3rab=1;
if cmj3raa=5 & cmj3rba=5 & cmj3rca=5 then cmj3rab=5;
else if cmj3raa=. | (cmj3raa ne 1 & cmj3rca=.) | (cmj3raa ne 1 & cmj3rca ne 1
 & cmj3rba=.) then cmj3rab=.;

label cmj3ra='Marijuana Dependence - Criterion A'
      cmj3rb='Marijuana Dependence - Criterion B'
      cmj3rde='Marijuana Dependence - Diagnosis'
      cmj3raa='Marijuana Abuse - Criterion A'
      cmj3rba='Marijuana Abuse - Criterion B'
      cmj3rca='Marijuana Abuse - Criterion C'
      cmj3rab='Marijuana Abuse - Diagnosis'
;
keep cmj3ra cmj3rb cmj3rde cmj3raa
      cmj3rba cmj3rca cmj3rab;
***** cobc.sas ***** (3/27/95);

* C-SSAGA DSM-III-R: Obsessive Compulsive Disorder *;

** Obsessions **;

*** Ob Criterion A ***;

cob3ra1=1;  **** symptom group 1 ****;
if ob1=5 | ob2b=5 | ob3=5 | ob4=5 | ob5=5 then cob3ra1=5;
else if ob1=3 | ob2b=3 | ob3=3 | ob4=3 | ob5=3 then cob3ra1=3;
else if ob1=9 | ob2a=9 | ob2b=9 | ob3=9 | ob4=9 | ob5=9  then cob3ra1=.;

cob3ra2=1;  **** symptom group 2 ****;
if ob6=5 then cob3ra2=5;
else if ob6=3 then cob3ra2=3;
if ob6=9 | cob3ra1=. then cob3ra2=.;  * if vs else if intentional;

cob3ra3=1;  **** symptom group 3 ****;
if ob7=5 then cob3ra3=5;
else if ob7=3 then cob3ra2=3;
if ob7=9 | cob3ra1=. then cob3ra3=.;  * if vs else if intentional;

**** symptom group 4 not assessed ****;

cob3ra=1;  *** Criterion A ***;
if cob3ra1=5 & cob3ra2=5 & cob3ra3=5 then cob3ra=5;
else if cob3ra1 ge 3 & cob3ra2 ge 3 & cob3ra3 ge 3 then cob3ra=3;
else if cob3ra1=. | cob3ra2=. | cob3ra3=. then cob3ra=.;

*** Ob Criterion B ***;

cob3rb=1;
if ob8a=5 | ob8b=2 then cob3rb=5;
else if cob3ra1=. | ob8a=9 | ob8b=9 then cob3rb=.;

** Obsessions Diagnosis **;

cob3r=1;
if cob3ra=5 & cob3rb=5 then cob3r=5;
else if cob3ra=3 & cob3rb=5 then cob3r=3;
else if (cob3ra=. & cob3rb ne 1) | (cob3rb=. & cob3ra ne 1) then cob3r=.;

** Compulsions **;

*** Cp Criterion A ***;

ccp3ra1=1;  **** symptom group 1 ****;
if cp1=5 | cp2b=5 | cp3b=5 then ccp3ra1=5;
else if cp1=3 | cp2b=3 | cp3b=3 then ccp3ra1=3;
else if cp1=9 | cp2a=9 | cp2b=9 | cp3a=9 | cp3b=9 then ccp3ra1=.;

ccp3ra2=1;  **** symptom group 2 ****;
if cp4=5 then ccp3ra2=5;
else if cp4=3 then ccp3ra2=3;
if cp3a=9 | cp3b=9 | ccp3ra1=. then ccp3ra2=.;  * if vs else if intentional;

ccp3ra3=1;  **** symptom group 3 ****;
if cp5a=5 | cp5b=5 then ccp3ra3=5;
else if cp5a=3 | cp5b=3 then ccp3ra3=3;
else if cp5a=9 | cp5b=9 then ccp3ra3=.;
if ccp3ra1=. then ccp3ra3=.;  * if vs else if intentional;

ccp3ra=1;  *** Criterion A ***;
if ccp3ra1=5 & ccp3ra2=5 & ccp3ra3=5 then ccp3ra=5;
else if ccp3ra1 ge 3 & ccp3ra2 ge 3 & ccp3ra3 ge 3 then ccp3ra=3;
else if ccp3ra1=. | ccp3ra2=. | ccp3ra3=. then ccp3ra=.;

*** Cp Criterion B ***;

ccp3rb=1;
if cp6a=5 | cp6b=2 then ccp3rb=5;
else if ccp3ra1=. | cp6a=9 | cp6b=9 then ccp3rb=.;

** Compulsions Diagnosis **;

ccp3r=1;
if ccp3ra=5 & ccp3rb=5 then ccp3r=5;
else if ccp3ra=3 & ccp3rb=5 then ccp3r=3;
else if (ccp3ra=. & ccp3rb ne 1) | (ccp3rb=. & ccp3ra ne 1) then ccp3r=.;

* Obsessive Compulsive Diagnosis *;

coc3r=1;
if cob3r=5 | ccp3r=5 then coc3r=5;
else if cob3r=3 | ccp3r=3 then coc3r=3;
else if cob3r=. | ccp3r=. then coc3r=.;

label cob3ra='Obsession - Criterion A'
      cob3rb='Obsession - Criterion B'
      cob3r='Obsession Diagnosis'
      ccp3ra='Compulsion - Criterion A'
      ccp3rb='Compulsion - Criterion B'
      ccp3r='Compulsion - Diagnosis'
      coc3r='Obsessive Compulsive Diagnosis'
;
keep  cob3ra cob3rb cob3r ccp3ra
      ccp3rb ccp3r
      coc3r
;
***** con.sas (3/27/95) *****;

* C-SSAGA DSM-III-R: Conduct Disorder *;

** CD Criterion A **;

ccd3ra1=1;  *** symptom group 1 ***;
cd3rd=cd3d; cd3rg=cd3g;
if cd3d=9 then cd3rd=.;
if cd3g=9 then cd3rg=.;
ttl=sum(cd3c,cd3rd,cd3f,cd3rg);
if cd3c ge 2 | (2 le cd3d le 5) | cd3f ge 2 | (2 le cd3g le 5) | ttl ge 2 then ccd3ra1=5;
else if cd3a=9 | cd3b=9 | cd3d=9 | cd3e=9 | cd3g=9 then ccd3ra1=.;

ccd3ra2=1;  *** symptom group 2 ***;
if ((cd4b=1 | cd4c=1) & cd4d=1) | cd4b ge 2 | (2 le cd4c le 5) then ccd3ra2=5;
else if cd4a=9 | cd4c=9 | ((cd4b=1 | cd4c=1) & cd4d=9) then ccd3ra2=.;

ccd3ra3=1;  *** symptom group 3 ***;
if (2 le cd5c le 4) then ccd3ra3=5;
else if cd5a=9 | cd5b=9 | cd5c=9 then ccd3ra3=.;

ccd3ra4=1;  *** symptom group 4 ***;
if cd6d ge 3 | (3 le cd6e le 5) then ccd3ra4=5;
else if cd6d ge 1 | (1 le cd6e le 5) then ccd3ra4=3;
else if cd6a=9 | cd6c=9 | cd6e=9 then ccd3ra4=.;

ccd3ra5=1;  *** symptom group 5 ***;
if cd7b ge 3 | (3 le cd7c le 5) | cd8b ge 3 | cd8c=3 then ccd3ra5=5;
else if cd7a=9 | cd7c=9 | cd8a=9 | cd8c=9 then ccd3ra5=.;

ccd3ra6=1;  *** symptom group 6 ***;
if cd9b ge 3 | (3 le cd9c le 5) then ccd3ra6=5;
else if cd9b ge 1 | (1 le cd9c le 5) then ccd3ra6=3;
else if cd9a=9 | cd9c=9 then ccd3ra6=.;

ccd3ra7=1;  *** symptom group 7 ***;
if cd10c ge 3 | (3 le cd10d le 5) then ccd3ra7=5;
else if cd10c ge 1 | (1 le cd10d le 5) then ccd3ra7=3;
else if cd10a=9 | cd10b=9 | cd10d=9 then ccd3ra7=.;

ccd3ra8=1;  *** symptom group 8 ***;
if cd11d ge 2 | (2 le cd11e le 5) then ccd3ra8=5;
else if cd11d ge 1 | (1 le cd11e le 5) then ccd3ra8=3;
else if cd11a=9 | cd11c=9 | cd11e=9 then ccd3ra8=.;

ccd3ra9=1;  *** symptom group 9 ***;
if cd12=5 then ccd3ra9=5;
else if cd12=9 then ccd3ra9=.;

ccd3ra10=1;  *** symptom group 10 ***;
if cd14b ge 2 | (2 le cd14c le 5) then ccd3ra10=5;
else if cd13a=9 | cd14a=9 | cd14c=9 then ccd3ra10=.;

ccd3ra11=1;  *** symptom group 11 ***;
if cd13b ge 3 | (3 le cd13c le 5) then ccd3ra11=5;
else if cd13a=9 | cd13c=9 then ccd3ra11=.;

ccd3ra12=1;  *** symptom group 12 ***;
if cd15b ge 3 | (3 le cd15c le 5) then ccd3ra12=5;
else if cd15b ge 1 | (1 le cd15c le 5) then ccd3ra12=3;
else if cd15a=9 | cd15c=9 then ccd3ra12=.;

ccd3ra13=1;  *** symptom group 13 ***;
if cd16d ge 2 | (2 le cd16e le 5) then ccd3ra13=5;
else if cd16d ge 1 | (1 le cd16e le 5) then ccd3ra13=3;
else if cd16a=9 | cd16c=9 | cd16e=9 then ccd3ra13=.;

ccd3r5sx=0; ccd3r3sx=0; ccd3ramx=0;  *** symptom group counts ***;
array rycda ccd3ra1-ccd3ra13;
do over rycda;
 if rycda=5 then ccd3r5sx+1;
 else if rycda=. then ccd3ramx+1;
 if rycda ge 3 then ccd3r3sx+1;
end;

**Diagnosis with no duration or clusterion
     - just symptom count**;
ccd3ract=1;  *** 3+ symptom groups ***;
if ccd3r5sx ge 3 then ccd3ract=5;
else if ccd3r3sx ge 3 then ccd3ract=3;
else if ccd3r5sx+ccd3ramx ge 3 then ccd3ract=.;

ccd3ra=1;  ** Criterion A **;
if ccd3ract=5 & cd18a=5 & cd18b=5 then ccd3ra=5;
else if ccd3ract=3 & cd18a=5 & cd18b=5 then ccd3ra=3;
else if ccd3ract=. | (cd18a=. & ccd3r5sx ge 2 & ccd3ract ne 1 & cd18b ne 1) |
 (cd18b=. & ccd3ract ne 1 & cd18a ne 1) then ccd3ra=.;

** CD Criterion B not assessed **;

* CD Diagnosis *;

ccd3r=ccd3ra;  * no Criterion B *;

label ccd3ract='ChildConDis - Diag w/3+symptom'
      ccd3ra='ChildConDis Criterion A'
      ccd3r='Child Conduct Disorder'
;
keep  ccd3ract ccd3ra
      ccd3r
;
***** copp.sas *****;

* C-SSAGA DSM-III-R: Oppositional Defiant Disorder *;

** ODD Criterion A **;

array ryopa op1 op2a op3a op4 op6-op9;
array ryopb cop3ra1-cop3ra4 cop3ra6-cop3ra9;

do over ryopa;  *** symptom groups 1-4,6-9;
 ryopb=1;
 if ryopa=5 then ryopb=5;
 else if ryopa=9 then ryopb=.;
end;

cop3ra5=1;  *** symptom group 5 ***;
if op5=2 then cop3ra5=5;
else if op5=9 then cop3ra5=.;

*** ODD screener ***;
if cop3ra1=5 | cop3ra2=5 | cop3ra3=5 | cop3ra4=5 | cop3ra5=5 then copscr1=1;
else if cop3ra1=1 & cop3ra2=1 & cop3ra3=1 & cop3ra4=1 & cop3ra5=1 then
 copscr1=0;

if copscr1=. then do;
 cop3ra6=.; cop3ra7=.; cop3ra8=.; cop3ra9=.;
end;

cop3rasx=0; cop3ramx=0;  *** symptom group counts ***;
array ryopc cop3ra1-cop3ra9;
do over ryopc;
 if ryopc=5 then cop3rasx+1;
 else if ryopc=. then cop3ramx+1;
end;

**Diagnosis without duration or clustering
    - just based on symptom count*;
cop3ract=1;  *** 5+ symptom groups ***;
if cop3rasx ge 5 then cop3ract=5;
else if cop3rasx+cop3ramx ge 5 then cop3ract=.;

cop3ra=1;  ** Criterion A **;
if cop3ract=5 & op10d=5 & op10e=5 then cop3ra=5;
else if cop3ract=. | (op10d=. & cop3ract ne 1 & op10e ne 1) | (op10e=. &
  cop3ract ne 1 & op10d ne 1) then cop3ra=.;

** ODD Criterion B not to be included (WR) **;

* ODD Diagnosis *;

cop3r=cop3ra;  * no Criterion B *;

label cop3ract='ODD -Diag w/5+Symptoms'
      cop3ra='ODD - Criterion A'
      cop3r='ODD - Diagnosis'
;
keep cop3ract cop3ra cop3r;
***** covr.sas ***** (3/27/95 rev);

* C-SSAGA DSM-III-R: Overanxious Disorder *;

** Ov Criterion A **;

array ryova ov2-ov8;
array ryovb cov3ra1-cov3ra7;

do over ryova;  *** symptom groups 1-7 ***;
 ryovb=ryova;
 if ryova=9 then ryovb=.;
end;

*** Ov screener 1 ***;
if cov3ra1 ge 3 | cov3ra2 ge 3 then covscr1=1;
else if cov3ra1=1 & cov3ra2=1 then covscr1=0;

if covscr1=. then do;
 cov3ra3=.; cov3ra4=.; cov3ra5=.; cov3ra6=.; cov3ra7=.;
end;

cov3rsx5=0; cov3rsx3=0; cov3ramx=0;  *** symptom group counts ***;
do over ryovb;
 if ryovb=5 then cov3rsx5+1;
 else if ryovb=. then cov3ramx+1;
 if ryovb ge 3 then cov3rsx3+1;     * if vs else if intentional;
end;

***Diagnosis without duration or clustering
      - just based on symptom count***;
cov3rct5=1; cov3rct3=1;  ** 4+ symptom groups **;
if cov3rsx5 ge 4 then cov3rct5=5;
else if cov3rsx5+cov3ramx ge 4 then cov3rct5=.;
if cov3rsx3 ge 4 then cov3rct3=5;
else if cov3rsx3+cov3ramx ge 4 then cov3rct3=.;

cov3ra5=1; cov3ra3=1;  ** Criterion A **;
if cov3rct5=5 & ov10a=5 & ov10b=5 then cov3ra5=5;
else if cov3rct5=. | (ov10a=. & cov3rct5 ne 1 & ov10b ne 1) | (ov10b=. &
 cov3rct5 ne 1 & ov10a ne 1) then cov3ra5=.;
if cov3rct3=5 & ov10a=5 & ov10b=5 then cov3ra3=5;
else if cov3rct3=. | (ov10a=. & cov3rct3 ne 1 & ov10b ne 1) | (ov10b=. &
 cov3rct3 ne 1 & ov10a ne 1) then cov3ra3=.;

** Ov Criterion B, C, D not assessed **;

* Overaxious Diagnosis *;

cov3r=1;
if cov3ra5=5 then cov3r=5;
else if cov3ra3=5 then cov3r=3;
else if ov2=1 & ov3=1 then cov3r=1;
else if cov3ra5=. | cov3ra3=. then cov3r=.;

label cov3rct5='OvrAnx 4+symptoms, no alc/drg use'
      cov3rct3='OvrAnx 4+symptoms, alc/drg use'
      cov3ra5='OvrAnx Criterion A - No alc/drg use'
      cov3ra3='OvrAnx Criterion A - Alc/drg use'
      cov3r='Overanxious Diagnosis'
;
keep  cov3rct5
      cov3rct3
      cov3ra5
      cov3ra3
      cov3r
;
***** cpsy.sas ***** (3/27/95);

* C-SSAGA Psychotic Symptoms *;

** Psychotic Sx Criterion A **;

array rypsa ps4 ps5 ps6;
array rypsb cps3ra3-cps3ra5;

do over rypsa;  *** symptom groups 3-5 ***;
 rypsb=1;
 if rypsa=5 then rypsb=5;
 else if rypsa=3 then rypsb=3;
 else if rypsa=9 then rypsb=.;
end;

cps3ra1=1;  *** symptom group 1 ***;
if ps1a=5 & ps1c=1 then cps3ra1=5;
else if ps1a ge 3 & ps1c=1 then cps3ra1=3;
else if ps1a=9 | ps1c=9 then cps3ra1=.;

cps3ra2=1;  *** symptom group 2 ***;
if ps2a=5 | ps3=5 then cps3ra2=5;
else if ps2a=3 | ps3=3 then cps3ra2=3;
else if ps2a=9 | ps3=9 then cps3ra2=.;

cps3ra6=1;  *** symptom group 6 ***;
if ps7=5 | ps8=5 | ps9=5 | ps10=5 | ps11=5 | ps12=5 then cps3ra6=5;
else if ps7=3 | ps8=3 | ps9=3 | ps10=3 | ps11=3 | ps12=3 then cps3ra6=3;
else if ps7=9 | ps8=9 | ps9=9 | ps10=9 | ps11=9 | ps12=9 then cps3ra6=.;

cps3rsx5=0; cps3rsx3=0; cps3ramx=0;  *** symptom group counts ***;
array rypsc cps3ra1-cps3ra6;
do over rypsc;
 if rypsc=5 then cps3rsx5+1;
 else if rypsc=. then cps3ramx+1;
 if rypsc ge 3 then cps3rsx3+1;  * if vs else if intentional;
end;

cps3ra=1;  *** Criterion A ***;
if cps3rsx5 ge 1 then cps3ra=5;
else if cps3rsx3 ge 1 then cps3ra=3;
else if cps3ramx ge 1 then cps3ra=.;

** Other Psychotic Criteria not assessed **;

* Psychotic Sx Diagnosis *;

cps3r=cps3ra; * no other criteria;

label cps3ra='Psychotic Symptoms - Criterion A'
      cps3r='Psychotic Sx Diagnosis'
;
keep  cps3ra cps3r
;
***** csep.sas ***** (3/27/95 rev);

* C-SSAGA DSM-III-R: Separation Anxiety Disorder *;

** Sep Criterion A **;

array rysaa sa1-sa3 sa6 sa9 sa10;
array rysab csa3ra1-csa3ra3 csa3ra5-csa3ra7;

do over rysaa;  *** symptom groups 1-3,5-7 ***;
 rysab=rysaa;
 if rysaa=9 then rysab=.;
end;

csa3ra4=1;  *** symptom group 4 ***;
if sa4=5 | sa5=5 then csa3ra4=5;
else if sa4=3 | sa5=3 then csa3ra4=3;
else if sa4=9 | sa5=9 then csa3ra4=.;

csa3ra8=1;  *** symptom group 8 ***;
if sa11a=5 | sa11b=5 then csa3ra8=5;
else if sa11a=3 | sa11b=3 then csa3ra8=3;
else if sa11a=9 | sa11b=9 then csa3ra8=.;

csa3ra9=1;  *** symptom group 9 ***;
if sa7=5 | sa8a=5 | sa8b=5 then csa3ra9=5;
else if sa7=3 | sa8a=3 | sa8b=3 then csa3ra9=3;
else if sa7=9 | sa8a=9 | sa8b=9 then csa3ra9=.;

*** Sep screener 1 ***;
if sa1 ge 3 | sa2 ge 3 | sa3 ge 3 | sa4 ge 3 | sa5 ge 3 then csascr1=1;
else if sa1=1 & sa2=1 & sa3=1 & sa4=1 & sa5=1 then csascr1=0;

if csascr1=. then do;
 csa3ra5=.; csa3ra6=.; csa3ra7=.; csa3ra8=.; csa3ra9=.;
end;

csa3rsx5=0; csa3rsx3=0; csa3ramx=0;  *** symptom group counts ***;
array rysac csa3ra1-csa3ra9;
do over rysac;
 if rysac=5 then csa3rsx5+1;
 else if rysac=. then csa3ramx+1;
 if rysac ge 3 then csa3rsx3+1;
end;

  **Diagnosis without duration and clustering
       - just symptom count > 3**;
csa3ra5=1; csa3ra3=1;  ** Criterion A **;
if csa3rsx5 ge 3 then csa3ra5=5;
else if csa3rsx5+csa3ramx ge 3 then csa3ra5=.;
if csa3rsx3 ge 3 then csa3ra3=5;
else if csa3rsx3+csa3ramx ge 3 then csa3ra3=.;

** Criterion B **;

csa3rb=1;
if sa13=5 then csa3rb=5;
else if sa13=9 | csa3ramx ge 1 then csa3rb=.;

** Criterion C **;

csa3rc=1;
if (1 le sa12a le 17)|(1 le dm3 lt 18) then csa3rc=5;
else if dm3=-9 | (dm3 ge 18 & sa12a=-9) then csa3rc=.;

** Criterion D not assessed **;

* Separation Anxiety Diagnosis *;

csa3r=1;
if csa3ra5=5 & csa3rb=5 & csa3rc=5 then csa3r=5;
else if csa3ra3=5 & csa3rb=5 & csa3rc=5 then csa3r=3;
else if csascr1=0 then csa3r=1;
else if csa3ra3=. | ((csa3rb=. | csa3rc=.) & csa3ra3 ne 1) then csa3r=.;

label csa3ra5='SepAnx Crit.A & Diag w/3+Symp-no alc/drg'
      csa3ra3='SepAnx Crit.A & Diag w/3+Symp-alc/drg'
      csa3rb='SepAnx Criterion B'
      csa3rc='SepAnx Criterion C'
      csa3r='Separation Anxiety Diagnosis'
;
keep  csa3ra5
      csa3ra3
      csa3rb
      csa3rc
      csa3r
;
***** csom.sas ***** (3/27/95);

* C-SSAGA DSM-III-R: Somatization Disorder *;

** Som Criterion A **;

csm3ra=1;
if sm1=5 | sm2=5 then csm3ra=5;
else if sm1=9 | sm2=9 then csm3ra=.;
else if sm1=3 | sm2=3 then csm3ra=3;

** Som Criterion B **;

array rysma sm3 sm4a sm4b sm4c sm4d sm4e;
array rysmb sm5 sm6a sm6b sm6c sm6d;
array rysmc sm7 sm8a sm8b sm8c;
array rysmd sm9 sm10 sm11a sm11b sm11c sm11d sm11e sm11f sm11g sm11h sm11i sm11j;
array rysme sm12b sm12c sm12d;

csm3rsx5=0; csm3rsx3=0; csm3rbmx=0;  *** symptom group counts ***;
do over rysma;
 if sm3=9 then csm3rbmx+1;
 else if rysma=5 then csm3rsx5+1;
 else if rysma=9 then csm3rbmx+1;
 if sm3 ne 9 & (rysma=3 | rysma=5) then csm3rsx3+1;  * if vs else if intentional;
end;

do over rysmb;
 if sm5=9 then csm3rbmx+1;
 else if rysmb=5 then csm3rsx5+1;
 else if rysmb=9 then csm3rbmx+1;
 if sm5 ne 9 & (rysmb=3 | rysmb=5) then csm3rsx3+1;  * if vs else if intentional;
end;

do over rysmc;
 if sm7=9 then csm3rbmx+1;
 else if rysmc=5 then csm3rsx5+1;
 else if rysmc=9 then csm3rbmx+1;
 if sm7 ne 9 & (rysmc=3 | rysmc=5) then csm3rsx3+1;  * if vs else if intentional;
end;

do over rysmd;
 if sm9=9 & sm10=9 then csm3rbmx+1;
 else if rysmd=5 then csm3rsx5+1;
 else if rysmd=9 then csm3rbmx+1;
 if (sm9 ne 9 | sm10 ne 9) & (rysmd=3 | rysmd=5) then csm3rsx3+1;
end;

if dm1=2 & dm3 ge 9 then do over rysme;
 if sm12a=9 | sm12b=9 then csm3rbmx+1;
 else if rysme=5 then csm3rsx5+1;
 else if rysme=9 then csm3rbmx+1;
 if sm12a ne 9 & sm12b ne 9 & (rysme=3 | rysme=5) then csm3rsx3+1;
end;

csm3rb5=1; csm3rb3=1;  ** Criterion B **;
if csm3rsx5 ge 13 then csm3rb5=5;
else if csm3rsx5+csm3rbmx ge 13 then csm3rb5=.;
if csm3rsx3 ge 13 then csm3rb3=5;
else if csm3rsx3+csm3rbmx ge 13 then csm3rb3=.;

* Somatization Diagnosis *;

csm3r=1;
if csm3ra=5 & csm3rb5=5 then csm3r=5;
else if csm3ra=. | csm3rb5=. then csm3r=.;
else if csm3ra=5 & csm3rb3=5 then csm3r=3;
else if csm3rb3=. then csm3r=.;

label csm3ra='Somatization - Criterion A'
      csm3rb5='Somat. - Criterion B - no alc/drg use'
      csm3rb3='Somat. - Criterion B - alc/drg use'
      csm3r='Somatization Diagnosis'
;
keep  csm3ra
      csm3rb5
      csm3rb3
      csm3r
;
***3/27/95 (rev)***;

***** cdep.sas *****;

* C-SSAGA DSM-III-R: Major Depressive Episode *;

** MD screeners **;

*** MD screener 1 (current scr) ***;
if (md2a=5 | md2b=5 | md2c=5 | md2d=5 | md2e=5) & md3a=5 then cmdscr1=1;
else if (md2a=1 & md2b=1 & md2c=1 & md2d=1 & md2e=1) | md3a=1 then cmdscr1=0;

*** MD screener 2 (other time scr) ***;
if (md6a=5 | md6b=5 | md6c=5 | md6d=5 | md6e=5) & md7a=5 then cmdscr2=1;
else if (md6a=1 & md6b=1 & md6c=1 & md6d=1 & md6e=1) | md7a=1 then cmdscr2=0;


*** MD screener 4 (current clean scr) ***;
if md4a=1 & (md4b=1 | (md4b=5 & (md4c=1 | md4c=2))) & md4e=1 then cmdscr4=1;
else if md4a=5 | (md4b=5 & (3 ge md4c ge 998)) | md4e=5 then cmdscr4=0;

*** MD screener 5 (other time 1 clean scr) ***;
if md10a=1 & (md10b=1 | (md10b=5 & (md10c=1 | md10c=2))) & md10e=1 then
 cmdscr5=1;
else if md10a=5 | (md10b=5 & (3 ge md10c ge 998)) | md10e=5 then cmdscr5=0;

*** MD screener 6 (other time 2 clean scr) ***;
if cmdscr5 ne 1 & md12a=5 & md12d=1 then cmdscr6=1;
else if md12a=1 | md12d=5 then cmdscr6=0;

** Major Depressive Episodes **;

*** MD Criterion A (current) ***;

  **** symptom group 1 ****;
if md3b=5 then cmdc3ra1=5;
else if (md2a=1 & md2b=1 & md2e=1) | md3b=1 | md3a=1 then cmdc3ra1=1;

  **** symptom group 2 ****;
if md3c=5 then cmdc3ra2=5;
else if (md2c=1 & md2d=1) | md3c=1 | md3a=1 then cmdc3ra2=1;

cmdc3ra3=1;  **** symptom group 3 ****;
if mda_19b=5 | mda_20b=5 | mda_19a=5 | mda_20a=5 then cmdc3ra3=5;
else if mda_19a=9 | mda_19b=9 | mda_20a=9 | mda_20b=9 then cmdc3ra3=.;

cmdc3ra4=1;  **** symptom group 4 ****;
if mda_21a=5 | mda_21b=5 | mda_21c=5 | mda_21d=5 then cmdc3ra4=5;
else if mda_21a=9 | mda_21b=9 | mda_21c=9 | mda_21d=9 then cmdc3ra4=.;

cmdc3ra5=1;  **** symptom group 5 ****;
if mda_22=5 | mda_23=5 then cmdc3ra5=5;
else if mda_22=9 | mda_23=9 then cmdc3ra5=.;

cmdc3ra6=1;  **** symptom group 6 ****;
if mda_24=5 then cmdc3ra6=5;
else if mda_24=9 then cmdc3ra6=.;

cmdc3ra7=1;  **** symptom group 7 ****;
if mda_25=5 | mda_26=5 then cmdc3ra7=5;
else if mda_25=9 | mda_26=9 then cmdc3ra7=.;

cmdc3ra8=1;  **** symptom group 8 ****;
if mda_27a=5 | mda_27b=5 | mda_28a=5 | mda_28b=5 then cmdc3ra8=5;
else if mda_27a=9 | mda_27b=9 | mda_28a=9 | mda_28b=9 then cmdc3ra8=.;

cmdc3ra9=1;  **** symptom group 9 ****;
if mda_29a=5 | mda_29b=5 | mda_29c=5 | mda_29d=5 then cmdc3ra9=5;
else if mda_29a=9 | mda_29b=9 | mda_29c=9 | mda_29d=9 then cmdc3ra9=.;


*** MD Criterion A (other time) ***;

  **** symptom group 1 ****;
if md7b=5 | md12b=5 then cmdp3ra1=5;
else if (md6a=1 & md6b=1 & md6c=1) | md7b=1 | md12b=1 then cmdp3ra1=1;

  **** symptom group 2 ****;
if md7c=5 | md12c=5 then cmdp3ra2=5;
else if (md6d=1 & md6e=1) | md7c=1 | md12c=1 then cmdp3ra2=1;

cmdp3ra3=1;  **** symptom group 3 ****;
if mdb_19a=5 | mdb_19b=5 | mdb_20a=5 | mdb_20b=5 then cmdp3ra3=5;
else if mdb_19a=9 | mdb_19b=9 | mdb_20a=9 | mdb_20b=9 then cmdp3ra3=.;

cmdp3ra4=1;  **** symptom group 4 ****;
if mdb_21a=5 | mdb_21b=5 | mdb_21c=5 | mdb_21d=5 then cmdp3ra4=5;
else if mdb_21a=9 | mdb_21b=9 | mdb_21c=9 | mdb_21d=9 then cmdp3ra4=.;

cmdp3ra5=1;  **** symptom group 5 ****;
if mdb_22=5 | mdb_23=5 then cmdp3ra5=5;
else if mdb_22=9 | mdb_23=9 then cmdp3ra5=.;

cmdp3ra6=1;  **** symptom group 6 ****;
if mdb_24=5 then cmdp3ra6=5;
else if mdb_24=9 then cmdp3ra6=.;

cmdp3ra7=1;  **** symptom group 7 ****;
if mdb_25=5 | mdb_26=5 then cmdp3ra7=5;
else if mdb_25=9 | mdb_26=9 then cmdp3ra7=.;

cmdp3ra8=1;  **** symptom group 8 ****;
if mdb_27a=5 | mdb_27b=5 | mdb_28a=5 | mdb_28b=5 then cmdp3ra8=5;
else if mdb_27a=9 | mdb_27b=9 | mdb_28a=9 | mdb_28b=9 then cmdp3ra8=.;

cmdp3ra9=1;  **** symptom group 9 ****;
if mdb_29a=5 | mdb_29b=5 | mdb_29c=5 | mdb_29d=5 then cmdp3ra9=5;
else if mdb_29a=9 | mdb_29b=9 | mdb_29c=9 | mdb_29d=9 then cmdp3ra9=.;

cur_past=0;
array rymda cmdc3ra1-cmdc3ra9;
array rymdb cmdp3ra1-cmdp3ra9;
if (cmdscr1=1 & cmdscr2 ne 1) | (cmdscr4=1 & cmdscr5 ne 1 & cmdscr6 ne 1) then
do over rymda;
 if _I_ le 2 then rymdb=rymda;
 cur_past=1;
 if _I_ gt 2 & rymda=5 then rymdb=rymda;
 if _I_ gt 2 then rymda=.;
 if cmdscr1=. then rymda=.;
end;

cmdc3rsx=0; cmdc3rmx=0;  **** symptom group counts (current) ****;
do over rymda;
 if rymda=5 then cmdc3rsx+1;
 else if rymda=. then cmdc3rmx+1;
end;

cmdc3rac=1;  **** 5+ symptom groups *****;
if cmdc3rsx ge 5 then cmdc3rac=5;
else if cmdc3rsx+cmdc3rmx ge 5 then cmdc3rac=.;

cmdc3ra=1;  *** Criterion A ***;
if cmdc3rac=5 & (cmdc3ra1=5 | cmdc3ra2=5) & mda_30b=5 then cmdc3ra=5;
else if (cmdc3rac=. & (cmdc3ra1 ne 1 | cmdc3ra2 ne 1)) | (cmdc3rac ne . &
 ((cmdc3ra1=. & cmdc3ra2 ne 5) | (cmdc3ra1 ne 5 & cmdc3ra2=.))) |
 (cmdc3rac ne 1 & (cmdc3ra1 ne 1 | cmdc3ra1 ne 1) & mda_30b=9) then cmdc3ra=.;

*** MD Criterion B ***;

cmdc3rb1=1;  **** B group 1 (alc & drug)****;
if mda_31c=5 | cmdscr4=0 then cmdc3rb1=5;
else if mda_31c=9 & cmdscr4 = . then cmdc3rb1=.;

cmdc3rb2=1;  **** B group 2 (bereavement)****;
if mda_31a=5 then cmdc3rb2=5;
else if mda_31a=9 then cmdc3rb2=.;

cmdc3rb3=1;  **** B group 3 (illness/injury)****;
if mda_31b=5 then cmdc3rb3=5;
else if mda_31b=9 then cmdc3rb3=.;

cmdc3rb=1;  *** Criterion B ***;
if cmdc3rb1=1 & cmdc3rb2=1 & cmdc3rb3=1 then cmdc3rb=5;
else if cmdc3rb1=. | cmdc3rb2=. | cmdc3rb3=. then cmdc3rb=.;

** Current Depressive Episode Diagnosis **;

cmdc3r=1;
if cmdc3ra=5 & cmdc3rb=5 then cmdc3r=5;
else if cmdc3ra=5 & cmdc3rb1=5 then cmdc3r=4; *alc&drg*;
else if cmdc3ra=5 & cmdc3rb2=5 then cmdc3r=3; *bereavement*;
else if cmdc3ra=5 & cmdc3rb3=5 then cmdc3r=2; *illness/injury*;
else if cmdc3ra=. | (cmdc3rb=. & cmdc3ra ne 1) then cmdc3r=.;

cmdp3rsx=0; cmdp3rmx=0;  **** symptom group counts (other time) ****;
do over rymdb;
 if rymdb=5 then cmdp3rsx+1;
 else if rymdb=. then cmdp3rmx+1;
end;

cmdp3rac=1;  **** 5+ symptom groups *****;
if cmdp3rsx ge 5 then cmdp3rac=5;
else if cmdp3rsx+cmdp3rmx ge 5 then cmdp3rac=.;

cmdp3ra=1;  *** Criterion A ***;
if cmdp3rac=5 & (cmdp3ra1=5 | cmdp3ra2=5) & mdb_30b=5 then cmdp3ra=5;
else if (cmdp3rac=. & (cmdp3ra1 ne 1 | cmdp3ra2 ne 1)) | (cmdp3rac ne . &
 ((cmdp3ra1=. & cmdp3ra2 ne 5) | (cmdp3ra1 ne 5 & cmdp3ra2=.))) |
 (cmdp3rac ne 1 & (cmdp3ra1 ne 1 | cmdp3ra1 ne 1) & mdb_30b=9) then cmdp3ra=.;

*** MD Criterion B ***;

cmdp3rb1=1;  **** B group 1 (alc&drug)****;
if mdb_31c=5 | cmdscr5=0 | cmdscr6=0 then cmdp3rb1=5;
else if cur_past=1 & (cmdscr4=0 | mda_31c=5) then cmdp3rb1=5;
else if mdb_31c=9 & cmdscr5=. & cmdscr6=. then cmdp3rb1=.;
else if cur_past=1 & cmdscr4=. & mda_31c=9 then cmdp3rb1=.;

cmdp3rb2=1;  **** B group 2 (bereavement)****;
if mdb_31a=5 then cmdp3rb2=5;
else if cur_past=1 & mda_31a=5 then cmdp3rb2=5;
else if mdb_31a=9 then cmdp3rb2=.;

cmdp3rb3=1;  **** B group 3 (illness/injury)****;
if mdb_31b=5 then cmdp3rb3=5;
else if cur_past=1 & mda_31b=5 then cmdp3rb3=5;
else if mdb_31b=9 then cmdp3rb3=.;

cmdp3rb=1;  *** Criterion B ***;
if cmdp3rb1=1 & cmdp3rb2=1 & cmdp3rb3=1 then cmdp3rb=5;
else if cmdp3rb1=. | cmdp3rb2=. | cmdp3rb3=. then cmdp3rb=.;

** Other Time Depressive Episode Diagnosis **;

cmdp3r=1;
if cmdp3ra=5 & cmdp3rb=5 then cmdp3r=5;
else if cmdp3ra=5 & cmdp3rb1=5 then cmdp3r=4; *alc&drug*;
else if cmdp3ra=5 & cmdp3rb2=5 then cmdp3r=3; *bereavement*;
else if cmdp3ra=5 & cmdp3rb3=5 then cmdp3r=2; *injury/illness*;
else if cmdp3ra=. | (cmdp3rb=.& cmdp3ra ne 1) then cmdp3r=.;

label cmdc3ra='Cur. Depression, Crit. A'
      cmdc3rb1='Cur. Depression,Crit. B-Alc&Drug use'
      cmdc3rb2='Cur. Depres. Crit.B-bereavement'
      cmdc3rb3='Cur. Depres. Crit.B-illness/injury'
      cmdc3rb='Cur.Depres. Crit.B-No other factors'
      cmdc3r='Cur. Depres. Diagnosis'
      cmdp3ra='Past Depression, Crit. A'
      cmdp3rb1='Past Depression,Crit. B-Alc&Drug use'
      cmdp3rb2='Past Depres. Crit.B-bereavement'
      cmdp3rb3='Past Depres. Crit.B-illness/injury'
      cmdp3rb='Past Depres. Crit.B-No other factors'
      cmdp3r='Past Depres. Diagnosis'
;
keep  cmdc3ra
      cmdc3rb1
      cmdc3rb2
      cmdc3rb3
      cmdc3rb
      cmdc3r
      cmdp3ra
      cmdp3rb1
      cmdp3rb2
      cmdp3rb3
      cmdp3rb
      cmdp3r
;

** Additional Dirty episodes of Depression**;

*** MD Criterion A **;

***symptom 1 & 2 ***;
cmdd3ra1=1; cmdd3ra2=1;  **** symptom group 1 & 2 ****;
if md35a=5 then cmdd3ra1=5 ;
else if md35a=9 then cmdd3ra1=.;
if md35a=5 then cmdd3ra2=5 ;
else if md35a=9 then cmdd3ra2=.;

cmdd3ra3=1;  **** symptom group 3 ****;
if md35c_1=5 | md35c_2=5 then cmdd3ra3=5;
else if md35c_1=9 | md35c_2=9 then cmdd3ra3=.;

cmdd3ra4=1;  **** symptom group 4 ****;
if md35c_3=5 then cmdd3ra4=5;
else if md35c_3=9 then cmdd3ra4=.;

cmdd3ra5=1;  **** symptom group 5 ****;
if md35c_4=5 | md35c_5=5 then cmdd3ra5=5;
else if md35c_4=9 | md35c_5=9 then cmdd3ra5=.;

cmdd3ra6=1;  **** symptom group 6 ****;
if md35c_6=5 then cmdd3ra6=5;
else if md35c_6=9 then cmdd3ra6=.;

cmdd3ra7=1;  **** symptom group 7 ****;
if md35c_7=5 then cmdd3ra7=5;
else if md35c_7=9 then cmdd3ra7=.;

cmdd3ra8=1;  **** symptom group 8 ****;
if md35c_8=5 | md35c_9=5 then cmdd3ra8=5;
else if md35c_8=9 | md35c_9=9 then cmdd3ra8=.;

cmdd3ra9=1;  **** symptom group 9 ****;
if md35c_10=5 then cmdd3ra9=5;
else if md35c_10=9 then cmdd3ra9=.;

array rymdd cmdd3ra1-cmdd3ra9;

cmdd3rsx=0; cmdd3rmx=0;  **** symptom group counts ****;
do over rymdd;
 if rymdd=5 then cmdd3rsx+1;
 else if rymdd=. then cmdd3rmx+1;
end;

cmdd3rac=1;  **** 5+ symptom groups *****;
if cmdd3rsx ge 5 then cmdd3rac=5;
else if cmdd3rsx+cmdd3rmx ge 5 then cmdd3rac=.;

cmdd3ra=1;  *** Criterion A ***;
if cmdd3rac=5 & (cmdd3ra1=5 | cmdd3ra2=5) & md35d=5 then cmdd3ra=5;
else if (cmdd3rac=. & (cmdd3ra1 ne 1 | cmdd3ra2 ne 1))
 | md35d=9 then cmdd3ra=.;

*** Criterion B not assessed - It is dirty ***;

**** MD - Dirty diagnoses **** ;

cmdd3r=cmdd3ra;


** Other clean episodes of Depression**;

*** MD Criterion A **;

***symptom 1 & 2 ***;
cmdo3ra1=1; cmdl3ra2=1;  **** symptom group 1 & 2 ****;
if md36a=5 then cmdo3ra1=5 ;
else if md36a=9 then cmdo3ra1=.;
if md36a=5 then cmdo3ra2=5;
else if md36a=9 then cmdo3ra2=.;

cmdo3ra3=1;  **** symptom group 3 ****;
if md36c_1=5 | md36c_2=5 then cmdo3ra3=5;
else if md36c_1=9 | md36c_2=9 then cmdo3ra3=.;

cmdo3ra4=1;  **** symptom group 4 ****;
if md36c_3=5 then cmdo3ra4=5;
else if md36c_3=9 then cmdo3ra4=.;

cmdo3ra5=1;  **** symptom group 5 ****;
if md36c_4=5 | md36c_5=5 then cmdo3ra5=5;
else if md36c_4=9 | md36c_5=9 then cmdo3ra5=.;

cmdo3ra6=1;  **** symptom group 6 ****;
if md36c_6=5 then cmdo3ra6=5;
else if md36c_6=9 then cmdo3ra6=.;

cmdo3ra7=1;  **** symptom group 7 ****;
if md36c_7=5 then cmdo3ra7=5;
else if md36c_7=9 then cmdo3ra7=.;

cmdo3ra8=1;  **** symptom group 8 ****;
if md36c_8=5 | md36c_9=5 then cmdo3ra8=5;
else if md36c_8=9 | md36c_9=9 then cmdo3ra8=.;

cmdo3ra9=1;  **** symptom group 9 ****;
if md36c_10=5 then cmdo3ra9=5;
else if md36c_10=9 then cmdo3ra9=.;

array rymdo cmdo3ra1-cmdo3ra9;

cmdo3rsx=0; cmdo3rmx=0;  **** symptom group counts ****;
do over rymdo;
 if rymdo=5 then cmdo3rsx+1;
 else if rymdo=. then cmdo3rmx+1;
end;

cmdo3rac=1;  **** 5+ symptom groups *****;
if cmdo3rsx ge 5 then cmdo3rac=5;
else if cmdo3rsx+cmdo3rmx ge 5 then cmdo3rac=.;

cmdo3ra=1;  *** Criterion A ***;
if cmdo3rac=5 & (cmdo3ra1=5 | cmdo3ra2=5) & md36d=5 then cmdo3ra=5;
else if (cmdo3rac=. & (cmdo3ra1 ne 1 | cmdo3ra2 ne 1 ))
 | md36d=9 then cmdo3ra=.;

*** Criterion B not assessed - It is clean ***;

****Other MD - diagnoses **** ;

cmdo3r=cmdo3ra;

label cmdd3ra='Additional Dirty MD - Criterion A'
      cmdo3ra='Other clean MD - Criterion A'
      cmdd3r='MD Diagnosis - Dirty'
      cmdo3r='Other MD clean Diagnosis'
;
keep  cmdd3ra
      cmdo3ra
      cmdd3r
      cmdo3r
;

%include './heic.include';
   array heic_ry(8) activ time discip roles rules peers sibling heic;
   array cheic_ry(8) cactiv ctime cdiscip croles
                    crules cpeers csibling cheic;
   do i=1 to 8; cheic_ry(i)=heic_ry(i);end;
   keep cactiv ctime cdiscip croles crules cpeers csibling cheic;
   label
      cactiv='School and other activities'
      ctime='Parents time spent with child'
      cdiscip='Discipline'
      croles='Adults as role models'
      crules='Family rules'
      cpeers='Peer relations'
      csibling='Sibling network'
      cheic='Total score on Home environment'
          ;
%include './sarah.include';
      csar_ev=sarahev;
      csar_now=sarahnow;
      label csar_now='sarah score,now';
      label csar_ev='sarah score,ever';
      keep csar_ev csar_now;
run;
