libname mf72 '/more/coga/mf/mf72';
data mf72.dx_psaga;set mf72.pssaga;
   length default=3;
   length ind_id pind_id 8;
   length big_idc $ 16;
   keep ind_id pind_id big_idc;
   *** al25a_1-al25a_9 removed NSR;
***** cadh.sas ***** (3/27/95) ;
* C-SSAGA DSM-III-R: Attention Deficit-Hyperactivity Disorder *;

** ADHD Criterion A **;

array ryada at1_1 at2_1 at3_1 at4_1 at5_1 at6_1 at8_1 at9_1 at10_1 at11_1
 at12_1 at13_1 at14_1;
array ryadb pat3ra1-pat3ra6 pat3ra8-pat3ra14;

do over ryada;  *** symptom groups 1-6,8-14 ***;
 ryadb=1;
 if ryada=5 then ryadb=5;
 else if ryada=9 then ryadb=.;
end;

pat3ra7=1;  *** symptom group 7 ***;
if at7a_1=5 | at7b_1=5 then pat3ra7=5;
else if at7a_1=9 | at7b_1=9 then pat3ra7=.;

*** ADHD screener 1 ***;
if pat3ra1=5 | pat3ra2=5 | pat3ra3=5 | pat3ra4=5 | pat3ra5=5 | pat3ra6=5 |
 pat3ra7=5 | pat3ra8=5 then patscr1=1;
else if pat3ra1=1 & pat3ra2=1 & pat3ra3=1 & pat3ra4=1 & pat3ra5=1 &
 pat3ra6=1 & pat3ra7=1 & pat3ra8=1 then patscr1=0;

if patscr1=. then do;
 pat3ra9=.; pat3ra10=.; pat3ra11=.; pat3ra12=.; pat3ra13=.; pat3ra14=.;
end;

pat3rasx=0; pat3ramx=0;  *** symptom group counts ***;
array ryadc pat3ra1-pat3ra14;
do over ryadc;
 if ryadc=5 then pat3rasx+1;
 else if ryadc=. then pat3ramx+1;
end;

**Diagnosis without duration or clustering
    - just symptom count**;
pat3ract=1;  *** 8+ symptom groups ***;
if pat3rasx ge 8 then pat3ract=5;
else if pat3rasx+pat3ramx ge 8 then pat3ract=.;

patscr2=0;  *** ADHD screener 2 ***;
if pat3rasx ge 4 then patscr2=1;
else if pat3rasx+pat3ramx ge 4 then patscr2=.;

pat3ra=1;  ** Criterion A **;
if pat3ract=5 & at15d=5 & at15e=5 then pat3ra=5;
else if pat3ract=. | (at15d=. & patscr2=1 & pat3ract ne 1 & at15e ne 1) | (at15e=.
 & patscr2=1 & pat3ract ne 1 & at15d ne 1) then pat3ra=.;

** ADHD Criterion B **;

pat3rb=1;  ** Criterion B **;
if 1 le at15a le 6 then pat3rb=5;
else if at15a=-9 | (at15a=. & patscr2=1) then pat3rb=.;

** ADHD Criterion C not assessed **;

* ADHD Diagnosis *;

pat3r=1;
if pat3ra=5 & pat3rb=5 then pat3r=5;
else if pat3ra=. | (pat3rb=. & pat3ra ne 1) then pat3r=.;

label pat3ract='ADHD - Diag w/ 8+symptoms'
      pat3ra='ADHD - Criterion A'
      pat3rb='ADHD - Criterion B'
      pat3r='ADHD Diagnosis'
;
keep  pat3ract pat3ra pat3rb pat3r;
;
***** calc.sas ***** (3/27/95);

* C-SSAGA DSM-III-R: Psychoactive Substance (Alcohol) Use Disorder *;

** Alcohol Dependence **;

*** Alc Criterion A ***;

**** Alc screener 1 ****;
if al4c ge 7 | (1 le al4d le 4) then palscr1=1;
else if al2=1 | (0 le al4c le 6) | al4d=0 then palscr1=0;

pal3ra1=1;  **** symptom group 1 ****;
if al21b=5 | al22b=5 then pal3ra1=5;
else if al21a=9 | al21b=9 | al22a=9 | al22b=9 then pal3ra1=.;

pal3ra2=1;  **** symptom group 2 ****;
if al20c=5 | al20b=5 then pal3ra2=5;
else if al20a=9 | al20b=9 | al20c=9 then pal3ra2=.;

pal3ra3=1;  **** symptom group 3 ****;
if al28=5 then pal3ra3=5;
else if al28=9 then pal3ra3=.;

pal3ra4=1;  **** symptom group 4 ****;
if al14d=5 | al15b=5 | al16=5 | al26b=5 | al27b=5 then pal3ra4=5;
else if al14c=9 | al14d=9 | al15a=9 | al15b=9 | al16=9 | al26a=9 |
 al26b=9 | al27a=9 | al27b=9 then pal3ra4=.;

pal3ra5=1;  **** symptom group 5 ****;
if al18=5 then pal3ra5=5;
else if al18=9 then pal3ra5=.;

pal3ra6=1;  **** symptom group 6 ****;
if al10g=5 | al13e=5 | al14b=5 then pal3ra6=5;
else if al10g=9 | al10f=9 | (al10f=. & (al10a=9 | al10c=9 |
 al10d=9 | al10e=9)) | al13e=9 | al13d=9 | (al13d=. & ( al13a=9 | al13b=9
 | al13c=9)) | al14a=9 | al14b=9 then pal3ra6=.;

pal3ra7=1;  **** symptom group 7 ****;
if al19a=5 | al19b=5 then pal3ra7=5;
else if al19a=9 | al19b=9 then pal3ra7=.;

pal3ra8=1;  **** symptom group 8 ****;
if al25b=5 then pal3ra8=5;
else if al25b=9 | (al25b=. & ((al24a_1=9)+(al24a_2=9)+(al24a_3=9)+(al24a_4=9)
 +(al24a_5=9)+(al24a_6=9)+(al24a_7=9)+(al24a_8=9)+(al24a_9=9)+(al24a_10=9)) ge 2)
 then pal3ra8=.;

pal3ra9=1; **** symptom group 9 ****;
if al24b_1=5 | al24b_2=5 | al24b_3=5 | al24b_4=5 | al24b_5=5 | al24b_6=5 |
 al24b_7=5 | al24b_8=5 | al24b_9=5 | al24b_10=5 then pal3ra9=5;
else if al24b_1=9 | al24b_2=9 | al24b_3=9 | al24b_4=9 | al24b_5=9 | al24b_6=9
 | al24b_7=9 | al24b_8=9 | al24b_9=9 | al24b_10=9
 | al24a_1=9 | al24a_2=9 | al24a_3=9 | al24a_4=9 | al24a_5=9 | al24a_6=9
 | al24a_7=9 | al24a_8=9 | al24a_9=9 | al24a_10=9 then pal3ra9=.;

array ryala pal3ra1-pal3ra9;
if palscr1=. then do over ryala;
 ryala=.;
end;

pal3rasx=0; pal3ramx=0;  **** symptom group counts ****;
do over ryala;
 if ryala=5 then pal3rasx+1;
 else if ryala=. then pal3ramx+1;
end;

pal3ra=1;  *** Criterion A ***;
if pal3rasx ge 3 then pal3ra=5;
else if pal3rasx+pal3ramx ge 3 then pal3ra=.;

*** Alc Criterion B ***;

pal3rb=1;
if al30b=5 then pal3rb=5;
else if al30b=9 | pal3ramx ge 1 then pal3rb=.;

** Alcohol Dependence Diagnosis **;

pal3rde=1;
if pal3ra=5 & pal3rb=5 then pal3rde=5;
else if pal3ra=. | (pal3ra ne 1 & pal3rb=.) then pal3rde=.;

** Alcohol Abuse **;

*** Alc Criterion A ***;

pal3raa1=pal3ra6;  **** symptom group 1 ****;

pal3raa2=1;  **** symptom group 2 ****;
if al14d=5 | al26b=5 | al27b=5 then pal3raa2=5;
else if al14c=9 | al14d=9 | al26a=9 | al26b=9 | al27a=9 | al27b=9 then
  pal3raa2=.;

if palscr1=. then do;
 pal3raa1=.; pal3raa2=.;
end;

pal3raa=1;  *** Criterion A ***;
if pal3raa1=5 | pal3raa2=5 then pal3raa=5;
else if pal3raa1=. | pal3raa2=. then pal3raa=.;

*** Alc Criterion B ***;

pal3rba=1;
if al30b=5 then pal3rba=5;
else if al30b=9 | (pal3raa1=. | pal3raa2=.) then pal3rba=.;

*** Alc Criterion C ***;

pal3rca=1;
if pal3rde=1 then pal3rca=5;
else if pal3rde=. then pal3rca=.;

** Alcohol Abuse Diagnosis **;

pal3rab=1;
if pal3raa=5 & pal3rba=5 & pal3rca=5 then pal3rab=5;
else if pal3raa=. | (pal3raa ne 1 & pal3rca=.) | (pal3raa ne 1 & pal3rca ne 1
 & pal3rba=.) then pal3rab=.;

label pal3ra='Alcohol Dependence - Criterion A'
      pal3rb='Alcohol Dependence - Criterion B'
      pal3rde='Alcohol Dependence Diagnosis'
      pal3raa='Alcohol Abuse - Criterion A'
      pal3rba='Alcohol Abuse - Criterion B'
      pal3rca='Alcohol Abuse - Criterion C'
      pal3rab='Alcohol Abuse - Diagnosis'
  ;
keep  pal3ra pal3rb pal3rde pal3raa pal3rba
      pal3rca pal3rab;
;
***** canr.sas ***** (3/27/95);

* C-SSAGA DSM-III-R: Anorexia Nervosa Eating Disorder *;

** AN Criterion A **;

pan3ra=1;
if an3c_3=5 then pan3ra=5;
else if an1=9 | an3c_3=9 then pan3ra=.;

** AN Criterion B **;

pan3rb=1;
if an4=5 | an5=5 then pan3rb=5;
else if an4=3 | an5=3 then pan3rb=3;
else if an1=9 | an4=9 | an5=9 then pan3rb=.;

** AN Criterion C **;

pan3rc=an2;
if an1=9 | an2=9 then pan3rc=.;

** AN Criterion D **;

pan3rd=.N;
if dm1=2 & dm3 ge 9 then do;
 pan3rd=1;
 if an9=5 then pan3rd=5;
 else if an1=9 | an8=9 | an9=9 then pan3rd=.;
end;

* Anorexia Nervosa Diagnosis *;

pan3r=1;
if dm1=1 | dm3 le 8 then do;
 if pan3ra=5 & pan3rb=5 & pan3rc=5 then pan3r=5;
 else if pan3ra=5 & pan3rb ge 3 & pan3rc ge 3 then pan3r=3;
 else if pan3ra=. |(( pan3rb=. | pan3rc=.)& pan3ra ne 1) then pan3r=.;
end;
else if dm1=2 & dm3 ge 9 then do;
 if pan3ra=5 & pan3rb=5 & pan3rc=5 & pan3rd=5 then pan3r=5;
 else if pan3ra=5 & pan3rb ge 3 & pan3rc ge 3 & pan3rd=5 then pan3r=3;
 else if pan3ra=. |(( pan3rb=. | pan3rc=. | pan3rd=.)& pan3ra ne 1) then pan3r=.;
end;

label pan3ra='Anorexia - Criterion A'
      pan3rb='Anorexia - Criterion B'
      pan3rc='Anorexia - Criterion C'
      pan3rd='Anorexia - Criterion D'
      pan3r='Anorexia - Diagnosis'
;
keep  pan3ra pan3rb pan3rc pan3r pan3r;
***** cbul.sas ***** (3/27/95);

* C-SSAGA DSM-III-R: Bulimia Nervosa Eating Disorder *;

** Bul Criterion A **;

pbu3ra=1;
if bu2a=5 | bu2b=5 then pbu3ra=5;
else if bu2a=3 then pbu3ra=3;
else if bu1a=9 | bu2b=9 then pbu3ra=.;

** Bul Criterion B **;

pbu3rb=bu7;
if pbu3ra=1 then pbu3rb=1;
else if pbu3ra=. | bu7=9 then pbu3rb=.;

** Bul Criterion C **;

pbu3rc=1;
if bu5=5 | bu6=5 then pbu3rc=5;
else if bu5=3 | bu6=3 then pbu3rc=3;
else if pbu3ra=. | bu5=9 | bu6=9 then pbu3rc=.;

** Bul Criterion D **;

pbu3rd=1;
if bu3=5 then pbu3rd=5;
else if pbu3ra=. | bu3=9 then pbu3rd=.;

** Bul Criterion E **;

pbu3re=1;
if bu4a=5 | bu4b=5 then pbu3re=5;
else if bu4a=3 | bu4b=3 then pbu3re=3;
else if pbu3ra=. | bu4a=9 | bu4b=9 then pbu3re=.;

* Bulimia Nervosa Diagnosis *;

pbu3r=1;
if pbu3ra=5 & pbu3rb=5 & pbu3rc=5 & pbu3rd=5 & pbu3re=5 then pbu3r=5;
else if pbu3ra ge 3 & pbu3rb ge 3 & pbu3rc ge 3 & pbu3rd=5 & pbu3re ge 3
 then pbu3r=3;
else if pbu3ra=. | ((pbu3rb=. | pbu3rc=. | pbu3rd=. | pbu3re=.) & pbu3ra ne 1) then pbu3r=.;

label pbu3ra='Bulimia - Criterion A'
      pbu3rb='Bulimia - Criterion B'
      pbu3rc='Bulimia - Criterion C'
      pbu3rd='Bulimia - Criterion D'
      pbu3re='Bulimia - Criterion E'
      pbu3r='Bulimia Diagnosis'
;
keep  pbu3ra pbu3rb pbu3rc pbu3rd pbu3re pbu3r;
***3/27/95 (rev)***;

***** cdrg.sas ***** (3/27/95);

* C-SSAGA DSM-III-R: Psychoactive Substance (Street Drugs) Use Disorder *;

** Street Drugs Dependence **;

*** SD Criterion A ***;

**** SD screener 0 ****;
if sd1_1=5 | sd1_2=5 | sd1_3=5 | sd1_4=5 | sd1_5=5 | sd1_6=5 | sd2=5 | sd3=5
 | sd4=5 then psdscr0=1;
else if sd1_1=1 & sd1_2=1 & sd1_3=1 & sd1_4=1 & sd1_5=1 & sd1_6=1 | sd2=1 |
 sd3=1 | sd4=1 then psdscr0=0;

array sd6a_(6) sd6a_1-sd6a_6;
array sd6b_(6) sd6b_1-sd6b_6;
array sdscr(6) psdscr1-psdscr6;

array sda1_9(6,9) psd3ra11-psd3ra19 psd3ra21-psd3ra29 psd3ra31-psd3ra39
                   psd3ra41-psd3ra49 psd3ra51-psd3ra59 psd3ra61-psd3ra69;
array sds(6) psd3rsx1-psd3rsx6;
array sdm(6) psd3rmx1-psd3rmx6;
array sda(6) psd3ra1-psd3ra6;
array sdb(6) psd3rb1-psd3rb6;
array sdde(6) psd3rde1-psd3rde6;

array sdaa1(6) psd3aa11 psd3aa21 psd3aa31 psd3aa41 psd3aa51 psd3aa61;
array sdaa2(6) psd3aa12 psd3aa22 psd3aa32 psd3aa42 psd3aa52 psd3aa62;
array sdaa(6) psd3raa1-psd3raa6;
array sdba(6) psd3rba1-psd3rba6;
array sdca(6) psd3rca1-psd3rca6;
array sdab(6) psd3rab1-psd3rab6;

array sd12a_(6) sd12a_1-sd12a_6;
array sd12b_(6) sd12b_1-sd12b_6;
array sd13a_(6) sd13a_1-sd13a_6;
array sd13b_(6) sd13b_1-sd13b_6;
array sd9a_(6) sd9a_1-sd9a_6;
array sd9b_(6) sd9b_1-sd9b_6;
array sd9c_(6) sd9c_1-sd9c_6;
array sd11_(6) sd11_1-sd11_6;
array sd14a_(6) sd14a_1-sd14a_6;
array sd14b_(6) sd14b_1-sd14b_6;
array sd15_(6) sd15_1-sd15_6;
array sd16a_(6) sd16a_1-sd16a_6;
array sd16b_(6) sd16b_1-sd16b_6;
array sd17a_(6) sd17a_1-sd17a_6;
array sd17b_(6) sd17b_1-sd17b_6;
array sd10_(6) sd10_1-sd10_6;
array sd18a_(6) sd18a_1-sd18a_6;
array sd18b_(6) sd18b_1-sd18b_6;
array sd18c_(6) sd18c_1-sd18c_6;
array sd18d_(6) sd18d_1-sd18d_6;
array sd18e_(6) sd18e_1-sd18e_6;
array sd20a_(6) sd20a_1-sd20a_6;
array sd20b_(6) sd20b_1-sd20b_6;
array sd20c_(6) sd20c_1-sd20c_6;
array sd20d_(6) sd20d_1-sd20d_6;
array sd20e_(6) sd20e_1-sd20e_6;
array sd20f_(6) sd20f_1-sd20f_6;
array sd21_(6) sd21_1-sd21_6;
array sd8a_(6) sd8a_1-sd8a_6;
array sd8b_(6) sd8b_1-sd8b_6;
array sd22_(16,6) sd22a_1-sd22a_6 sd22b_1-sd22b_6 sd22c_1-sd22c_6
 sd22d_1-sd22d_6 sd22e_1-sd22e_6 sd22f_1-sd22f_6 sd22g_1-sd22g_6
 sd22h_1-sd22h_6 sd22i_1-sd22i_6 sd22j_1-sd22j_6 sd22k_1-sd22k_6
 sd22l_1-sd22l_6 sd22m_1-sd22m_6 sd22n_1-sd22n_6 sd22o_1-sd22o_6
 sd22p_1-sd22p_6;
array sd23_(6) sd23_1-sd23_6;
array sd24_(6) sd24_1-sd24_6;

do i=1 to 6;

 **** SD screener 1-6 ****;
 if sd6a_(i) ge 7 | (1 le sd6b_(i) le 4) then sdscr(i)=1;
 else if psdscr0=0 | (0 le sd6a_(i) le 6) | sd6b_(i)=0 then sdscr(i)=0;

 sda1_9(i,1)=1;  **** symptom group 1 ****;
 if sd12b_(i)=5 | sd13b_(i)=5 then sda1_9(i,1)=5;
 else if sd12a_(i)=9 | sd12b_(i)=9 | sd13a_(i)=9 | sd13b_(i)=9 then
  sda1_9(i,1)=.;

 sda1_9(i,2)=1;  **** symptom group 2 ****;
 if sd9c_(i)=5 | sd9b_(i)=5 then sda1_9(i,2)=5;
 else if sd9a_(i)=9 | sd9b_(i)=9 | sd9c_(i)=9 then sda1_9(i,2)=.;

 sda1_9(i,3)=1;  **** symptom group 3 ****;
 if sd11_(i)=5 then sda1_9(i,3)=5;
 else if sd11_(i)=9 then sda1_9(i,3)=.;

 sda1_9(i,4)=1;  **** symptom group 4 ****;
 if sd14b_(i)=5 | sd15_(i)=5 | sd16b_(i)=5 | sd17b_(i)=5 then sda1_9(i,4)=5;
 else if sd14a_(i)=9 | sd14b_(i)=9 | sd15_(i)=9 | sd16a_(i)=9 | sd16b_(i)=9 |
  sd17a_(i)=9 | sd17b_(i)=9 then sda1_9(i,4)=.;

 sda1_9(i,5)=1;  **** symptom group 5 ****;
 if sd10_(i)=5 then sda1_9(i,5)=5;
 else if sd10_(i)=9 then sda1_9(i,5)=.;

 sda1_9(i,6)=1;  **** symptom group 6 ****;
 if sd18e_(i)=5 | sd20f_(i)=5 | sd21_(i)=5 then sda1_9(i,6)=5;
 else if sd18e_(i)=9 | sd18d_(i)=9 | (sd18d_(i)=. & (sd18a_(i)=9 | sd18b_(i)=9
  | sd18c_(i)=9)) | sd20f_(i)=9 | sd20e_(i)=9 | (sd20e_(i)=. & (sd20a_(i)=9 |
  sd20b_(i)=9 | sd20c_(i)=9 | sd20d_(i)=9)) | sd21_(i)=9 then sda1_9(i,6)=.;

 sda1_9(i,7)=1;  **** symptom group 7 ****;
 if sd8a_(i)=5 | sd8b_(i)=5 then sda1_9(i,7)=5;
 else if sd8a_(i)=9 | sd8b_(i)=9 then sda1_9(i,7)=.;

 sd24_9s=0;
 do j=1 to 16;
  if sd22_(j,i)=9 then sd24_9s+1;
 end;

 sda1_9(i,8)=1;  **** symptom group 8 ****;
 if sd24_(i)=5 then sda1_9(i,8)=5;
 else if sd24_(i)=9 | (sd24_(i)=. & sd24_9s ge 2) then sda1_9(i,8)=.;

 sda1_9(i,9)=1;  **** symptom group 9 ****;
 if sd23_(i)=5 then sda1_9(i,9)=5;
 else if sd23_(i)=9 | sd22_(1,i)=9 | sd22_(2,i)=9 | sd22_(3,i)=9 | sd22_(4,i)=9
  | sd22_(5,i)=9 | sd22_(6,i)=9 | sd22_(7,i)=9 | sd22_(8,i)=9 | sd22_(9,i)=9
  | sd22_(10,i)=9 | sd22_(11,i)=9 | sd22_(12,i)=9 | sd22_(13,i)=9 | sd22_(14,i)=9
  | sd22_(15,i)=9 | sd22_(16,i)=9 then sda1_9(i,9)=.;

 if psdscr0=. | sdscr(i)=. then do j=1 to 9;
  sda1_9(i,j)=.;
 end;

 sds(i)=0; sdm(i)=0;  **** symptom group counts ****;
 do j=1 to 9;
  if sda1_9(i,j)=5 then sds(i)+1;
  else if sda1_9(i,j)=. then sdm(i)+1;
 end;

 sda(i)=1;  *** Criterion A ***;
 if sds(i) ge 3 then sda(i)=5;
 else if sds(i)+sdm(i) ge 3 then sda(i)=.;

 *** SD Criterion B ***;

 sdb(i)=1;
 if sd26b=5 then sdb(i)=5;
 else if sd26b=9 | sdm(i) ge 1 then sdb(i)=.;

 ** Street Drugs Dependence Diagnosis **;

 sdde(i)=1;
 if sda(i)=5 & sdb(i)=5 then sdde(i)=5;
 else if sda(i)=. | (sda(i) ne 1 & sdb(i)=.) then sdde(i)=.;

 ** Street Drugs Abuse **;

 *** SD Criterion A ***;

 sdaa1(i)=sda1_9(i,6);  **** symptom group 1 ****;

 sdaa2(i)=1;  **** symptom group 2 ****;
 if sd16b_(i)=5 | sd17b_(i)=5 then sdaa2(i)=5;
 else if sd16a_(i)=9 | sd16b_(i)=9 | sd17a_(i)=9 | sd17b_(i)=9 then sdaa2(i)=.;

 sdaa(i)=1;  *** Criterion A ***;
 if sdaa1(i)=5 | sdaa2(i)=5 then sdaa(i)=5;
 else if sdaa1(i)=. | sdaa2(i)=. then sdaa(i)=.;

 if psdscr0=. | sdscr(i)=. then do;
  sdaa1(i)=.; sdaa2(i)=.;
 end;

 *** SD Criterion B ***;

 sdba(i)=1;
 if sd26b=5 then sdba(i)=5;
 else if sd26b=9 | (sdaa1(i)=. | sdaa2(i)=.) then sdba(i)=.;

 *** SD Criterion C ***;

 sdca(i)=1;
 if sdde(i)=1 then sdca(i)=5;
 else if sdde(i)=. then sdca(i)=.;

 ** Street Drugs Abuse Diagnosis **;

 sdab(i)=1;
 if sdaa(i)=5 & sdba(i)=5 & sdca(i)=5 then sdab(i)=5;
 else if sdaa(i)=. | (sdaa(i) ne 1 & sdca(i)=.) | (sdaa(i) ne 1 & sdca(i) ne 1
  & sdba(i)=.) then sdab(i)=.;
end;

label psd3ra1='Street Drugs Dependence Criterion A'
      psd3ra2='Street Drugs Dependence Criterion A'
      psd3ra3='Street Drugs Dependence Criterion A'
      psd3ra4='Street Drugs Dependence Criterion A'
      psd3ra5='Street Drugs Dependence Criterion A'
      psd3ra6='Street Drugs Dependence Criterion A'
      psd3rb1='Street Drugs Dependence Criterion B'
      psd3rb2='Street Drugs Dependence Criterion B'
      psd3rb3='Street Drugs Dependence Criterion B'
      psd3rb4='Street Drugs Dependence Criterion B'
      psd3rb5='Street Drugs Dependence Criterion B'
      psd3rb6='Street Drugs Dependence Criterion B'
      psd3rde1='Street Drugs Dependence Diagnosis'
      psd3rde2='Street Drugs Dependence Diagnosis'
      psd3rde3='Street Drugs Dependence Diagnosis'
      psd3rde4='Street Drugs Dependence Diagnosis'
      psd3rde5='Street Drugs Dependence Diagnosis'
      psd3rde6='Street Drugs Dependence Diagnosis'
      psd3raa1='Street Drugs Abuse Criterion A'
      psd3raa2='Street Drugs Abuse Criterion A'
      psd3raa3='Street Drugs Abuse Criterion A'
      psd3raa4='Street Drugs Abuse Criterion A'
      psd3raa5='Street Drugs Abuse Criterion A'
      psd3raa6='Street Drugs Abuse Criterion A'
      psd3rba1='Street Drugs Abuse Criterion B'
      psd3rba2='Street Drugs Abuse Criterion B'
      psd3rba3='Street Drugs Abuse Criterion B'
      psd3rba4='Street Drugs Abuse Criterion B'
      psd3rba5='Street Drugs Abuse Criterion B'
      psd3rba6='Street Drugs Abuse Criterion B'
      psd3rca1='Street Drugs Abuse Criterion C'
      psd3rca2='Street Drugs Abuse Criterion C'
      psd3rca3='Street Drugs Abuse Criterion C'
      psd3rca4='Street Drugs Abuse Criterion C'
      psd3rca5='Street Drugs Abuse Criterion C'
      psd3rca6='Street Drugs Abuse Criterion C'
      psd3rab1='Street Drugs Abuse Diagnosis'
      psd3rab2='Street Drugs Abuse Diagnosis'
      psd3rab3='Street Drugs Abuse Diagnosis'
      psd3rab4='Street Drugs Abuse Diagnosis'
      psd3rab5='Street Drugs Abuse Diagnosis'
      psd3rab6='Street Drugs Abuse Diagnosis'
  ;
keep psd3ra1-psd3ra6 psd3rb1-psd3rb6 psd3rde1-psd3rde6
     psd3raa1-psd3raa6 psd3rba1-psd3rba6 psd3rca1-psd3rca6
     psd3rab1-psd3rab6;
***** cmj.sas ***** (3/27/95);

* C-SSAGA DSM-III-R: Psychoactive Substance (Marijuana) Use Disorder *;

** Marijuana Dependence **;

*** Mj Criterion A ***;

**** Mj screener 1 ****;
if mj1e ge 7 | (1 le mj1f le 4) then pmjscr1=1;
else if mj1a=1 | (0 le mj1e le 6) | mj1f=0 then pmjscr1=0;

pmj3ra1=1;  **** symptom group 1 ****;
if mj6b=5 | mj7b=5 then pmj3ra1=5;
else if mj6a=9 | mj6b=9 | mj7a=9 | mj7b=9 then pmj3ra1=.;

pmj3ra2=1;  **** symptom group 2 ****;
if mj8c=5 | mj8b=5 then pmj3ra2=5;
else if mj8a=9 | mj8b=9 | mj8c=9 then pmj3ra2=.;

pmj3ra3=1;  **** symptom group 3 ****;
if mj20=5 then pmj3ra3=5;
else if mj20=9 then pmj3ra3=.;

pmj3ra4=1;  **** symptom group 4 ****;
if mj14b=5 | mj15=5 | mj16b=5 | mj17b=5 then pmj3ra4=5;
else if mj14a=9 | mj14b=9 | mj15=9 | mj16a=9 | mj16b=9 | mj17a=9 | mj17b=9
 then pmj3ra4=.;

pmj3ra5=1;  **** symptom group 5 ****;
if mj9a=5 | mj9b=5 then pmj3ra5=5;
else if mj9a=9 | mj9b=9 then pmj3ra5=.;

pmj3ra6=1;  **** symptom group 6 ****;
if mj10e=5 | mj12f=5 | mj13b=5 then pmj3ra6=5;
else if mj10e=9 | mj10d=9 | (mj10d=. & (mj10a=9 | mj10b=9 | mj10c=9)) |
 mj12f=9 | mj12e=9 | (mj12e=. & (mj12a=9 | mj12b=9 | mj12c=9 | mj12d=9)) |
 mj13a=9 | mj13b=9 then pmj3ra6=.;

pmj3ra7=1;  **** symptom group 7 ****;
if mj4a=5 | mj4b=5 then pmj3ra7=5;
else if mj4a=9 | mj4b=9 then pmj3ra7=.;

pmj3ra8=1;  **** symptom group 8 ****;
if mj19b=5 then pmj3ra8=5;
else if mj19b=9 | (mj19b=. & ((mj18a_1=9)+(mj18a_2=9)+(mj18a_3=9)+(mj18a_4=9)
 +(mj18a_5=9)+(mj18a_6=9)+(mj18a_7=9) ge 2) | ((mj19a_1=9)+(mj19a_2=9)+(mj19a_3=9)
 + (mj19a_4=9)+(mj19a_5=9)+(mj19a_6=9)+(mj19a_7=9) ge 2)) then pmj3ra8=.;

pmj3ra9=1;  **** symptom group 9 ****;
if mj18b_1=5 | mj18b_2=5 | mj18b_3=5 | mj18b_4=5 | mj18b_5=5 | mj18b_6=5 |
 mj18b_7=5 then pmj3ra9=5;
else if mj18b_1=9 | mj18b_2=9 | mj18b_3=9 | mj18b_4=9 | mj18b_5=9 | mj18b_6=9
 | mj18b_7=9 | mj18a_1=9 | mj18a_2=9 | mj18a_3=9 | mj18a_4=9 | mj18a_5=9 |
 mj18a_6=9 | mj18a_7=9 then pmj3ra9=.;

array rymja pmj3ra1-pmj3ra9;
if pmjscr1=. then do over rymja;
 rymja=.;
end;

pmj3rasx=0; pmj3ramx=0;  **** symptom group counts ****;
do over rymja;
 if rymja=5 then pmj3rasx+1;
 else if rymja=. then pmj3ramx+1;
end;

pmj3ra=1;  *** Criterion A ***;
if pmj3rasx ge 3 then pmj3ra=5;
else if pmj3rasx+pmj3ramx ge 3 then pmj3ra=.;

*** Mj Criterion B ***;

pmj3rb=1;
if mj22b=5 then pmj3rb=5;
else if mj22b=9 | pmj3ramx ge 1 then pmj3rb=.;

** Marijuana Dependence Diagnosis **;

pmj3rde=1;
if pmj3ra=5 & pmj3rb=5 then pmj3rde=5;
else if pmj3ra=. | (pmj3ra ne 1 & pmj3rb=.) then pmj3rde=.;

** Marijuana Abuse **;

*** Mj Criterion A ***;

pmj3raa1=pmj3ra6;  **** symptom group 1 ****;

pmj3raa2=1;  **** symptom group 2 ****;
if mj16b=5 | mj17b=5 then pmj3raa2=5;
else if mj16a=9 | mj16b=9 | mj17a=9 | mj17b=9 then pmj3raa2=.;

if pmjscr1=. then do;
 pmj3raa1=.; pmj3raa2=.;
end;

pmj3raa=1;  *** Criterion A ***;
if pmj3raa1=5 | pmj3raa2=5 then pmj3raa=5;
else if pmj3raa1=. | pmj3raa2=. then pmj3raa=.;

*** Mj Criterion B ***;

pmj3rba=1;
if mj22b=5 then pmj3rba=5;
else if mj22b=9 | (pmj3raa1=. | pmj3raa2=.) then pmj3rba=.;

*** Mj Criterion C ***;

pmj3rca=1;
if pmj3rde=1 then pmj3rca=5;
else if pmj3rde=. then pmj3rca=.;

** Marijuana Abuse Diagnosis **;

pmj3rab=1;
if pmj3raa=5 & pmj3rba=5 & pmj3rca=5 then pmj3rab=5;
else if pmj3raa=. | (pmj3raa ne 1 & pmj3rca=.) | (pmj3raa ne 1 & pmj3rca ne 1
 & pmj3rba=.) then pmj3rab=.;

label pmj3ra='Marijuana Dependence - Criterion A'
      pmj3rb='Marijuana Dependence - Criterion B'
      pmj3rde='Marijuana Dependence - Diagnosis'
      pmj3raa='Marijuana Abuse - Criterion A'
      pmj3rba='Marijuana Abuse - Criterion B'
      pmj3rca='Marijuana Abuse - Criterion C'
      pmj3rab='Marijuana Abuse - Diagnosis'
;
keep pmj3ra pmj3rb pmj3rde pmj3raa
      pmj3rba pmj3rca pmj3rab;
***** cobc.sas ***** (3/27/95);

* C-SSAGA DSM-III-R: Obsessive Compulsive Disorder *;

** Obsessions **;

*** Ob Criterion A ***;

pob3ra1=1;  **** symptom group 1 ****;
if ob1=5 | ob2b=5 | ob3=5 | ob4=5 | ob5=5 then pob3ra1=5;
else if ob1=3 | ob2b=3 | ob3=3 | ob4=3 | ob5=3 then pob3ra1=3;
else if ob1=9 | ob2a=9 | ob2b=9 | ob3=9 | ob4=9 | ob5=9  then pob3ra1=.;

pob3ra2=1;  **** symptom group 2 ****;
if ob6=5 then pob3ra2=5;
else if ob6=3 then pob3ra2=3;
if ob6=9 | pob3ra1=. then pob3ra2=.;  * if vs else if intentional;

pob3ra3=1;  **** symptom group 3 ****;
if ob7=5 then pob3ra3=5;
else if ob7=3 then pob3ra2=3;
if ob7=9 | pob3ra1=. then pob3ra3=.;  * if vs else if intentional;

**** symptom group 4 not assessed ****;

pob3ra=1;  *** Criterion A ***;
if pob3ra1=5 & pob3ra2=5 & pob3ra3=5 then pob3ra=5;
else if pob3ra1 ge 3 & pob3ra2 ge 3 & pob3ra3 ge 3 then pob3ra=3;
else if pob3ra1=. | pob3ra2=. | pob3ra3=. then pob3ra=.;

*** Ob Criterion B ***;

pob3rb=1;
if ob8a=5 | ob8b=2 then pob3rb=5;
else if pob3ra1=. | ob8a=9 | ob8b=9 then pob3rb=.;

** Obsessions Diagnosis **;

pob3r=1;
if pob3ra=5 & pob3rb=5 then pob3r=5;
else if pob3ra=3 & pob3rb=5 then pob3r=3;
else if (pob3ra=. & pob3rb ne 1) | (pob3rb=. & pob3ra ne 1) then pob3r=.;

** Compulsions **;

*** Cp Criterion A ***;

pcp3ra1=1;  **** symptom group 1 ****;
if cp1=5 | cp2b=5 | cp3b=5 then pcp3ra1=5;
else if cp1=3 | cp2b=3 | cp3b=3 then pcp3ra1=3;
else if cp1=9 | cp2a=9 | cp2b=9 | cp3a=9 | cp3b=9 then pcp3ra1=.;

pcp3ra2=1;  **** symptom group 2 ****;
if cp4=5 then pcp3ra2=5;
else if cp4=3 then pcp3ra2=3;
if cp3a=9 | cp3b=9 | pcp3ra1=. then pcp3ra2=.;  * if vs else if intentional;

pcp3ra3=1;  **** symptom group 3 ****;
if cp5a=5 | cp5b=5 then pcp3ra3=5;
else if cp5a=3 | cp5b=3 then pcp3ra3=3;
else if cp5a=9 | cp5b=9 then pcp3ra3=.;
if pcp3ra1=. then pcp3ra3=.;  * if vs else if intentional;

pcp3ra=1;  *** Criterion A ***;
if pcp3ra1=5 & pcp3ra2=5 & pcp3ra3=5 then pcp3ra=5;
else if pcp3ra1 ge 3 & pcp3ra2 ge 3 & pcp3ra3 ge 3 then pcp3ra=3;
else if pcp3ra1=. | pcp3ra2=. | pcp3ra3=. then pcp3ra=.;

*** Cp Criterion B ***;

pcp3rb=1;
if cp6a=5 | cp6b=2 then pcp3rb=5;
else if pcp3ra1=. | cp6a=9 | cp6b=9 then pcp3rb=.;

** Compulsions Diagnosis **;

pcp3r=1;
if pcp3ra=5 & pcp3rb=5 then pcp3r=5;
else if pcp3ra=3 & pcp3rb=5 then pcp3r=3;
else if (pcp3ra=. & pcp3rb ne 1) | (pcp3rb=. & pcp3ra ne 1) then pcp3r=.;

* Obsessive Compulsive Diagnosis *;

poc3r=1;
if pob3r=5 | pcp3r=5 then poc3r=5;
else if pob3r=3 | pcp3r=3 then poc3r=3;
else if pob3r=. | pcp3r=. then poc3r=.;

label pob3ra='Obsession - Criterion A'
      pob3rb='Obsession - Criterion B'
      pob3r='Obsession Diagnosis'
      pcp3ra='Compulsion - Criterion A'
      pcp3rb='Compulsion - Criterion B'
      pcp3r='Compulsion - Diagnosis'
      poc3r='Obsessive Compulsive Diagnosis'
;
keep  pob3ra pob3rb pob3r pcp3ra
      pcp3rb pcp3r
      poc3r
;
***** con.sas (3/27/95) *****;

* C-SSAGA DSM-III-R: Conduct Disorder *;

** CD Criterion A **;

pcd3ra1=1;  *** symptom group 1 ***;
cd3rd=cd3d; cd3rg=cd3g;
if cd3d=9 then cd3rd=.;
if cd3g=9 then cd3rg=.;
ttl=sum(cd3c,cd3rd,cd3f,cd3rg);
if cd3c ge 2 | (2 le cd3d le 5) | cd3f ge 2 | (2 le cd3g le 5) | ttl ge 2 then pcd3ra1=5;
else if cd3a=9 | cd3b=9 | cd3d=9 | cd3e=9 | cd3g=9 then pcd3ra1=.;

pcd3ra2=1;  *** symptom group 2 ***;
if ((cd4b=1 | cd4c=1) & cd4d=1) | cd4b ge 2 | (2 le cd4c le 5) then pcd3ra2=5;
else if cd4a=9 | cd4c=9 | ((cd4b=1 | cd4c=1) & cd4d=9) then pcd3ra2=.;

pcd3ra3=1;  *** symptom group 3 ***;
if (2 le cd5c le 4) then pcd3ra3=5;
else if cd5a=9 | cd5b=9 | cd5c=9 then pcd3ra3=.;

pcd3ra4=1;  *** symptom group 4 ***;
if cd6d ge 3 | (3 le cd6e le 5) then pcd3ra4=5;
else if cd6d ge 1 | (1 le cd6e le 5) then pcd3ra4=3;
else if cd6a=9 | cd6c=9 | cd6e=9 then pcd3ra4=.;

pcd3ra5=1;  *** symptom group 5 ***;
if cd7b ge 3 | (3 le cd7c le 5) | cd8b ge 3 | cd8c=3 then pcd3ra5=5;
else if cd7a=9 | cd7c=9 | cd8a=9 | cd8c=9 then pcd3ra5=.;

pcd3ra6=1;  *** symptom group 6 ***;
if cd9b ge 3 | (3 le cd9c le 5) then pcd3ra6=5;
else if cd9b ge 1 | (1 le cd9c le 5) then pcd3ra6=3;
else if cd9a=9 | cd9c=9 then pcd3ra6=.;

pcd3ra7=1;  *** symptom group 7 ***;
if cd10c ge 3 | (3 le cd10d le 5) then pcd3ra7=5;
else if cd10c ge 1 | (1 le cd10d le 5) then pcd3ra7=3;
else if cd10a=9 | cd10b=9 | cd10d=9 then pcd3ra7=.;

pcd3ra8=1;  *** symptom group 8 ***;
if cd11d ge 2 | (2 le cd11e le 5) then pcd3ra8=5;
else if cd11d ge 1 | (1 le cd11e le 5) then pcd3ra8=3;
else if cd11a=9 | cd11c=9 | cd11e=9 then pcd3ra8=.;

pcd3ra9=1;  *** symptom group 9 ***;
if cd12=5 then pcd3ra9=5;
else if cd12=9 then pcd3ra9=.;

pcd3ra10=1;  *** symptom group 10 ***;
if cd14b ge 2 | (2 le cd14c le 5) then pcd3ra10=5;
else if cd13a=9 | cd14a=9 | cd14c=9 then pcd3ra10=.;

pcd3ra11=1;  *** symptom group 11 ***;
if cd13b ge 3 | (3 le cd13c le 5) then pcd3ra11=5;
else if cd13a=9 | cd13c=9 then pcd3ra11=.;

pcd3ra12=1;  *** symptom group 12 ***;
if cd15b ge 3 | (3 le cd15c le 5) then pcd3ra12=5;
else if cd15b ge 1 | (1 le cd15c le 5) then pcd3ra12=3;
else if cd15a=9 | cd15c=9 then pcd3ra12=.;

pcd3ra13=1;  *** symptom group 13 ***;
if cd16d ge 2 | (2 le cd16e le 5) then pcd3ra13=5;
else if cd16d ge 1 | (1 le cd16e le 5) then pcd3ra13=3;
else if cd16a=9 | cd16c=9 | cd16e=9 then pcd3ra13=.;

pcd3r5sx=0; pcd3r3sx=0; pcd3ramx=0;  *** symptom group counts ***;
array rycda pcd3ra1-pcd3ra13;
do over rycda;
 if rycda=5 then pcd3r5sx+1;
 else if rycda=. then pcd3ramx+1;
 if rycda ge 3 then pcd3r3sx+1;
end;

**Diagnosis with no duration or clusterion
     - just symptom count**;
pcd3ract=1;  *** 3+ symptom groups ***;
if pcd3r5sx ge 3 then pcd3ract=5;
else if pcd3r3sx ge 3 then pcd3ract=3;
else if pcd3r5sx+pcd3ramx ge 3 then pcd3ract=.;

pcd3ra=1;  ** Criterion A **;
if pcd3ract=5 & cd18a=5 & cd18b=5 then pcd3ra=5;
else if pcd3ract=3 & cd18a=5 & cd18b=5 then pcd3ra=3;
else if pcd3ract=. | (cd18a=. & pcd3r5sx ge 2 & pcd3ract ne 1 & cd18b ne 1) |
 (cd18b=. & pcd3ract ne 1 & cd18a ne 1) then pcd3ra=.;

** CD Criterion B not assessed **;

* CD Diagnosis *;

pcd3r=pcd3ra;  * no Criterion B *;

label pcd3ract='ChildConDis - Diag w/3+symptom'
      pcd3ra='ChildConDis Criterion A'
      pcd3r='Child Conduct Disorder'
;
keep  pcd3ract pcd3ra
      pcd3r
;
***** copp.sas *****;

* C-SSAGA DSM-III-R: Oppositional Defiant Disorder *;

** ODD Criterion A **;

array ryopa op1 op2a op3a op4 op6-op9;
array ryopb pop3ra1-pop3ra4 pop3ra6-pop3ra9;

do over ryopa;  *** symptom groups 1-4,6-9;
 ryopb=1;
 if ryopa=5 then ryopb=5;
 else if ryopa=9 then ryopb=.;
end;

pop3ra5=1;  *** symptom group 5 ***;
if op5=2 then pop3ra5=5;
else if op5=9 then pop3ra5=.;

*** ODD screener ***;
if pop3ra1=5 | pop3ra2=5 | pop3ra3=5 | pop3ra4=5 | pop3ra5=5 then popscr1=1;
else if pop3ra1=1 & pop3ra2=1 & pop3ra3=1 & pop3ra4=1 & pop3ra5=1 then
 popscr1=0;

if popscr1=. then do;
 pop3ra6=.; pop3ra7=.; pop3ra8=.; pop3ra9=.;
end;

pop3rasx=0; pop3ramx=0;  *** symptom group counts ***;
array ryopc pop3ra1-pop3ra9;
do over ryopc;
 if ryopc=5 then pop3rasx+1;
 else if ryopc=. then pop3ramx+1;
end;

**Diagnosis without duration or clustering
    - just based on symptom count*;
pop3ract=1;  *** 5+ symptom groups ***;
if pop3rasx ge 5 then pop3ract=5;
else if pop3rasx+pop3ramx ge 5 then pop3ract=.;

pop3ra=1;  ** Criterion A **;
if pop3ract=5 & op10d=5 & op10e=5 then pop3ra=5;
else if pop3ract=. | (op10d=. & pop3ract ne 1 & op10e ne 1) | (op10e=. &
  pop3ract ne 1 & op10d ne 1) then pop3ra=.;

** ODD Criterion B not to be included (WR) **;

* ODD Diagnosis *;

pop3r=pop3ra;  * no Criterion B *;

label pop3ract='ODD -Diag w/5+Symptoms'
      pop3ra='ODD - Criterion A'
      pop3r='ODD - Diagnosis'
;
keep pop3ract pop3ra pop3r;
***** covr.sas ***** (3/27/95 rev);

* C-SSAGA DSM-III-R: Overanxious Disorder *;

** Ov Criterion A **;

array ryova ov2-ov8;
array ryovb pov3ra1-pov3ra7;

do over ryova;  *** symptom groups 1-7 ***;
 ryovb=ryova;
 if ryova=9 then ryovb=.;
end;

*** Ov screener 1 ***;
if pov3ra1 ge 3 | pov3ra2 ge 3 then povscr1=1;
else if pov3ra1=1 & pov3ra2=1 then povscr1=0;

if povscr1=. then do;
 pov3ra3=.; pov3ra4=.; pov3ra5=.; pov3ra6=.; pov3ra7=.;
end;

pov3rsx5=0; pov3rsx3=0; pov3ramx=0;  *** symptom group counts ***;
do over ryovb;
 if ryovb=5 then pov3rsx5+1;
 else if ryovb=. then pov3ramx+1;
 if ryovb ge 3 then pov3rsx3+1;     * if vs else if intentional;
end;

***Diagnosis without duration or clustering
      - just based on symptom count***;
pov3rct5=1; pov3rct3=1;  ** 4+ symptom groups **;
if pov3rsx5 ge 4 then pov3rct5=5;
else if pov3rsx5+pov3ramx ge 4 then pov3rct5=.;
if pov3rsx3 ge 4 then pov3rct3=5;
else if pov3rsx3+pov3ramx ge 4 then pov3rct3=.;

pov3ra5=1; pov3ra3=1;  ** Criterion A **;
if pov3rct5=5 & ov10a=5 & ov10b=5 then pov3ra5=5;
else if pov3rct5=. | (ov10a=. & pov3rct5 ne 1 & ov10b ne 1) | (ov10b=. &
 pov3rct5 ne 1 & ov10a ne 1) then pov3ra5=.;
if pov3rct3=5 & ov10a=5 & ov10b=5 then pov3ra3=5;
else if pov3rct3=. | (ov10a=. & pov3rct3 ne 1 & ov10b ne 1) | (ov10b=. &
 pov3rct3 ne 1 & ov10a ne 1) then pov3ra3=.;

** Ov Criterion B, C, D not assessed **;

* Overaxious Diagnosis *;

pov3r=1;
if pov3ra5=5 then pov3r=5;
else if pov3ra3=5 then pov3r=3;
else if ov2=1 & ov3=1 then pov3r=1;
else if pov3ra5=. | pov3ra3=. then pov3r=.;

label pov3rct5='OvrAnx 4+symptoms, no alc/drg use'
      pov3rct3='OvrAnx 4+symptoms, alc/drg use'
      pov3ra5='OvrAnx Criterion A - No alc/drg use'
      pov3ra3='OvrAnx Criterion A - Alc/drg use'
      pov3r='Overanxious Diagnosis'
;
keep  pov3rct5
      pov3rct3
      pov3ra5
      pov3ra3
      pov3r
;
***** cpsy.sas ***** (3/27/95);

* C-SSAGA Psychotic Symptoms *;

** Psychotic Sx Criterion A **;

array rypsa ps4 ps5 ps6;
array rypsb pps3ra3-pps3ra5;

do over rypsa;  *** symptom groups 3-5 ***;
 rypsb=1;
 if rypsa=5 then rypsb=5;
 else if rypsa=3 then rypsb=3;
 else if rypsa=9 then rypsb=.;
end;

pps3ra1=1;  *** symptom group 1 ***;
if ps1a=5 & ps1c=1 then pps3ra1=5;
else if ps1a ge 3 & ps1c=1 then pps3ra1=3;
else if ps1a=9 | ps1c=9 then pps3ra1=.;

pps3ra2=1;  *** symptom group 2 ***;
if ps2a=5 | ps3=5 then pps3ra2=5;
else if ps2a=3 | ps3=3 then pps3ra2=3;
else if ps2a=9 | ps3=9 then pps3ra2=.;

pps3ra6=1;  *** symptom group 6 ***;
if ps7=5 | ps8=5 | ps9=5 | ps10=5 | ps11=5 | ps12=5 then pps3ra6=5;
else if ps7=3 | ps8=3 | ps9=3 | ps10=3 | ps11=3 | ps12=3 then pps3ra6=3;
else if ps7=9 | ps8=9 | ps9=9 | ps10=9 | ps11=9 | ps12=9 then pps3ra6=.;

pps3rsx5=0; pps3rsx3=0; pps3ramx=0;  *** symptom group counts ***;
array rypsc pps3ra1-pps3ra6;
do over rypsc;
 if rypsc=5 then pps3rsx5+1;
 else if rypsc=. then pps3ramx+1;
 if rypsc ge 3 then pps3rsx3+1;  * if vs else if intentional;
end;

pps3ra=1;  *** Criterion A ***;
if pps3rsx5 ge 1 then pps3ra=5;
else if pps3rsx3 ge 1 then pps3ra=3;
else if pps3ramx ge 1 then pps3ra=.;

** Other Psychotic Criteria not assessed **;

* Psychotic Sx Diagnosis *;

pps3r=pps3ra; * no other criteria;

label pps3ra='Psychotic Symptoms - Criterion A'
      pps3r='Psychotic Sx Diagnosis'
;
keep  pps3ra pps3r
;
***** csep.sas ***** (3/27/95 rev);

* C-SSAGA DSM-III-R: Separation Anxiety Disorder *;

** Sep Criterion A **;

array rysaa sa1-sa3 sa6 sa9 sa10;
array rysab psa3ra1-psa3ra3 psa3ra5-psa3ra7;

do over rysaa;  *** symptom groups 1-3,5-7 ***;
 rysab=rysaa;
 if rysaa=9 then rysab=.;
end;

psa3ra4=1;  *** symptom group 4 ***;
if sa4=5 | sa5=5 then psa3ra4=5;
else if sa4=3 | sa5=3 then psa3ra4=3;
else if sa4=9 | sa5=9 then psa3ra4=.;

psa3ra8=1;  *** symptom group 8 ***;
if sa11a=5 | sa11b=5 then psa3ra8=5;
else if sa11a=3 | sa11b=3 then psa3ra8=3;
else if sa11a=9 | sa11b=9 then psa3ra8=.;

psa3ra9=1;  *** symptom group 9 ***;
if sa7=5 | sa8a=5 | sa8b=5 then psa3ra9=5;
else if sa7=3 | sa8a=3 | sa8b=3 then psa3ra9=3;
else if sa7=9 | sa8a=9 | sa8b=9 then psa3ra9=.;

*** Sep screener 1 ***;
if sa1 ge 3 | sa2 ge 3 | sa3 ge 3 | sa4 ge 3 | sa5 ge 3 then psascr1=1;
else if sa1=1 & sa2=1 & sa3=1 & sa4=1 & sa5=1 then psascr1=0;

if psascr1=. then do;
 psa3ra5=.; psa3ra6=.; psa3ra7=.; psa3ra8=.; psa3ra9=.;
end;

psa3rsx5=0; psa3rsx3=0; psa3ramx=0;  *** symptom group counts ***;
array rysac psa3ra1-psa3ra9;
do over rysac;
 if rysac=5 then psa3rsx5+1;
 else if rysac=. then psa3ramx+1;
 if rysac ge 3 then psa3rsx3+1;
end;

  **Diagnosis without duration and clustering
       - just symptom count > 3**;
psa3ra5=1; psa3ra3=1;  ** Criterion A **;
if psa3rsx5 ge 3 then psa3ra5=5;
else if psa3rsx5+psa3ramx ge 3 then psa3ra5=.;
if psa3rsx3 ge 3 then psa3ra3=5;
else if psa3rsx3+psa3ramx ge 3 then psa3ra3=.;

** Criterion B **;

psa3rb=1;
if sa13=5 then psa3rb=5;
else if sa13=9 | psa3ramx ge 1 then psa3rb=.;

** Criterion C **;

psa3rc=1;
if (1 le sa12a le 17)|(1 le dm3 lt 18) then psa3rc=5;
else if dm3=-9 | (dm3 ge 18 & sa12a=-9) then psa3rc=.;

** Criterion D not assessed **;

* Separation Anxiety Diagnosis *;

psa3r=1;
if psa3ra5=5 & psa3rb=5 & psa3rc=5 then psa3r=5;
else if psa3ra3=5 & psa3rb=5 & psa3rc=5 then psa3r=3;
else if psascr1=0 then psa3r=1;
else if psa3ra3=. | ((psa3rb=. | psa3rc=.) & psa3ra3 ne 1) then psa3r=.;

label psa3ra5='SepAnx Crit.A & Diag w/3+Symp-no alc/drg'
      psa3ra3='SepAnx Crit.A & Diag w/3+Symp-alc/drg'
      psa3rb='SepAnx Criterion B'
      psa3rc='SepAnx Criterion C'
      psa3r='Separation Anxiety Diagnosis'
;
keep  psa3ra5
      psa3ra3
      psa3rb
      psa3rc
      psa3r
;
***** csom.sas ***** (3/27/95);

* C-SSAGA DSM-III-R: Somatization Disorder *;

** Som Criterion A **;

psm3ra=1;
if sm1=5 | sm2=5 then psm3ra=5;
else if sm1=9 | sm2=9 then psm3ra=.;
else if sm1=3 | sm2=3 then psm3ra=3;

** Som Criterion B **;

array rysma sm3 sm4a sm4b sm4c sm4d sm4e;
array rysmb sm5 sm6a sm6b sm6c sm6d;
array rysmc sm7 sm8a sm8b sm8c;
array rysmd sm9 sm10 sm11a sm11b sm11c sm11d sm11e sm11f sm11g sm11h sm11i sm11j;
array rysme sm12b sm12c sm12d;

psm3rsx5=0; psm3rsx3=0; psm3rbmx=0;  *** symptom group counts ***;
do over rysma;
 if sm3=9 then psm3rbmx+1;
 else if rysma=5 then psm3rsx5+1;
 else if rysma=9 then psm3rbmx+1;
 if sm3 ne 9 & (rysma=3 | rysma=5) then psm3rsx3+1;  * if vs else if intentional;
end;

do over rysmb;
 if sm5=9 then psm3rbmx+1;
 else if rysmb=5 then psm3rsx5+1;
 else if rysmb=9 then psm3rbmx+1;
 if sm5 ne 9 & (rysmb=3 | rysmb=5) then psm3rsx3+1;  * if vs else if intentional;
end;

do over rysmc;
 if sm7=9 then psm3rbmx+1;
 else if rysmc=5 then psm3rsx5+1;
 else if rysmc=9 then psm3rbmx+1;
 if sm7 ne 9 & (rysmc=3 | rysmc=5) then psm3rsx3+1;  * if vs else if intentional;
end;

do over rysmd;
 if sm9=9 & sm10=9 then psm3rbmx+1;
 else if rysmd=5 then psm3rsx5+1;
 else if rysmd=9 then psm3rbmx+1;
 if (sm9 ne 9 | sm10 ne 9) & (rysmd=3 | rysmd=5) then psm3rsx3+1;
end;

if dm1=2 & dm3 ge 9 then do over rysme;
 if sm12a=9 | sm12b=9 then psm3rbmx+1;
 else if rysme=5 then psm3rsx5+1;
 else if rysme=9 then psm3rbmx+1;
 if sm12a ne 9 & sm12b ne 9 & (rysme=3 | rysme=5) then psm3rsx3+1;
end;

psm3rb5=1; psm3rb3=1;  ** Criterion B **;
if psm3rsx5 ge 13 then psm3rb5=5;
else if psm3rsx5+psm3rbmx ge 13 then psm3rb5=.;
if psm3rsx3 ge 13 then psm3rb3=5;
else if psm3rsx3+psm3rbmx ge 13 then psm3rb3=.;

* Somatization Diagnosis *;

psm3r=1;
if psm3ra=5 & psm3rb5=5 then psm3r=5;
else if psm3ra=. | psm3rb5=. then psm3r=.;
else if psm3ra=5 & psm3rb3=5 then psm3r=3;
else if psm3rb3=. then psm3r=.;

label psm3ra='Somatization - Criterion A'
      psm3rb5='Somat. - Criterion B - no alc/drg use'
      psm3rb3='Somat. - Criterion B - alc/drg use'
      psm3r='Somatization Diagnosis'
;
keep  psm3ra
      psm3rb5
      psm3rb3
      psm3r
;
***3/27/95 (rev)***;

***** cdep.sas *****;

* C-SSAGA DSM-III-R: Major Depressive Episode *;

** MD screeners **;

*** MD screener 1 (current scr) ***;
if (md2a=5 | md2b=5 | md2c=5 | md2d=5 | md2e=5) & md3a=5 then pmdscr1=1;
else if (md2a=1 & md2b=1 & md2c=1 & md2d=1 & md2e=1) | md3a=1 then pmdscr1=0;

*** MD screener 2 (other time scr) ***;
if (md6a=5 | md6b=5 | md6c=5 | md6d=5 | md6e=5) & md7a=5 then pmdscr2=1;
else if (md6a=1 & md6b=1 & md6c=1 & md6d=1 & md6e=1) | md7a=1 then pmdscr2=0;


*** MD screener 4 (current clean scr) ***;
if md4a=1 & (md4b=1 | (md4b=5 & (md4c=1 | md4c=2))) & md4e=1 then pmdscr4=1;
else if md4a=5 | (md4b=5 & (3 ge md4c ge 998)) | md4e=5 then pmdscr4=0;

*** MD screener 5 (other time 1 clean scr) ***;
if md10a=1 & (md10b=1 | (md10b=5 & (md10c=1 | md10c=2))) & md10e=1 then
 pmdscr5=1;
else if md10a=5 | (md10b=5 & (3 ge md10c ge 998)) | md10e=5 then pmdscr5=0;

*** MD screener 6 (other time 2 clean scr) ***;
if pmdscr5 ne 1 & md12a=5 & md12d=1 then pmdscr6=1;
else if md12a=1 | md12d=5 then pmdscr6=0;

** Major Depressive Episodes **;

*** MD Criterion A (current) ***;

  **** symptom group 1 ****;
if md3b=5 then pmdc3ra1=5;
else if (md2a=1 & md2b=1 & md2e=1) | md3b=1 | md3a=1 then pmdc3ra1=1;

  **** symptom group 2 ****;
if md3c=5 then pmdc3ra2=5;
else if (md2c=1 & md2d=1) | md3c=1 | md3a=1 then pmdc3ra2=1;

pmdc3ra3=1;  **** symptom group 3 ****;
if mda_19b=5 | mda_20b=5 | mda_19a=5 | mda_20a=5 then pmdc3ra3=5;
else if mda_19a=9 | mda_19b=9 | mda_20a=9 | mda_20b=9 then pmdc3ra3=.;

pmdc3ra4=1;  **** symptom group 4 ****;
if mda_21a=5 | mda_21b=5 | mda_21c=5 | mda_21d=5 then pmdc3ra4=5;
else if mda_21a=9 | mda_21b=9 | mda_21c=9 | mda_21d=9 then pmdc3ra4=.;

pmdc3ra5=1;  **** symptom group 5 ****;
if mda_22=5 | mda_23=5 then pmdc3ra5=5;
else if mda_22=9 | mda_23=9 then pmdc3ra5=.;

pmdc3ra6=1;  **** symptom group 6 ****;
if mda_24=5 then pmdc3ra6=5;
else if mda_24=9 then pmdc3ra6=.;

pmdc3ra7=1;  **** symptom group 7 ****;
if mda_25=5 | mda_26=5 then pmdc3ra7=5;
else if mda_25=9 | mda_26=9 then pmdc3ra7=.;

pmdc3ra8=1;  **** symptom group 8 ****;
if mda_27a=5 | mda_27b=5 | mda_28a=5 | mda_28b=5 then pmdc3ra8=5;
else if mda_27a=9 | mda_27b=9 | mda_28a=9 | mda_28b=9 then pmdc3ra8=.;

pmdc3ra9=1;  **** symptom group 9 ****;
if mda_29a=5 | mda_29b=5 | mda_29c=5 | mda_29d=5 then pmdc3ra9=5;
else if mda_29a=9 | mda_29b=9 | mda_29c=9 | mda_29d=9 then pmdc3ra9=.;


*** MD Criterion A (other time) ***;

  **** symptom group 1 ****;
if md7b=5 | md12b=5 then pmdp3ra1=5;
else if (md6a=1 & md6b=1 & md6c=1) | md7b=1 | md12b=1 then pmdp3ra1=1;

  **** symptom group 2 ****;
if md7c=5 | md12c=5 then pmdp3ra2=5;
else if (md6d=1 & md6e=1) | md7c=1 | md12c=1 then pmdp3ra2=1;

pmdp3ra3=1;  **** symptom group 3 ****;
if mdb_19a=5 | mdb_19b=5 | mdb_20a=5 | mdb_20b=5 then pmdp3ra3=5;
else if mdb_19a=9 | mdb_19b=9 | mdb_20a=9 | mdb_20b=9 then pmdp3ra3=.;

pmdp3ra4=1;  **** symptom group 4 ****;
if mdb_21a=5 | mdb_21b=5 | mdb_21c=5 | mdb_21d=5 then pmdp3ra4=5;
else if mdb_21a=9 | mdb_21b=9 | mdb_21c=9 | mdb_21d=9 then pmdp3ra4=.;

pmdp3ra5=1;  **** symptom group 5 ****;
if mdb_22=5 | mdb_23=5 then pmdp3ra5=5;
else if mdb_22=9 | mdb_23=9 then pmdp3ra5=.;

pmdp3ra6=1;  **** symptom group 6 ****;
if mdb_24=5 then pmdp3ra6=5;
else if mdb_24=9 then pmdp3ra6=.;

pmdp3ra7=1;  **** symptom group 7 ****;
if mdb_25=5 | mdb_26=5 then pmdp3ra7=5;
else if mdb_25=9 | mdb_26=9 then pmdp3ra7=.;

pmdp3ra8=1;  **** symptom group 8 ****;
if mdb_27a=5 | mdb_27b=5 | mdb_28a=5 | mdb_28b=5 then pmdp3ra8=5;
else if mdb_27a=9 | mdb_27b=9 | mdb_28a=9 | mdb_28b=9 then pmdp3ra8=.;

pmdp3ra9=1;  **** symptom group 9 ****;
if mdb_29a=5 | mdb_29b=5 | mdb_29c=5 | mdb_29d=5 then pmdp3ra9=5;
else if mdb_29a=9 | mdb_29b=9 | mdb_29c=9 | mdb_29d=9 then pmdp3ra9=.;

cur_past=0;
array rymda pmdc3ra1-pmdc3ra9;
array rymdb pmdp3ra1-pmdp3ra9;
if (pmdscr1=1 & pmdscr2 ne 1) | (pmdscr4=1 & pmdscr5 ne 1 & pmdscr6 ne 1) then
do over rymda;
 if _I_ le 2 then rymdb=rymda;
 cur_past=1;
 if _I_ gt 2 & rymda=5 then rymdb=rymda;
 if _I_ gt 2 then rymda=.;
 if pmdscr1=. then rymda=.;
end;

pmdc3rsx=0; pmdc3rmx=0;  **** symptom group counts (current) ****;
do over rymda;
 if rymda=5 then pmdc3rsx+1;
 else if rymda=. then pmdc3rmx+1;
end;

pmdc3rac=1;  **** 5+ symptom groups *****;
if pmdc3rsx ge 5 then pmdc3rac=5;
else if pmdc3rsx+pmdc3rmx ge 5 then pmdc3rac=.;

pmdc3ra=1;  *** Criterion A ***;
if pmdc3rac=5 & (pmdc3ra1=5 | pmdc3ra2=5) & mda_30b=5 then pmdc3ra=5;
else if (pmdc3rac=. & (pmdc3ra1 ne 1 | pmdc3ra2 ne 1)) | (pmdc3rac ne . &
 ((pmdc3ra1=. & pmdc3ra2 ne 5) | (pmdc3ra1 ne 5 & pmdc3ra2=.))) |
 (pmdc3rac ne 1 & (pmdc3ra1 ne 1 | pmdc3ra1 ne 1) & mda_30b=9) then pmdc3ra=.;

*** MD Criterion B ***;

pmdc3rb1=1;  **** B group 1 (alc & drug)****;
if mda_31c=5 | pmdscr4=0 then pmdc3rb1=5;
else if mda_31c=9 & pmdscr4 = . then pmdc3rb1=.;

pmdc3rb2=1;  **** B group 2 (bereavement)****;
if mda_31a=5 then pmdc3rb2=5;
else if mda_31a=9 then pmdc3rb2=.;

pmdc3rb3=1;  **** B group 3 (illness/injury)****;
if mda_31b=5 then pmdc3rb3=5;
else if mda_31b=9 then pmdc3rb3=.;

pmdc3rb=1;  *** Criterion B ***;
if pmdc3rb1=1 & pmdc3rb2=1 & pmdc3rb3=1 then pmdc3rb=5;
else if pmdc3rb1=. | pmdc3rb2=. | pmdc3rb3=. then pmdc3rb=.;

** Current Depressive Episode Diagnosis **;

pmdc3r=1;
if pmdc3ra=5 & pmdc3rb=5 then pmdc3r=5;
else if pmdc3ra=5 & pmdc3rb1=5 then pmdc3r=4; *alc&drg*;
else if pmdc3ra=5 & pmdc3rb2=5 then pmdc3r=3; *bereavement*;
else if pmdc3ra=5 & pmdc3rb3=5 then pmdc3r=2; *illness/injury*;
else if pmdc3ra=. | (pmdc3rb=. & pmdc3ra ne 1) then pmdc3r=.;

pmdp3rsx=0; pmdp3rmx=0;  **** symptom group counts (other time) ****;
do over rymdb;
 if rymdb=5 then pmdp3rsx+1;
 else if rymdb=. then pmdp3rmx+1;
end;

pmdp3rac=1;  **** 5+ symptom groups *****;
if pmdp3rsx ge 5 then pmdp3rac=5;
else if pmdp3rsx+pmdp3rmx ge 5 then pmdp3rac=.;

pmdp3ra=1;  *** Criterion A ***;
if pmdp3rac=5 & (pmdp3ra1=5 | pmdp3ra2=5) & mdb_30b=5 then pmdp3ra=5;
else if (pmdp3rac=. & (pmdp3ra1 ne 1 | pmdp3ra2 ne 1)) | (pmdp3rac ne . &
 ((pmdp3ra1=. & pmdp3ra2 ne 5) | (pmdp3ra1 ne 5 & pmdp3ra2=.))) |
 (pmdp3rac ne 1 & (pmdp3ra1 ne 1 | pmdp3ra1 ne 1) & mdb_30b=9) then pmdp3ra=.;

*** MD Criterion B ***;

pmdp3rb1=1;  **** B group 1 (alc&drug)****;
if mdb_31c=5 | pmdscr5=0 | pmdscr6=0 then pmdp3rb1=5;
else if cur_past=1 & (pmdscr4=0 | mda_31c=5) then pmdp3rb1=5;
else if mdb_31c=9 & pmdscr5=. & pmdscr6=. then pmdp3rb1=.;
else if cur_past=1 & pmdscr4=. & mda_31c=9 then pmdp3rb1=.;

pmdp3rb2=1;  **** B group 2 (bereavement)****;
if mdb_31a=5 then pmdp3rb2=5;
else if cur_past=1 & mda_31a=5 then pmdp3rb2=5;
else if mdb_31a=9 then pmdp3rb2=.;

pmdp3rb3=1;  **** B group 3 (illness/injury)****;
if mdb_31b=5 then pmdp3rb3=5;
else if cur_past=1 & mda_31b=5 then pmdp3rb3=5;
else if mdb_31b=9 then pmdp3rb3=.;

pmdp3rb=1;  *** Criterion B ***;
if pmdp3rb1=1 & pmdp3rb2=1 & pmdp3rb3=1 then pmdp3rb=5;
else if pmdp3rb1=. | pmdp3rb2=. | pmdp3rb3=. then pmdp3rb=.;

** Other Time Depressive Episode Diagnosis **;

pmdp3r=1;
if pmdp3ra=5 & pmdp3rb=5 then pmdp3r=5;
else if pmdp3ra=5 & pmdp3rb1=5 then pmdp3r=4; *alc&drug*;
else if pmdp3ra=5 & pmdp3rb2=5 then pmdp3r=3; *bereavement*;
else if pmdp3ra=5 & pmdp3rb3=5 then pmdp3r=2; *injury/illness*;
else if pmdp3ra=. | (pmdp3rb=.& pmdp3ra ne 1) then pmdp3r=.;

label pmdc3ra='Cur. Depression, Crit. A'
      pmdc3rb1='Cur. Depression,Crit. B-Alc&Drug use'
      pmdc3rb2='Cur. Depres. Crit.B-bereavement'
      pmdc3rb3='Cur. Depres. Crit.B-illness/injury'
      pmdc3rb='Cur.Depres. Crit.B-No other factors'
      pmdc3r='Cur. Depres. Diagnosis'
      pmdp3ra='Past Depression, Crit. A'
      pmdp3rb1='Past Depression,Crit. B-Alc&Drug use'
      pmdp3rb2='Past Depres. Crit.B-bereavement'
      pmdp3rb3='Past Depres. Crit.B-illness/injury'
      pmdp3rb='Past Depres. Crit.B-No other factors'
      pmdp3r='Past Depres. Diagnosis'
;
keep  pmdc3ra
      pmdc3rb1
      pmdc3rb2
      pmdc3rb3
      pmdc3rb
      pmdc3r
      pmdp3ra
      pmdp3rb1
      pmdp3rb2
      pmdp3rb3
      pmdp3rb
      pmdp3r
;

** Additional Dirty episodes of Depression**;

*** MD Criterion A **;

***symptom 1 & 2 ***;
pmdd3ra1=1; pmdd3ra2=1;  **** symptom group 1 & 2 ****;
if md35a=5 then pmdd3ra1=5 ;
else if md35a=9 then pmdd3ra1=.;
if md35a=5 then pmdd3ra2=5 ;
else if md35a=9 then pmdd3ra2=.;

pmdd3ra3=1;  **** symptom group 3 ****;
if md35c_1=5 | md35c_2=5 then pmdd3ra3=5;
else if md35c_1=9 | md35c_2=9 then pmdd3ra3=.;

pmdd3ra4=1;  **** symptom group 4 ****;
if md35c_3=5 then pmdd3ra4=5;
else if md35c_3=9 then pmdd3ra4=.;

pmdd3ra5=1;  **** symptom group 5 ****;
if md35c_4=5 | md35c_5=5 then pmdd3ra5=5;
else if md35c_4=9 | md35c_5=9 then pmdd3ra5=.;

pmdd3ra6=1;  **** symptom group 6 ****;
if md35c_6=5 then pmdd3ra6=5;
else if md35c_6=9 then pmdd3ra6=.;

pmdd3ra7=1;  **** symptom group 7 ****;
if md35c_7=5 then pmdd3ra7=5;
else if md35c_7=9 then pmdd3ra7=.;

pmdd3ra8=1;  **** symptom group 8 ****;
if md35c_8=5 | md35c_9=5 then pmdd3ra8=5;
else if md35c_8=9 | md35c_9=9 then pmdd3ra8=.;

pmdd3ra9=1;  **** symptom group 9 ****;
if md35c_10=5 then pmdd3ra9=5;
else if md35c_10=9 then pmdd3ra9=.;

array rymdd pmdd3ra1-pmdd3ra9;

pmdd3rsx=0; pmdd3rmx=0;  **** symptom group counts ****;
do over rymdd;
 if rymdd=5 then pmdd3rsx+1;
 else if rymdd=. then pmdd3rmx+1;
end;

pmdd3rac=1;  **** 5+ symptom groups *****;
if pmdd3rsx ge 5 then pmdd3rac=5;
else if pmdd3rsx+pmdd3rmx ge 5 then pmdd3rac=.;

pmdd3ra=1;  *** Criterion A ***;
if pmdd3rac=5 & (pmdd3ra1=5 | pmdd3ra2=5) & md35d=5 then pmdd3ra=5;
else if (pmdd3rac=. & (pmdd3ra1 ne 1 | pmdd3ra2 ne 1))
 | md35d=9 then pmdd3ra=.;

*** Criterion B not assessed - It is dirty ***;

**** MD - Dirty diagnoses **** ;

pmdd3r=pmdd3ra;


** Other clean episodes of Depression**;

*** MD Criterion A **;

***symptom 1 & 2 ***;
pmdo3ra1=1; pmdl3ra2=1;  **** symptom group 1 & 2 ****;
if md36a=5 then pmdo3ra1=5 ;
else if md36a=9 then pmdo3ra1=.;
if md36a=5 then pmdo3ra2=5;
else if md36a=9 then pmdo3ra2=.;

pmdo3ra3=1;  **** symptom group 3 ****;
if md36c_1=5 | md36c_2=5 then pmdo3ra3=5;
else if md36c_1=9 | md36c_2=9 then pmdo3ra3=.;

pmdo3ra4=1;  **** symptom group 4 ****;
if md36c_3=5 then pmdo3ra4=5;
else if md36c_3=9 then pmdo3ra4=.;

pmdo3ra5=1;  **** symptom group 5 ****;
if md36c_4=5 | md36c_5=5 then pmdo3ra5=5;
else if md36c_4=9 | md36c_5=9 then pmdo3ra5=.;

pmdo3ra6=1;  **** symptom group 6 ****;
if md36c_6=5 then pmdo3ra6=5;
else if md36c_6=9 then pmdo3ra6=.;

pmdo3ra7=1;  **** symptom group 7 ****;
if md36c_7=5 then pmdo3ra7=5;
else if md36c_7=9 then pmdo3ra7=.;

pmdo3ra8=1;  **** symptom group 8 ****;
if md36c_8=5 | md36c_9=5 then pmdo3ra8=5;
else if md36c_8=9 | md36c_9=9 then pmdo3ra8=.;

pmdo3ra9=1;  **** symptom group 9 ****;
if md36c_10=5 then pmdo3ra9=5;
else if md36c_10=9 then pmdo3ra9=.;

array rymdo pmdo3ra1-pmdo3ra9;

pmdo3rsx=0; pmdo3rmx=0;  **** symptom group counts ****;
do over rymdo;
 if rymdo=5 then pmdo3rsx+1;
 else if rymdo=. then pmdo3rmx+1;
end;

pmdo3rac=1;  **** 5+ symptom groups *****;
if pmdo3rsx ge 5 then pmdo3rac=5;
else if pmdo3rsx+pmdo3rmx ge 5 then pmdo3rac=.;

pmdo3ra=1;  *** Criterion A ***;
if pmdo3rac=5 & (pmdo3ra1=5 | pmdo3ra2=5) & md36d=5 then pmdo3ra=5;
else if (pmdo3rac=. & (pmdo3ra1 ne 1 | pmdo3ra2 ne 1 ))
 | md36d=9 then pmdo3ra=.;

*** Criterion B not assessed - It is clean ***;

****Other MD - diagnoses **** ;

pmdo3r=pmdo3ra;

label pmdd3ra='Additional Dirty MD - Criterion A'
      pmdo3ra='Other clean MD - Criterion A'
      pmdd3r='MD Diagnosis - Dirty'
      pmdo3r='Other MD clean Diagnosis'
;
keep  pmdd3ra
      pmdo3ra
      pmdd3r
      pmdo3r
;


%include './heic.include';
   array heic_ry(8) activ time discip roles rules peers sibling heic;
   array pheic_ry(8) pactiv ptime pdiscip proles
                    prules ppeers psibling pheic;
   do i=1 to 8; pheic_ry(i)=heic_ry(i);end;
   keep pactiv ptime pdiscip proles prules ppeers psibling pheic;
   label
      pactiv='School and other activities'
      ptime='Parents time spent with child'
      pdiscip='Discipline'
      proles='Adults as role models'
      prules='Family rules'
      ppeers='Peer relations'
      psibling='Sibling network'
      pheic='Total score on Home environment'
          ;
%include './sarah.include';
      psar_ev=sarahev;
      psar_now=sarahnow;
      label psar_now='sarah score,now';
      label psar_ev='sarah score,ever';
      keep psar_ev psar_now;
run;
