***** csep.sas ***** (3/27/95 rev);

* C-SSAGA DSM-III-R: Separation Anxiety Disorder *;

** Sep Criterion A **;

array rysaa sa1-sa3 sa6 sa9 sa10;
array rysab #sa3ra1-#sa3ra3 #sa3ra5-#sa3ra7;

do over rysaa;  *** symptom groups 1-3,5-7 ***;
 rysab=rysaa;
 if rysaa=9 then rysab=.;
end;

#sa3ra4=1;  *** symptom group 4 ***;
if sa4=5 | sa5=5 then #sa3ra4=5;
else if sa4=3 | sa5=3 then #sa3ra4=3;
else if sa4=9 | sa5=9 then #sa3ra4=.;

#sa3ra8=1;  *** symptom group 8 ***;
if sa11a=5 | sa11b=5 then #sa3ra8=5;
else if sa11a=3 | sa11b=3 then #sa3ra8=3;
else if sa11a=9 | sa11b=9 then #sa3ra8=.;

#sa3ra9=1;  *** symptom group 9 ***;
if sa7=5 | sa8a=5 | sa8b=5 then #sa3ra9=5;
else if sa7=3 | sa8a=3 | sa8b=3 then #sa3ra9=3;
else if sa7=9 | sa8a=9 | sa8b=9 then #sa3ra9=.;

*** Sep screener 1 ***;
if sa1 ge 3 | sa2 ge 3 | sa3 ge 3 | sa4 ge 3 | sa5 ge 3 then #sascr1=1;
else if sa1=1 & sa2=1 & sa3=1 & sa4=1 & sa5=1 then #sascr1=0;

if #sascr1=. then do;
 #sa3ra5=.; #sa3ra6=.; #sa3ra7=.; #sa3ra8=.; #sa3ra9=.;
end;

#sa3rsx5=0; #sa3rsx3=0; #sa3ramx=0;  *** symptom group counts ***;
array rysac #sa3ra1-#sa3ra9;
do over rysac;
 if rysac=5 then #sa3rsx5+1;
 else if rysac=. then #sa3ramx+1;
 if rysac ge 3 then #sa3rsx3+1;
end;

  **Diagnosis without duration and clustering
       - just symptom count > 3**;
#sa3ra5=1; #sa3ra3=1;  ** Criterion A **;
if #sa3rsx5 ge 3 then #sa3ra5=5;
else if #sa3rsx5+#sa3ramx ge 3 then #sa3ra5=.;
if #sa3rsx3 ge 3 then #sa3ra3=5;
else if #sa3rsx3+#sa3ramx ge 3 then #sa3ra3=.;

** Criterion B **;

#sa3rb=1;
if sa13=5 then #sa3rb=5;
else if sa13=9 | #sa3ramx ge 1 then #sa3rb=.;

** Criterion C **;

#sa3rc=1;
if (1 le sa12a le 17)|(1 le dm3 lt 18) then #sa3rc=5;
else if dm3=-9 | (dm3 ge 18 & sa12a=-9) then #sa3rc=.;

** Criterion D not assessed **;

* Separation Anxiety Diagnosis *;

#sa3r=1;
if #sa3ra5=5 & #sa3rb=5 & #sa3rc=5 then #sa3r=5;
else if #sa3ra3=5 & #sa3rb=5 & #sa3rc=5 then #sa3r=3;
else if #sascr1=0 then #sa3r=1;
else if #sa3ra3=. | ((#sa3rb=. | #sa3rc=.) & #sa3ra3 ne 1) then #sa3r=.;

label #sa3ra5='SepAnx Crit.A & Diag w/3+Symp-no alc/drg'
      #sa3ra3='SepAnx Crit.A & Diag w/3+Symp-alc/drg'
      #sa3rb='SepAnx Criterion B'
      #sa3rc='SepAnx Criterion C'
      #sa3r='Separation Anxiety Diagnosis'
;
